# Dictionaries.jl

*An alternative interface for dictionaries in Julia, for improved productivity and performance*

![Test Status](https://github.com/andyferris/Dictionaries.jl/workflows/Test/badge.svg)
[![Codecov](https://codecov.io/gh/andyferris/Dictionaries.jl/branch/master/graph/badge.svg)](https://codecov.io/gh/andyferris/Dictionaries.jl)

This package is somewhat young – new features are being added and some (low-level) interfaces may be tweaked in the future, but things should be stable enough for general usage. Contributions welcome – please submit an issue or PR!

## Motivation

The high-level goal of this package is to define a new interface for dictionary and set structures which is convenient and efficient for functional data manipulation – including operations such as non-scalar indexing, broadcasting, mapping, filtering, reducing, grouping, and so-on. While Julia comes with built-in `AbstractDict` and `AbstractSet` supertypes, the interfaces for these are not as well established or generic as for `AbstractArray`, the built-in dictionaries implement less of the common data manipulation operations compared to arrays, and it is difficult to work with them in a performant manner.

In this package we aim to devise a cohesive interface for abstract dictionaries (or associative maps), having the common supertype `AbstractDictionary`. A large part of this is working with indices (of arbitrary type) as well as convenient and efficient iteration of the containers. A second goal is to make dictionary manipulation more closely resemble array manipulation, to make it easier for users. Simultaneously, we are pushing the performance of working with dictionaries to be closer to that of working with arrays.

## Getting started

Dictionaries share the common supertype `AbstractDictionary`, and the go-to container in this package is `Dictionary` – which is a new hash-based implementation that serves as a replacement of Julia's inbuilt `Dict` type (using `hash` and `isequal` for key lookup and comparison). The three main difference to `Dict` are that it preserves the order of elements, it iterates much faster, and it iterates values rather than key-value pairs.

### Constructing dictionaries

You can construct one from a list of indices (or keys) and a list of values.

```julia
julia> dict = Dictionary(["a", "b", "c"], [1, 2, 3])
3-element Dictionary{String,Int64}
 "a" │ 1
 "b" │ 2
 "c" │ 3

julia> dict["a"]
1

julia> dict == Dictionary(("a", "b", "c"), (1, 2, 3))
true
```

The constructor also accepts any indexable container, preserving the keys and values.
```julia
julia> Dictionary(Dict("a"=>1, "b"=>2, "c"=>3))
3-element Dictionary{String,Int64}
 "c" │ 3
 "b" │ 2
 "a" │ 1
```

If you prefer, you can use the `dictionary` function to create a dictionary from something
that iterates key-value pairs (either as a `Pair` or a two-tuple, etc), somewhat like a
`Dict` constructor.

```julia
julia> dictionary(["a" => 1, "b" => 2, "c" => 3])
3-element Dictionary{String,Int64}
 "a" │ 1
 "b" │ 2
 "c" │ 3
```

One final way to construct a dictionary is using the `index` function, which accepts a
function that constructs a "key" for each element in the collection.

```julia
julia> index(first, ["Alice", "Bob", "Charlie"])
3-element Dictionary{Char,String}
 'A' │ "Alice"
 'B' │ "Bob"
 'C' │ "Charlie"
```

### Accessing dictionaries

The values of `Dictionary` are mutable, or "settable", and can be modified via `setindex!`.
However, just like for `Array`s, new indices (keys) are *never* created or rearranged this way.

```julia
julia> dict["a"] = 10
10

julia> dict
3-element Dictionary{String,Int64}
 "a" │ 10
 "b" │ 2
 "c" │ 3

julia> dict["d"] = 42
ERROR: IndexError("Dictionary does not contain index: d")
Stacktrace:
 [1] setindex!(::Dictionary{String,Int64}, ::Int64, ::String) at /home/ferris/.julia/dev/Dictionaries/src/AbstractDictionary.jl:347
 [2] top-level scope at REPL[7]:1
```

The indices of `Dictionary` are said to be "insertable" – indices can be added or removed with the `insert!` and `delete!` functions.

```
julia> insert!(dict, "d", 42)
4-element Dictionary{String,Int64}
 "a" │ 10
 "b" │ 2
 "c" │ 3
 "d" │ 42

julia> delete!(dict, "d")
3-element Dictionary{String,Int64}
 "a" │ 10
 "b" │ 2
 "c" │ 3
```

Note that `insert!` and `delete!` are precise in the sense that `insert!` will error if the index already exists, and `delete!` will error if the index does not. The `set!` function provides "upsert" functionality ("update or insert") and `unset!` is useful for removing an index that may or may not exist.

### Working with dictionaries

Dictionaries can be manipulated and transformed using a similar interface to Julia's built-in arrays. The first thing to note is that dictionaries iterate values, so it easy to perform simple analytics on the dictionary values.

```julia
julia> dict = Dictionary(["a", "b", "c"], [1, 2, 3])
3-element Dictionary{String,Int64}
 "a" │ 1
 "b" │ 2
 "c" │ 3

julia> sum(dict)
6

julia> using Statistics; mean(dict)
2.0
```

Mapping and broadcasting also function as-per arrays, preserving the indices and transforming the corresponding values.

```julia
julia> map(iseven, dict)
3-element Dictionary{String,Bool}
 "a" │ false
 "b" │ true
 "c" │ false

julia> map(*, dict, dict)
3-element Dictionary{String,Int64}
 "a" │ 1
 "b" │ 4
 "c" │ 9

julia> dict .+ 1
3-element Dictionary{String,Int64}
 "a" │ 2
 "b" │ 3
 "c" │ 4
```

There is a `mapview` function exported by [SplitApplyCombine.jl](https://github.com/JuliaData/SplitApplyCombine.jl), which is the lazy version of the above.

Filtering a dictionary also preserves the keys, dropping the remainder.

```julia
julia> filter(isodd, dict)
2-element Dictionary{String,Bool}
 "a" │ 1
 "c" │ 3
```

The `filterview` function is provided to lazily filter a dictionary, which may occasionally
be more performant when working with larger containers.

The `pairs` function allows access to both the index (key) and value when iterating.

```julia
julia> pairs(dict)
3-element Dictionaries.PairDictionary{String,Int64,Dictionary{String,Int64}}
 "a" │ "a" => 1
 "b" │ "b" => 2
 "c" │ "c" => 3

julia> map(((k,v),) -> k^v, pairs(dict))
3-element Dictionary{String,String}
 "a" │ "a"
 "b" │ "bb"
 "c" │ "ccc"
```

You can sort a dictionary by value using the `sort` function (with the usual keyword arguments).

```julia
julia> sort(dict; rev = true)
3-element Dictionary{String, Int64}
 "c" │ 3
 "b" │ 2
 "a" │ 1
```

The `sortkeys` and `sortpairs` functions allows you to sort by a dictionary's key or key-value pair, respectively, and you can do in-place sorting on supported types with `sort!`, `sortkeys!` and `sortpairs!` (although these may be slower than the out-of-place algorithms).

### Indices

The indices of a dictionary are unique, and form a set (in the mathematical sense). You can get the indices for any dictionary with the `keys` function.

```julia
julia> keys(dict)
3-element Indices{String}
 "a"
 "b"
 "c"
```

Whenever you call `keys(::AbstractDictionary)`, you always receive an `AbstractIndices` in return. 
`Indices` shares a similar implementation to `Base.Set` and can be used to perform set operations including `union`, `intersect`, `setdiff`, `symdiff`, and mutating counterparts. You can construct one from any iterable of unique elements.

```julia
julia> inds = Indices(["a", "b", "c"])
3-element Indices{String}
 "a"
 "b"
 "c"
```

You can also use the `distinct` function, which is similar to `unique` from `Base`, to construct indices where the input may not be unique.

```julia
julia> distinct([1,2,3,3])
3-element Indices{Int64}
 1
 2
 3
```

The `distinct` function may be considered as useful replacement of `unique` in many cases, as the `unique` function internally constructs a hashmap (`Set`) anyway before returning a `Vector`. However, a `Indices` iterates as fast as `Vector` and in many cases it can be useful to be able to `map` it into a dictionary. 

`Indices` are insertable, so you can use `insert!` and `delete!` (or `set!` and `unset!`) to add and remove elements.

```julia
julia> insert!(inds, "d")
4-element Indices{String}
 "a"
 "b"
 "c"
 "d"

julia> delete!(inds, "d")
3-element Indices{String}
 "a"
 "b"
 "c"
```

One crucial property of `AbstractIndices` is that they are a subtype of `AbstractDictionary` (similar to how the `keys` of an `AbstractArray` are always `AbstractArray`s). But how can a set, or indices, be a dictionary? Under `getindex`, they form a map from each element to itself.

```julia
julia> inds["b"]
"b"
```

Thus, if you iterate an `AbstractIndices` you are guaranteed never to get the same value twice, and the collection is a set. All the usual set operations like `union`, `intersect`, `setdiff` and `symdiff` are defined, as well as a newly exported predicate function `disjoint(set1, set2)` which returns `true` if `set1` and `set2` do not intersect/overlap according to an elementwise `isequal` check, and `false` otherwise (note that `Dictionaries.disjoint` is deprecated in favour of `Base.isdisjoint` in Julia 1.5 onwards).

Since all dictionaries have `keys`, even indices must have `keys` – and in this case `keys(inds::AbstractIndices) === inds`.

### Working with indices

While the above properties for `AbstractIndices` may seem a little unnecessary at first, they lead to a variety of useful behavior.

If you wish to perform an operation on each element of a set, you can simply `map` or `broadcast` some indices, and return a dictionary. These operations cannot return an `AbstractIndices` since the mapping may or may not be one-to-one, so the results may not be distinct, while `map`/`broadcast` must preserve the number of elements and the `keys`.

```julia
julia> map(uppercase, inds)
3-element Dictionary{String,String}
 "a" │ "A"
 "b" │ "B"
 "c" │ "C"

julia> inds .* "at"
3-element Dictionary{String,String}
 "a" │ "aat"
 "b" │ "bat"
 "c" │ "cat"
```

You can filter indices.

```julia
julia> filter(in(["a", "b"]), inds)
2-element Indices{String}
 "a"
 "b"
```

To find the subset of dictionary indices/keys that satisfy some constraint on the values, use the `findall` function.

```julia
julia> dict
3-element Dictionary{String,Int64}
 "a" │ 1
 "b" │ 2
 "c" │ 3

julia> inds2 = findall(isodd, dict)
2-element Indices{String}
 "a"
 "c"
```

And, finally, one useful thing you can do with indices is, well, *indexing*. Non-scalar indexing of dictionaries is a little more complicated than that of arrays, since there is an ambiguity on whether the indexer is a *single* index or a collection of indices (for arrays, the scalar indices are integers (or `CartesianIndex`es) so this ambiguity is less of a problem). The [Indexing.jl](https://github.com/andyferris/Indexing.jl) provides the `getindices` function to return a container with the same indices as the indexer, and this is re-exported here.

```julia
julia> getindices(dict, inds2)
2-element Dictionary{String,Int64}
 "a" │ 1
 "c" │ 3
```

It has [been suggested](https://github.com/JuliaLang/julia/issues/30845) to make the syntax `dict.[inds2]` available in Julia in the future for unambiguous non-scalar indexing. 

Lazy non-scalar indexing may be achieved, as usual, with the `view` function.

```julia
julia> view(dict, inds2)
2-element DictionaryView{String,Int64,Indices{String},Dictionary{String,Int64}}
 "a" │ 1
 "c" │ 3
```

Boolean or "logical" indexing is also ambiguous with scalar and non-scalar indexing. Luckily, the `findall` function is a convenient way to convert a Boolean-valued dictionary into indices, which we can use with `getindices`:

```julia
julia> isodd.(dict)
3-element Dictionary{String,Bool}
 "a" │ true
 "b" │ false
 "c" │ true

julia> getindices(dict, findall(isodd.(dict)))
2-element Dictionary{String,Int64}
 "a" │ 1
 "c" │ 3
```

(Who knows – maybe we need syntax for this, too?)

### Other dictionary types

The `UnorderedDictionary` container is another hash-based dictionary, but unlike `Dictionary` the order of elements is not defined. Internally, it has a slightly optimized version of the implementation of the `Dict` built into Julia, but supports the `AbstractDictionary` interface as well as tokens. It can be a bit faster than `Dictionary` for workloads focussing on insertion and deletion – such as when building a cache where iteration order is unimportant and speed of random lookup and insertion is more important.

The `ArrayDictionary` container is a simple, iteration-based dictionary that may be faster for smaller collections. It's `keys` are the corresponding `ArrayIndices` type. By default these contain `Vector`s which support mutation, insertion and tokenization, but they can contain other arrays such as [`SVector`](https://github.com/JuliaArrays/StaticArrays.jl)s (which make for good statically-sized dictionaries, with similarities with `Base.ImmutableDict`).

There is a `FillDictionary` container which lazily maps every key to the same value (only keeping a single copy of the value).

Indices that are based on sort ordering instead of hashing (both in a dense sorted form and as a B-tree or similar) are also planned.

### Factories for dictionary creation

#### Dictionaries with the same indices

The `similar` function is used to create a dictionary with defined indices, but undefined values that can be set/mutated after the fact. `similar(dict, T)` creates a container with the same indices as `dict` and, optionally, a new element type.

```julia
julia> similar(dict, Vector{Int})
3-element Dictionary{String,Array{Int64,1}}
 "a" │ #undef
 "b" │ #undef
 "c" │ #undef
```

The behaviour is the same if `dict` is an `AbstractIndices` – you always get a dictionary with settable/mutable elements. Preserving the indices using `similar` and setting the values provides a huge performance advantage compared to iteratively constructing a new dictionary via insertion (see the bottom of this README).

On the other hand, values can be initialized with the `fill(value, dict)` function.

```julia
julia> fill(42, dict)
3-element Dictionary{String,Int64}
 "a" │ 42
 "b" │ 42
 "c" │ 42
```

The `fill` function can optionally define a wider type than the value, helpful for if you want to assign a default value like `missing` but allow this to be updated later.

```julia
julia> fill(missing, dict, Union{Missing, Int64})
3-element Dictionary{String,Union{Missing, Int64}}
 "a" │ missing
 "b" │ missing
 "c" │ missing
```

Functions `zeros`, `ones`, `falses` and `trues` are defined as a handy alternative to the above in common cases, as are `rand` and `randn`.

```julia
julia> zeros(dict)
3-element Dictionary{String,Float64}
 "a" │ 0.0
 "b" │ 0.0
 "c" │ 0.0

julia> zeros(UInt8, dict)
3-element Dictionary{String,UInt8}
 "a" │ 0x00
 "b" │ 0x00
 "c" │ 0x00
```

Note that the *indices* of the output are not guaranteed to be mutable/insertable – in fact, in the current implementation inserting or deleting indices to the output of the above can corrupt the input container (Julia suffers similar restrictions with `AbstractArray`s with mutable indices, for example changing the size of the indices of a `SubArray` can lead to corruption and segfaults). For efficiency, the indices (the keys and hashmap, etc) are often not copied when creating a new dictionary – instead multiple references may be held to the same indices. This also holds true for the output of `map`, `broadcast`, `getindices`, `similar`, `zeros`, `ones`, `falses` and `trues`. If you want a new container with indices you can insert, by sure to `copy` the indices first, or use `empty` instead.

#### Empty, insertable dictionaries indices

The `empty` function will create an insertable container which is "similar" to the input, with zero elements and the specified type for the indices and values.

 * `empty(x, I)` constructs an empty indices (whether `x` is a dictionary or indices).
 * `empty(x, I, T)` constructs an empty dictionary (whether `x` is a dictionary or indices).
 * `empty(x)` constructs an empty container – indices if `x` are indices, and a dictionary if `x` is a dictionary.

## Types, interfaces and traits

This section will be of primary interest to developers who wish to understand the internals to *Dictionaries.jl* or create their own custom dictionary types.

### `AbstractDictionary`

The common supertype to this package is `AbstractDictionary{I, T}`, which models an indexable container. To implement a simple `AbstractDictionary` all you need to implement is:

 * `getindex(::AbstractDictionary{I, T}, ::I) --> T`
 * `keys(::AbstractDictionary{I, T}) --> AbstractIndices{I}`
 * `isassigned(::AbstractDictionary{I, T}, ::I) --> Bool`

### `AbstractIndices`

Indexable containers in Julia have `keys`, which form a "set" in the mathematic sense of a collection of distinct elements. The `keys` of an `AbstractDictionary{I, T}` must have type `AbstractIndices{I}`. These form a set because no two elements in an `AbstractIndices` can be `isequal`. To implement a simple index type, you need to provide:

 * The `iterate` protocol, returning unique values of type `I`.
 * `in`, such that `in(i, indices)` implies there is an element of `indices` which `isequal` to `i`.
 * Either `length`, or override `IteratorSize` to `SizeUnknown`.

Indices themselves are also dictionaries (much like the indices of `AbstractArray`s are also `AbstractArray`s), and we have the subtyping relationship `AbstractIndices{I} <: AbstractDictionary{I, I}`. Indexing an `AbstractIndices` is always an identity operation, such that `indices[i] === i`. The `keys` function is also an identity operation on indices (`keys(indices::AbstractIndices) === indices`) and therefore idempotent on dictionaries (`keys(keys(dict::AbstractDictionary)) === keys(dict)`). 

### Non-scalar indexing

Indexing an `AbstractDictionary` follows the interface provided by the *Indexing.jl* package. Since the indices of a dictionary may be of arbitrary type (including being a container such as an array or a dictionary), a function distinct to `getindex` is required to indicate non-scalar indexing.

The expression `dict3 = getindices(dict1, dict2)` follows the following simple rules:

 * The output indices match the indexer, such that `issetequal(keys(dict3), keys(dict2))`.
 * The values of `dict3` come directly from `dict1`, such that `dict3[i] === dict1[dict2[i]]` for all `i in keys(dict2)`.

Non-scalar indexing is simplified such that it is essentially `getindices(dict1, dict2) = map(i -> dict1[i], dict2)`. Note also that `getindices(dict, keys(dict))` has the same keys and values as `dict`, and is synonymous with `getindices(dict, :)`.

These rules match those for `AbstractArray`, including offset arrays. The `view` function will work similarly, and the `setindices!` function from *Indexing.jl* is already implemented (see mutation, below).

### Setting/mutating values

Many dictionary types support setting or mutating the the *values* of the elements. To support mutation, an `AbstractDictionary` should implement:

 * `issettable(::AbstractDictionary)` (returning `true`)
 * `setindex!(dict::AbstractDictionary{I, T}, ::T, ::I)` (returning `dict`)

The `issettable` function is a trait function that indicate whether an `AbstractDictionary` supports `setindex!`.

Because the idempotency property of `AbstractIndices`, indices always have immutable values – but indices can be inserted or deleted (see below).

### Insertion and deletion

If arbitrary indices can be added to or removed from an `AbstractDictionary`, one needs to implement:

 * `isinsertable(::AbstractDictionary)` (returning `true`)
 * `insert!(dict::AbstractDictionary{I, T}, ::I, ::T)` (returning `dict`)
 * `delete!(dict::AbstractDictionary{I, T}, ::I)` (returning `dict`)

The `insert!` and `delete!` always create or remove indices. Calling `insert!` when an index already exists will throw an error, as will attempting to `delete!` an index that does not exist. The function `set!` is provided as an "upsert" (update or insert) operation. Similarly, `unset!` function can be used to ensure a given index does not exist. The `get!` function works as in `Base`.

**NOTE**: `setindex!` can *never* create new indices, unlike with Julia's `AbstractDict` (and many other programming languages!). Always use `set!` to perform an "upsert" operation. This change may seem inconvenient at first, but it is similar to `AbstractArray` and how Julia differs from MATLAB in requiring one to explicitly `push!` to the end of a vector (a much less bug-prone pattern).

`AbstractIndices` may also be insertable, by implementing:

 * `isinsertable(indices)` (returning `true`)
 * `insert!(indices, i)` – add new index `i` to `indices` (will error if index exists)
 * `delete!(indices, i)` – remove an existing index `i` from `indices` (will error if index does not exist).

The `set!` and `unset!` functions behave as expected, as do `union!`, `intersect!`, `setdiff!` and `symdiff!`. Since indices iterate values, the `filter!` function can programmatically trim back a set of indices.

### Tokens

To make operations on dictionaries fast, we need to avoid unnecessary lookups into the dictionary and operations like recomputations of hashes. The token interface makes many things more efficient, especially co-iteration of `similar` containers containing identical `keys`.

#### Implementing the token interface for `AbstractIndices`

A token is a more efficient way of referring to an element of `indices`. Using tokens may
help avoid multiple index lookups for a single operation.

A tokenizable indices must implement:

 * `istokenizable(indices)` (returning `true`)
 * `tokentype(indices) --> T::Type`
 * `iteratetoken(indices, s...)` iterates the tokens of `indices`, like `iterate`
 * `gettoken(indices, i) --> (hasindex::Bool, token)`
 * `gettokenvalue(indices, token)` returning the value of the index at `token`

An `isinsertable` tokenizable indices must implement

 * `gettoken!(indices, i) --> (hadtoken::Bool, token)`
 * `deletetoken!(indices, token) --> indices`

#### Implementing the token interface for `AbstractDictionary`

An tokenizable dictionary must implement:

 * `istokenizable(dict)` (returning `true`)
 * `keys(dict)` must be `istokenizable` and share tokens with `dict`
 * `gettokenvalue(dict, token)` returning the dictionary value at `token`
 * `istokenassigned(dict, token) --> Bool` 

An `issettable` tokenizable dictionary must implement:

 * `settokenvalue!(dict, token, value)`

An `isinsertable` tokenizable dictionary must implement:

 * `gettoken!(dict, i) --> (hadtoken::Bool, token)`
 * `deletetoken!(dict, token) --> dict`

### Co-iteration implementation notes

When two-or-more dictionaries share the same tokens, co-iterating through their matching
elements becomes much more efficient. By default, the `similar` function on `Indices`
and `ArrayIndices` does not make a copy of the indices. When performing an operation such as
`map!(f, d_out, d_in)`, a check of `keys(d_out) === keys(d_in)` lets us know that the
tokens are equivalent with a constant-time operation. When this is the case, the `map!`
operation can skip lookup entirely, performing zero calls to `hash` and dealing with hash
collisions.

A quick benchmark verifies the result.

```julia
julia> using Dictionaries, BenchmarkTools

julia> d1 = Dictionary(1:10_000_000, 10_000_000:-1:1);

julia> d2 = d1 .+ 1;

julia> @btime map(+, d1, d2);
  25.712 ms (20 allocations: 76.29 MiB)
```

The `copy` below makes `keys(d1) !== keys(d2)`, disabling token co-iteration. It still uses
an iterative approach rather than using multiple hash-table lookups per element, so it's
relatively snappy.

```julia
julia> @btime map(+, d1, $(copy(d2)));
  61.615 ms (20 allocations: 76.29 MiB)
```

For a comparative baseline benchmark, we can try the same with dense vectors.

```julia
julia> v1 = collect(10_000_000:-1:1);

julia> v2 = v1 .+ 1;

julia> @btime map(+, v1, v2);
  27.587 ms (5 allocations: 76.29 MiB)
```

Here, the vector results are in line with the dictionary co-iteration!

Using insertion, instead of preserving the existing indices, is comparatively slow.

```julia
julia> function f(d1, d2)
           out = Dictionary{Int64, Int64}()
           for i in keys(d1)
               insert!(out, i, d1[i] + d2[i])
           end
           return out
       end
f (generic function with 1 method)

julia> @btime f(d1, d2);
  2.819 s (10000091 allocations: 668.42 MiB)
```

Unfortunately, insertion appears to be the idiomatic way of doing things with `Base.Dict`.
Compare the above to:

```julia
julia> dict1 = Dict(pairs(d1)); dict2 = Dict(pairs(d2));

julia> function g(d1, d2)
           out = Dict{Int64, Int64}()
           for i in keys(d1)
               out[i] = d1[i] + d2[i]
           end
           return out
       end
g (generic function with 1 method)

julia> @btime g(dict1, dict2);
  9.507 s (72 allocations: 541.17 MiB)
```

The result is similar with generators, which is possibly the easiest way of dealing with
`Base.Dict`.

```julia
julia> @btime Dict(i => dict1[i] + dict2[i] for i in keys(dict1));
  13.046 s (89996503 allocations: 2.02 GiB)
```

This represents a 500x speedup between the first example with `Dictionary` to this last
example with `Base.Dict`.

@testset "filter" begin
    inds = Indices([1,2,3,4,5])

    @test isequal(filter(iseven, inds)::Indices, Indices([2, 4]))
    @test isequal(filter(isodd, inds)::Indices, Indices([1, 3, 5]))
 
    @test isequal(filterview(iseven, inds)::Dictionaries.FilteredIndices, Indices([2, 4]))
    @test isequal(filterview(isodd, inds)::Dictionaries.FilteredIndices, Indices([1, 3, 5]))
    @test filterview(iseven, inds)[2] == 2
    @test length(filterview(iseven, inds)) == 2
    @test_throws IndexError filterview(isodd, inds)[2]
    @test in(2, filterview(iseven, inds))
    @test !in(2, filterview(isodd, inds))

    @test collect(reverse(filterview(iseven, inds))) == [4, 2]

    @test empty(filterview(iseven, inds))::Indices == Indices{Int}()
    @test keys(similar(filterview(iseven, inds))::Dictionary) == Indices{Int}([2, 4])

    filter!(iseven, inds)
    @test isequal(inds, Indices([2, 4]))

    d = Dictionary([1,2,3,4,5], [1,3,2,4,5])

    @test isequal(filter(iseven, d)::Dictionary, dictionary([3=>2, 4=>4]))
    @test isequal(filter(isodd, d)::Dictionary, dictionary([1=>1, 2=>3, 5=>5]))

    @test isequal(filterview(iseven, d)::Dictionaries.FilteredDictionary, dictionary([3=>2, 4=>4]))
    @test isequal(filterview(isodd, d)::Dictionaries.FilteredDictionary, dictionary([1=>1, 2=>3, 5=>5]))
    @test filterview(iseven, d)[3] == 2
    @test length(filterview(iseven, d)) == 2
    @test_throws IndexError filterview(isodd, d)[3]

    @test empty(filterview(iseven, d))::Dictionary{Int, Int} == Dictionary{Int, Int}()
    @test keys(similar(filterview(iseven, d))::Dictionary) == Indices{Int}([3, 4])

    filter!(iseven, d)
    @test isequal(d, Dictionary([3,4],[2,4]))

    for _ in 1:100
        @test rand(filterview(iseven, d)) in [2,4]
    end
    @test_throws ArgumentError rand(filterview(x -> false, d))
end

struct FillDictionary{I, T, Inds <: AbstractIndices{I}} <: AbstractDictionary{I, T}
    inds::Inds
    value::T
end

FillDictionary(inds, value) = FillDictionary(Indices(inds), value)

Base.keys(d::FillDictionary) = getfield(d, :inds)

@inline function Base.getindex(d::FillDictionary{I}, i::I) where I
    @boundscheck checkindex(keys(d), i)
    return getfield(d, :value)
end

Base.isassigned(d::FillDictionary{I}, i::I) where {I} = Base.isassigned(keys(d), i)

gettokenvalue(d::FillDictionary, t) = getfield(d, :value)

istokenassigned(d::FillDictionary, t) = true

mutable struct UnorderedDictionary{I,T} <: AbstractDictionary{I, T}
    indices::UnorderedIndices{I}
    values::Vector{T}

    UnorderedDictionary{I, T}(indices::UnorderedIndices{I}, values::Vector{T}, ::Nothing) where {I, T} = new(indices, values)
end

"""
    UnorderedDictionary{I, T}()

Construct an empty `UnorderedDictionary` with index type `I` and element type `T`. This type of
dictionary uses hashes for fast lookup and insertion, and is both mutable and insertable.
(See `issettable` and `isinsertable`). Unlike `Dictionary`, the order of elements
is undefined (depending on the implementation of `hash` and the history of the collection).
"""
function UnorderedDictionary{I, T}(; sizehint::Int = 16) where {I, T}
    indices = UnorderedIndices{I}(; sizehint=sizehint)
    UnorderedDictionary{I, T}(indices, Vector{T}(undef, length(indices.slots)), nothing)
end
UnorderedDictionary{I}() where {I} = UnorderedDictionary{I, Any}()
UnorderedDictionary() = UnorderedDictionary{Any}()

"""
    UnorderedDictionary{I, T}(indices, undef::UndefInitializer)

Construct a `UnorderedDictionary` with index type `I` and element type `T`. The container is
initialized with `keys` that match the values of `indices`, but the values are uninitialized.
"""
function UnorderedDictionary{I, T}(indices, ::UndefInitializer) where {I, T} 
    return UnorderedDictionary{I, T}(UnorderedIndices{I}(indices), undef)
end

function UnorderedDictionary{I, T}(h::UnorderedIndices{I}, ::UndefInitializer) where {I, T}
    return UnorderedDictionary{I, T}(h, Vector{T}(undef, length(h.slots)), nothing)
end

function UnorderedDictionary{I, T}(indices::UnorderedIndices{I}, values) where {I, T}
    vals = Vector{T}(undef, length(indices.slots))
    d = UnorderedDictionary{I, T}(indices, vals, nothing)

    @inbounds for (i, v) in zip(tokens(indices), values)
        vals[i] = v
    end

    return d
end

"""
    UnorderedDictionary(indices, values)
    UnorderedDictionary{I}(indices, values)
    UnorderedDictionary{I, T}(indices, values)

Construct a `UnorderedDictionary` with indices from `indices` and values from `values`, matched
in iteration order.
"""
function UnorderedDictionary{I, T}(indices, values) where {I, T}
    iter_size = Base.IteratorSize(indices)
    if iter_size isa Union{Base.HasLength, Base.HasShape}
        d = UnorderedDictionary{I, T}(; sizehint = length(indices)*2)
    else
        d = UnorderedDictionary{I, T}()
    end

    for (i, v) in zip(indices, values)
        insert!(d, i, v)
    end

    return d
end
function UnorderedDictionary{I}(indices, values) where {I}
    if Base.IteratorEltype(values) === Base.EltypeUnknown()
        # TODO: implement automatic widening from iterators of Base.EltypeUnknown
        values = collect(values)
    end

    return UnorderedDictionary{I, eltype(values)}(indices, values)
end

function UnorderedDictionary(indices, values)
    if Base.IteratorEltype(indices) === Base.EltypeUnknown()
        # TODO: implement automatic widening from iterators of Base.EltypeUnknown
        indices = collect(indices)
    end

    return UnorderedDictionary{eltype(indices)}(indices, values)
end

"""
UnorderedDictionary(indexable)

Construct a `UnorderedDictionary` from an indexable container `indexable` with the same `keys` and
`values`, equivalent to `UnorderedDictionary(keys(indexable), values(indexable))`. Note that
`indexable` may not be copied.
"""
UnorderedDictionary(indexable) = UnorderedDictionary(keys(indexable), values(indexable))
UnorderedDictionary{I}(indexable) where {I} = UnorderedDictionary{I}(keys(indexable), values(indexable))
UnorderedDictionary{I, T}(indexable) where {I, T} = UnorderedDictionary{I, T}(keys(indexable), values(indexable))

UnorderedDictionary{I, T}(indexable::UnorderedDictionary) where {I, T} = UnorderedDictionary{I, T,}(convert(UnorderedIndices{I}, keys(indexable)), convert(Vector{T}, indexable.values), nothing)

function Base.convert(::Type{UnorderedDictionary{I, T}}, dict::UnorderedDictionary) where {I, T}
    return UnorderedDictionary{I, T}(convert(UnorderedIndices{I}, dict.indices), convert(Vector{T}, dict.values), nothing)
end
Base.convert(::Type{T}, dict::T) where {T<:UnorderedDictionary} = dict

## Implementation

Base.keys(d::UnorderedDictionary) = d.indices
isinsertable(d::UnorderedDictionary) = true
issettable(d::UnorderedDictionary) = true

@propagate_inbounds function gettoken(d::UnorderedDictionary{I}, i::I) where {I}
    return gettoken(keys(d), i)
end

@inline function gettokenvalue(d::UnorderedDictionary, token)
    return @inbounds d.values[token]
end

function istokenassigned(d::UnorderedDictionary, token)
    return isassigned(d.values, token)
end

@inline function settokenvalue!(d::UnorderedDictionary{I, T}, token, value::T) where {I, T}
    @inbounds d.values[token] = value
    return d
end

function gettoken!(d::UnorderedDictionary{T}, key::T) where {T}
    indices = keys(d)
    (token, values) = _gettoken!(indices, d.values, key)
    if token < 0
        (token, values) = _insert!(indices, values, key, -token)
        d.values = values
        return (false, token)
    else
        d.values = values
        return (true, token)
    end 
end

function Base.copy(d::UnorderedDictionary{I, T}) where {I, T}
    return UnorderedDictionary{I, T}(copy(d.indices), copy(d.values), nothing)
end

tokenized(d::UnorderedDictionary) = d.values

function Base.empty!(d::UnorderedDictionary)
    empty!(d.indices)
    empty!(d.values)
    resize!(d.values, length(keys(d).slots))
    return d
end

function deletetoken!(d::UnorderedDictionary{I, T}, token) where {I, T}
    deletetoken!(keys(d), token)
    isbitstype(T) || ccall(:jl_arrayunset, Cvoid, (Any, UInt), d.values, token-1)
    return d
end

function Base.sizehint!(d::UnorderedDictionary, sz::Int)
    d.values = _sizehint!(d.indices, d.values, sz)
    return d
end

function Base.rehash!(d::UnorderedDictionary, newsz::Int = length(d.indices))
    _rehash!(d.indices, d.values, newsz)
    return d
end

Base.filter!(pred, d::UnorderedDictionary) = Base.unsafe_filter!(pred, d)

function Base.similar(indices::UnorderedIndices{I}, ::Type{T}) where {I, T}
    return UnorderedDictionary{I, T}(indices, undef)
end

empty_type(::Type{<:UnorderedDictionary}, ::Type{I}, ::Type{T}) where {I, T} = UnorderedDictionary{I, T}
empty_type(::Type{<:UnorderedIndices}, ::Type{I}, ::Type{T}) where {I, T} = UnorderedDictionary{I, T}

module BenchHashIndices

using BenchmarkTools
using Dictionaries
using OrderedCollections

const suite = BenchmarkGroup()

sizes = [10, 100, 1000, 10_000]
#sizes = [10_000]
cutoff = 101

function build_vector_by_insertion(n)
    out = Vector{Int}()
    for i in 1:n
        push!(out, i)
    end
    return out
end

function build_set_by_insertion(n)
    out = Set{Int}()
    for i in 1:n
        push!(out, i)
    end
    return out
end

function build_ordered_set_by_insertion(n)
    out = OrderedSet{Int}()
    for i in 1:n
        push!(out, i)
    end
    return out
end

function build_indices_by_insertion(n)
    out = ArrayIndices{Int}()
    for i in 1:n
        insert!(out, i)
    end
    return out
end

function build_hashindices_by_insertion(n)
    out = Indices{Int}()
    for i in 1:n
        insert!(out, i)
    end
    return out
end

function build_old_hashindices_by_insertion(n)
    out = UnorderedIndices{Int}()
    for i in 1:n
        insert!(out, i)
    end
    return out
end

function empty_by_deletion(set::Vector, n)
    for i in 1:n
        pop!(set)
    end
    return set
end

function empty_by_deletion(set::Set, n)
    for i in 1:n
        delete!(set, i)
    end
    return set
end

function empty_by_deletion(set::OrderedSet, n)
    for i in 1:n
        delete!(set, i)
    end
    return set
end

function empty_by_deletion(indices::AbstractIndices, n)
    for i in 1:n
        delete!(indices, i)
    end
    return indices
end

function foreachsum(set)
    count = Ref(0)
    foreach(x -> count[] += 1, set)
    return count[]
end

function all_in(set, n)
    out = 0
    for i in 1:n
        out += i in set
    end
    return out
end

function not_in(set, n)
    out = 0
    for i in n+1:2n
        out += i in set
    end
    return out
end

function basic_set_test(N)
    h = Set{Int}()
    out = true
    for i in 1:N
        push!(h, i)
    end
    for i in 1:N
        out &= i in h
    end
    for i in 1:2:N
        delete!(h, i)
    end
    for i in 1:N
        out &= (i in h) == iseven(i)
    end
    for i in 1:2:N
        push!(h, i)
    end
    for i in 1:N
        out &= i in h
    end
    for i in 1:N
        delete!(h, i)
    end
    out &= isempty(h)
    push!(h, 7)
    out &= 7 in h
    for i in 1:N
        push!(h, i)
    end
    for i in 1:N
        out &= i in h
    end
    for i in 1:2:N
        delete!(h, i)
    end
    for i in 1:N
        out &= (i in h) == iseven(i)
    end
    for i in N+1:2N
        push!(h, i)
    end
    for i in 1:2N
        out &= (i in h) == (i > N || iseven(i))
    end
    return out
end

function basic_ordered_set_test(N)
    h = OrderedSet{Int}()
    out = true
    for i in 1:N
        push!(h, i)
    end
    for i in 1:N
        out &= i in h
    end
    for i in 1:2:N
        delete!(h, i)
    end
    for i in 1:N
        out &= (i in h) == iseven(i)
    end
    for i in 1:2:N
        push!(h, i)
    end
    for i in 1:N
        out &= i in h
    end
    for i in 1:N
        delete!(h, i)
    end
    out &= isempty(h)
    push!(h, 7)
    out &= 7 in h
    for i in 1:N
        push!(h, i)
    end
    for i in 1:N
        out &= i in h
    end
    for i in 1:2:N
        delete!(h, i)
    end
    for i in 1:N
        out &= (i in h) == iseven(i)
    end
    for i in N+1:2N
        push!(h, i)
    end
    for i in 1:2N
        out &= (i in h) == (i > N || iseven(i))
    end
    return out
end

function basic_indices_test(N)
    h = ArrayIndices{Int}()
    out = true
    for i in 1:N
        insert!(h, i)
    end
    for i in 1:N
        out &= i in h
    end
    for i in 1:2:N
        delete!(h, i)
    end
    for i in 1:N
        out &= (i in h) == iseven(i)
    end
    for i in 1:2:N
        insert!(h, i)
    end
    for i in 1:N
        out &= i in h
    end
    for i in 1:N
        delete!(h, i)
    end
    out &= isempty(h)
    insert!(h, 7)
    out &= 7 in h
    for i in 1:N
        set!(h, i)
    end
    for i in 1:N
        out &= i in h
    end
    for i in 1:2:N
        delete!(h, i)
    end
    for i in 1:N
        out &= (i in h) == iseven(i)
    end
    for i in N+1:2N
        insert!(h, i)
    end
    for i in 1:2N
        out &= (i in h) == (i > N || iseven(i))
    end
    return out
end

function basic_hash_indices_test(N)
    h = Indices{Int}()
    out = true
    for i in 1:N
        insert!(h, i)
    end
    for i in 1:N
        out &= i in h
    end
    for i in 1:2:N
        delete!(h, i)
    end
    for i in 1:N
        out &= (i in h) == iseven(i)
    end
    for i in 1:2:N
        insert!(h, i)
    end
    for i in 1:N
        out &= i in h
    end
    for i in 1:N
        delete!(h, i)
    end
    out &= isempty(h)
    insert!(h, 7)
    out &= 7 in h
    for i in 1:N
        set!(h, i)
    end
    for i in 1:N
        out &= i in h
    end
    for i in 1:2:N
        delete!(h, i)
    end
    for i in 1:N
        out &= (i in h) == iseven(i)
    end
    for i in N+1:2N
        insert!(h, i)
    end
    for i in 1:2N
        out &= (i in h) == (i > N || iseven(i))
    end
    return out
end

function basic_unordered_indices_test(N)
    h = UnorderedIndices{Int}()
    out = true
    for i in 1:N
        insert!(h, i)
    end
    for i in 1:N
        out &= i in h
    end
    for i in 1:2:N
        delete!(h, i)
    end
    for i in 1:N
        out &= (i in h) == iseven(i)
    end
    for i in 1:2:N
        insert!(h, i)
    end
    for i in 1:N
        out &= i in h
    end
    for i in 1:N
        delete!(h, i)
    end
    out &= isempty(h)
    insert!(h, 7)
    out &= 7 in h
    for i in 1:N
        set!(h, i)
    end
    for i in 1:N
        out &= i in h
    end
    for i in 1:2:N
        delete!(h, i)
    end
    for i in 1:N
        out &= (i in h) == iseven(i)
    end
    for i in N+1:2N
        insert!(h, i)
    end
    for i in 1:2N
        out &= (i in h) == (i > N || iseven(i))
    end
    return out
end

pred1 = !=(5)
pred2 = ==(5)

for n in sizes
    r = 1:n
    y = n ÷ 2

    mostly_unique = rand(1:n, n)
    sorted_mostly_unique = sort(mostly_unique)
    rarely_unique = rand(1:floor(Int, sqrt(n)), n)
    sorted_rarely_unique = sort(rarely_unique)

    if n < cutoff 
        vec = collect(r)
        even_vec = collect(2:2:n)
        odd_vec = collect(1:2:n)
    
        indices = ArrayIndices(collect(r))
        even_indices = ArrayIndices(collect(2:2:n))
        odd_indices = ArrayIndices(collect(1:2:n))
    end

    set = Set(r)
    even_set = Set(2:2:n)
    odd_set = Set(1:2:n)

    ordered_set = OrderedSet(r)
    even_ordered_set = OrderedSet(2:2:n)
    odd_ordered_set = OrderedSet(1:2:n)

    hash_indices = Indices(r)
    even_hash_indices = Indices(2:2:n)
    odd_hash_indices = Indices(1:2:n)

    unordered_indices = UnorderedIndices(r)
    even_unordered_indices = UnorderedIndices(2:2:n)
    odd_unordered_indices = UnorderedIndices(1:2:n)

    suite_n = suite["$n"] = BenchmarkGroup()

    s = suite_n["constructor"] = BenchmarkGroup()
    n < cutoff && (s["Vector"] = @benchmarkable Vector($r))
    s["Set"] = @benchmarkable Set($r)
    s["OrderedSet"] = @benchmarkable OrderedSet($r)
    n < cutoff && (s["ArrayIndices"] = @benchmarkable ArrayIndices($r))
    s["Indices"] = @benchmarkable Indices($r)
    s["UnorderedIndices"] = @benchmarkable UnorderedIndices($r)

    s = suite_n["build by insertion"] = BenchmarkGroup()
    n < cutoff && (s["Vector (push!)"] = @benchmarkable build_set_by_insertion($n))
    s["Set"] = @benchmarkable build_set_by_insertion($n)
    s["OrderedSet"] = @benchmarkable build_ordered_set_by_insertion($n)
    n < cutoff && (s["Set"] = @benchmarkable build_indices_by_insertion($n))
    s["Indices"] = @benchmarkable build_hashindices_by_insertion($n)
    s["UnorderedIndices"] = @benchmarkable build_old_hashindices_by_insertion($n)

    s = suite_n["copy"] = BenchmarkGroup()
    n < cutoff && (s["Vector (pop!)"] = @benchmarkable copy($vec))
    s["Set"] = @benchmarkable copy($set)
    s["OrderedSet"] = @benchmarkable copy($ordered_set)
    n < cutoff && (s["ArrayIndices"] = @benchmarkable copy($indices))
    s["Indices"] = @benchmarkable copy($hash_indices)
    s["UnorderedIndices"] = @benchmarkable copy($unordered_indices)

    s = suite_n["copy and empty by deletion"] = BenchmarkGroup()
    n < cutoff && (s["Vector (pop!)"] = @benchmarkable empty_by_deletion(copy($vec), $n))
    s["Set"] = @benchmarkable empty_by_deletion(copy($set), $n)
    s["OrderedSet"] = @benchmarkable empty_by_deletion(copy($ordered_set), $n)
    n < cutoff && (s["ArrayIndices"] = @benchmarkable empty_by_deletion(copy($indices), $n))
    s["Indices"] = @benchmarkable empty_by_deletion(copy($hash_indices), $n)
    s["UnorderedIndices"] = @benchmarkable empty_by_deletion(copy($unordered_indices), $n)

    s = suite_n["insertion/deletion tests"] = BenchmarkGroup()
    s["Set"] = @benchmarkable basic_set_test($n)
    s["OrderedSet"] = @benchmarkable basic_ordered_set_test($n)
    n < cutoff && (s["ArrayIndices"] = @benchmarkable basic_indices_test($n))
    s["Indices"] = @benchmarkable basic_hash_indices_test($n)
    s["UnorderedIndices"] = @benchmarkable basic_unordered_indices_test($n)

    s = suite_n["insertion/deletion tests"] = BenchmarkGroup()
    s["Set"] = @benchmarkable basic_set_test($n)
    s["OrderedSet"] = @benchmarkable basic_ordered_set_test($n)
    n < cutoff && (s["ArrayIndices"] = @benchmarkable basic_indices_test($n))
    s["Indices"] = @benchmarkable basic_hash_indices_test($n)
    s["UnorderedIndices"] = @benchmarkable basic_unordered_indices_test($n)

    s = suite_n["unique/distinct (high uniqueness, unsorted)"] = BenchmarkGroup()
    s["Vector (unique)"] = @benchmarkable unique($mostly_unique)
    s["Set"] = @benchmarkable Set($mostly_unique)
    s["OrderedSet"] = @benchmarkable OrderedSet($mostly_unique)
    s["Indices (distinct)"] = @benchmarkable distinct($mostly_unique)

    s = suite_n["unique/distinct (high uniqueness, sorted)"] = BenchmarkGroup()
    s["Vector (unique)"] = @benchmarkable unique($sorted_mostly_unique)
    s["Set"] = @benchmarkable Set($sorted_mostly_unique)
    s["OrderedSet"] = @benchmarkable OrderedSet($sorted_mostly_unique)
    s["Indices"] = @benchmarkable distinct($sorted_mostly_unique)

    s = suite_n["unique/distinct (low uniqueness, unsorted)"] = BenchmarkGroup()
    s["Vector (unique)"] = @benchmarkable unique($rarely_unique)
    s["Set"] = @benchmarkable Set($rarely_unique)
    s["OrderedSet"] = @benchmarkable OrderedSet($rarely_unique)
    s["Indices"] = @benchmarkable distinct($rarely_unique)

    s = suite_n["unique/distinct (low uniqueness, sorted)"] = BenchmarkGroup()
    s["Vector (unique)"] = @benchmarkable unique($sorted_rarely_unique)
    s["Set"] = @benchmarkable Set($sorted_rarely_unique)
    s["OrderedSet"] = @benchmarkable OrderedSet($sorted_rarely_unique)
    s["Indices"] = @benchmarkable distinct($sorted_rarely_unique)

    s = suite_n["in"] = BenchmarkGroup()
    n < cutoff && (s["Vector"] = @benchmarkable all_in($vec, $n))
    s["Set"] = @benchmarkable all_in($set, $n)
    s["OrderedSet"] = @benchmarkable all_in($ordered_set, $n)
    n < cutoff && (s["ArrayIndices"] = @benchmarkable all_in($indices, $n))
    s["Indices"] = @benchmarkable all_in($hash_indices, $n)
    s["UnorderedIndices"] = @benchmarkable all_in($unordered_indices, $n)

    s = suite_n["not in"] = BenchmarkGroup()
    n < cutoff && (s["Vector"] = @benchmarkable not_in($vec, $n))
    s["Set"] = @benchmarkable not_in($set, $n)
    s["OrderedSet"] = @benchmarkable not_in($ordered_set, $n)
    n < cutoff && (s["ArrayIndices"] = @benchmarkable not_in($indices, $n))
    s["Indices"] = @benchmarkable not_in($hash_indices, $n)
    s["UnorderedIndices"] = @benchmarkable not_in($unordered_indices, $n)

    s = suite_n["count"] = BenchmarkGroup()
    n < cutoff && (s["Vector"] = @benchmarkable count(iseven, $vec))
    s["Set"] = @benchmarkable count(iseven, $set)
    s["OrderedSet"] = @benchmarkable count(iseven, $ordered_set)
    n < cutoff && (s["ArrayIndices"] = @benchmarkable count(iseven, $indices))
    s["Indices"] = @benchmarkable count(iseven, $hash_indices)
    s["UnorderedIndices"] = @benchmarkable count(iseven, $unordered_indices)

    s = suite_n["sum"] = BenchmarkGroup()
    n < cutoff && (s["Vector"] = @benchmarkable sum($vec))
    s["Set"] = @benchmarkable sum($set)
    s["OrderedSet"] = @benchmarkable sum($ordered_set)
    n < cutoff && (s["ArrayIndices"] = @benchmarkable sum($indices))
    s["Indices"] = @benchmarkable sum($hash_indices)
    s["UnorderedIndices"] = @benchmarkable sum($unordered_indices)

    s = suite_n["foreach"] = BenchmarkGroup()
    n < cutoff && (s["Vector"] = @benchmarkable foreachsum($vec))
    s["Set"] = @benchmarkable foreachsum($set)
    s["OrderedSet"] = @benchmarkable foreachsum($ordered_set)
    n < cutoff && (s["ArrayIndices"] = @benchmarkable foreachsum($indices))
    s["Indices"] = @benchmarkable foreachsum($hash_indices)
    s["UnorderedIndices"] = @benchmarkable foreachsum($unordered_indices)

    s = suite_n["filter-map-reduce via generator"] = BenchmarkGroup()
    n < cutoff && (s["Vector"] = @benchmarkable sum($(2x for x in vec if isodd(x))))
    s["Set"] = @benchmarkable sum($(2x for x in set if isodd(x)))
    s["OrderedSet"] = @benchmarkable sum($(2x for x in ordered_set if isodd(x)))
    n < cutoff && (s["ArrayIndices"] = @benchmarkable sum($(2x for x in indices if isodd(x))))
    s["Indices"] = @benchmarkable sum($(2x for x in hash_indices if isodd(x)))
    s["UnorderedIndices"] = @benchmarkable sum($(2x for x in unordered_indices if isodd(x)))

    s = suite_n["filter (most)"] = BenchmarkGroup()
    n < cutoff && (s["Vector"] = @benchmarkable filter($pred1, $vec))
    s["Set"] = @benchmarkable filter($pred1, $set)
    s["OrderedSet"] = @benchmarkable filter($pred1, $ordered_set)
    n < cutoff && (s["ArrayIndices"] = @benchmarkable filter($pred1, $indices))
    s["Indices"] = @benchmarkable filter($pred1, $hash_indices)
    s["UnorderedIndices"] = @benchmarkable filter($pred1, $unordered_indices)

    s = suite_n["filter (half)"] = BenchmarkGroup()
    n < cutoff && (s["Vector"] = @benchmarkable filter(iseven, $vec))
    s["Set"] = @benchmarkable filter(iseven, $set)
    s["OrderedSet"] = @benchmarkable filter(iseven, $ordered_set)
    n < cutoff && (s["ArrayIndices"] = @benchmarkable filter(iseven, $indices))
    s["Indices"] = @benchmarkable filter(iseven, $hash_indices)
    s["UnorderedIndices"] = @benchmarkable filter(iseven, $unordered_indices)

    s = suite_n["filter (few)"] = BenchmarkGroup()
    n < cutoff && (s["Vector"] = @benchmarkable filter($pred2, $vec))
    s["Set"] = @benchmarkable filter($pred2, $set)
    s["OrderedSet"] = @benchmarkable filter($pred2, $ordered_set)
    n < cutoff && (s["ArrayIndices"] = @benchmarkable filter($pred2, $indices))
    s["Indices"] = @benchmarkable filter($pred2, $hash_indices)
    s["UnorderedIndices"] = @benchmarkable filter($pred2, $unordered_indices)

    s = suite_n["copy and filter! (most)"] = BenchmarkGroup()
    n < cutoff && (s["Vector"] = @benchmarkable filter!($pred1, copy($vec)))
    s["Set"] = @benchmarkable filter!($pred1, copy($set))
    s["OrderedSet"] = @benchmarkable filter!($pred1, copy($ordered_set))
    n < cutoff && (s["ArrayIndices"] = @benchmarkable filter!($pred1, copy($indices)))
    s["Indices"] = @benchmarkable filter!($pred1, copy($hash_indices))
    s["UnorderedIndices"] = @benchmarkable filter!($pred1, copy($unordered_indices))

    s = suite_n["copy and filter! (half)"] = BenchmarkGroup()
    n < cutoff && (s["Vector"] = @benchmarkable filter!(iseven, copy($vec)))
    s["Set"] = @benchmarkable filter!(iseven, copy($set))
    s["OrderedSet"] = @benchmarkable filter!(iseven, copy($ordered_set))
    n < cutoff && (s["ArrayIndices"] = @benchmarkable filter!(iseven, copy($indices)))
    s["Indices"] = @benchmarkable filter!(iseven, copy($hash_indices))
    s["UnorderedIndices"] = @benchmarkable filter!(iseven, copy($unordered_indices))

    s = suite_n["copy and filter! (few)"] = BenchmarkGroup()
    n < cutoff && (s["Vector"] = @benchmarkable filter!($pred2, copy($vec)))
    s["Set"] = @benchmarkable filter!($pred2, copy($set))
    s["OrderedSet"] = @benchmarkable filter!($pred2, copy($ordered_set))
    n < cutoff && (s["ArrayIndices"] = @benchmarkable filter!($pred2, copy($indices)))
    s["Indices"] = @benchmarkable filter!($pred2, copy($hash_indices))
    s["UnorderedIndices"] = @benchmarkable filter!($pred2, copy($unordered_indices))

    s = suite_n["union"] = BenchmarkGroup()
    n < cutoff && (s["Vector"] = @benchmarkable union($even_vec, $odd_vec))
    s["Set"] = @benchmarkable union($even_set, $odd_set)
    s["OrderedSet"] = @benchmarkable union($even_ordered_set, $odd_ordered_set)
    n < cutoff && (s["ArrayIndices"] = @benchmarkable union($even_indices, $even_indices))
    s["Indices"] = @benchmarkable union($even_hash_indices, $odd_hash_indices)
    s["UnorderedIndices"] = @benchmarkable union($even_unordered_indices, $odd_unordered_indices)

    s = suite_n["intersect (empty)"] = BenchmarkGroup()
    n < cutoff && (s["Vector"] = @benchmarkable intersect($even_vec, $odd_vec))
    s["Set"] = @benchmarkable intersect($even_set, $odd_set)
    s["OrderedSet"] = @benchmarkable intersect($even_ordered_set, $odd_ordered_set)
    n < cutoff && (s["ArrayIndices"] = @benchmarkable intersect($even_indices, $odd_indices))
    s["Indices"] = @benchmarkable intersect($even_hash_indices, $odd_hash_indices)
    s["UnorderedIndices"] = @benchmarkable intersect($even_unordered_indices, $odd_unordered_indices)

    s = suite_n["intersect (half)"] = BenchmarkGroup()
    n < cutoff && (s["Vector"] = @benchmarkable intersect($even_vec, $vec))
    s["Set"] = @benchmarkable intersect($even_set, $set)
    s["OrderedSet"] = @benchmarkable intersect($even_ordered_set, $ordered_set)
    n < cutoff && (s["ArrayIndices"] = @benchmarkable intersect($even_indices, $indices))
    s["Indices"] = @benchmarkable intersect($even_hash_indices, $hash_indices)
    s["UnorderedIndices"] = @benchmarkable intersect($even_unordered_indices, $unordered_indices)

    s = suite_n["intersect (whole)"] = BenchmarkGroup()
    n < cutoff && (s["Vector"] = @benchmarkable intersect($vec, $vec))
    s["Set"] = @benchmarkable intersect($set, $set)
    s["OrderedSet"] = @benchmarkable intersect($ordered_set, $ordered_set)
    n < cutoff && (s["ArrayIndices"] = @benchmarkable intersect($indices, $indices))
    s["Indices"] = @benchmarkable intersect($hash_indices, $hash_indices)
    s["UnorderedIndices"] = @benchmarkable intersect($unordered_indices, $unordered_indices)

    s = suite_n["setdiff (whole)"] = BenchmarkGroup()
    n < cutoff && (s["Vector"] = @benchmarkable setdiff($even_vec, $odd_vec))
    s["Set"] = @benchmarkable setdiff($even_set, $odd_set)
    s["OrderedSet"] = @benchmarkable setdiff($even_ordered_set, $odd_ordered_set)
    n < cutoff && (s["ArrayIndices"] = @benchmarkable setdiff($even_indices, $odd_indices))
    s["Indices"] = @benchmarkable setdiff($even_hash_indices, $odd_hash_indices)
    s["UnorderedIndices"] = @benchmarkable setdiff($even_unordered_indices, $odd_unordered_indices)

    s = suite_n["setdiff (half)"] = BenchmarkGroup()
    n < cutoff && (s["Vector"] = @benchmarkable setdiff($even_vec, $vec))
    s["Set"] = @benchmarkable setdiff($even_set, $set)
    s["OrderedSet"] = @benchmarkable setdiff($even_ordered_set, $ordered_set)
    n < cutoff && (s["ArrayIndices"] = @benchmarkable setdiff($even_indices, $indices))
    s["Indices"] = @benchmarkable setdiff($even_hash_indices, $hash_indices)
    s["UnorderedIndices"] = @benchmarkable setdiff($even_unordered_indices, $unordered_indices)

    s = suite_n["setdiff (empty)"] = BenchmarkGroup()
    n < cutoff && (s["Vector"] = @benchmarkable setdiff($vec, $vec))
    s["Set"] = @benchmarkable setdiff($set, $set)
    s["OrderedSet"] = @benchmarkable setdiff($ordered_set, $ordered_set)
    n < cutoff && (s["ArrayIndices"] = @benchmarkable setdiff($indices, $indices))
    s["Indices"] = @benchmarkable setdiff($hash_indices, $hash_indices)
    s["UnorderedIndices"] = @benchmarkable setdiff($unordered_indices, $unordered_indices)

    s = suite_n["symdiff (whole)"] = BenchmarkGroup()
    n < cutoff && (s["Vector"] = @benchmarkable symdiff($even_vec, $odd_vec))
    s["Set"] = @benchmarkable symdiff($even_set, $odd_set)
    s["OrderedSet"] = @benchmarkable symdiff($even_ordered_set, $odd_ordered_set)
    n < cutoff && (s["ArrayIndices"] = @benchmarkable symdiff($even_indices, $odd_indices))
    s["Indices"] = @benchmarkable symdiff($even_hash_indices, $odd_hash_indices)
    s["UnorderedIndices"] = @benchmarkable symdiff($even_unordered_indices, $odd_unordered_indices)

    s = suite_n["symdiff (left half)"] = BenchmarkGroup()
    n < cutoff && (s["Vector"] = @benchmarkable symdiff($vec, $odd_vec))
    s["Set"] = @benchmarkable symdiff($set, $odd_set)
    s["OrderedSet"] = @benchmarkable symdiff($ordered_set, $odd_ordered_set)
    n < cutoff && (s["ArrayIndices"] = @benchmarkable symdiff($indices, $odd_indices))
    s["Indices"] = @benchmarkable symdiff($hash_indices, $odd_hash_indices)
    s["UnorderedIndices"] = @benchmarkable symdiff($unordered_indices, $odd_unordered_indices)

    s = suite_n["symdiff (right half)"] = BenchmarkGroup()
    n < cutoff && (s["Vector"] = @benchmarkable symdiff($even_vec, $vec))
    s["Set"] = @benchmarkable symdiff($even_set, $set)
    s["OrderedSet"] = @benchmarkable symdiff($even_ordered_set, $ordered_set)
    n < cutoff && (s["ArrayIndices"] = @benchmarkable symdiff($even_indices, $indices))
    s["Indices"] = @benchmarkable symdiff($even_hash_indices, $hash_indices)
    s["UnorderedIndices"] = @benchmarkable symdiff($even_unordered_indices, $unordered_indices)

    s = suite_n["symdiff (empty)"] = BenchmarkGroup()
    n < cutoff && (s["Vector"] = @benchmarkable symdiff($vec, $vec))
    s["Set"] = @benchmarkable symdiff($set, $set)
    s["OrderedSet"] = @benchmarkable symdiff($ordered_set, $ordered_set)
    n < cutoff && (s["ArrayIndices"] = @benchmarkable symdiff($indices, $indices))
    s["Indices"] = @benchmarkable symdiff($hash_indices, $hash_indices)
    s["UnorderedIndices"] = @benchmarkable symdiff($unordered_indices, $unordered_indices)
end

end  # module

BenchHashIndices.suite

function Base.foreach(f, d::AbstractDictionary, d2::AbstractDictionary, ds::AbstractDictionary...)
    if sharetokens(d, d2, ds...)
        @inbounds for t in tokens(d)
            f(gettokenvalue(d, t), gettokenvalue(d2, t), map(x -> @inbounds(gettokenvalue(x, t)), ds)...)
        end
    else
       @boundscheck if !isequal(keys(d), keys(d2)) || any(dict -> !isequal(keys(d), keys(dict)), ds)
            throw(IndexError("Indices do not match"))
       end
       @inbounds for xs in zip(d, d2, ds...)
            f(xs...)
       end
    end
    return nothing
end

# (avoid an _apply for the two-input case)
function Base.foreach(f, d::AbstractDictionary, d2::AbstractDictionary)
    if sharetokens(d, d2)
        @inbounds for t in tokens(d)
            f(gettokenvalue(d, t), gettokenvalue(d2, t))
        end
    else
       @boundscheck if !isequal(keys(d), keys(d2))
            throw(IndexError("Indices do not match"))
       end
       @inbounds for (x, x2) in zip(d, d2)
            f(x, x2)
       end
    end
    return nothing
end

function Base.foreach(f, d::AbstractDictionary)
    @inbounds for x in d
        f(x)
    end
    return nothing
end

## A simple token-based interface

"""
    istokenizable(indices::AbstractIndices)

Return `true` if the indices `indices` obeys the token interface, or `false` otherwise.

A token is a more efficient way of referring to an element of `indices`. Using tokens may
help avoid multiple index lookups for a single operation.

A tokenizable indices must implement:

 * `tokentype(indices) --> T::Type`
 * `iteratetoken(indices, s...)` iterates the tokens of `indices`, like `iterate`
 * `gettoken(indices, i) --> (hasindex::Bool, token)`
 * `gettokenvalue(indices, token)` returning the value of the index at `token`

An `isinsertable` tokenizable indices must implement

 * `gettoken!(indices, i) --> (hadtoken::Bool, token)`
 * `deletetoken!(indices, token) --> indices`

    istokenizable(dict::AbstractDictionary)

Return `true` if the dictionary `dict` obeys the token interface, or `false` otherwise.

A token is a more efficient way of referring to an element of `dict`. Using tokens may
help avoid multiple index lookups for a single operation.

An tokenizable dictionary must implement:

 * `keys(dict)` must be `istokenizable` and share tokens with `dict`
 * `gettokenvalue(dict, token)` returning the dictionary value at `token`
 * `istokenassigned(dict, token) --> Bool` 

An `issettable` tokenizable dictionary must implement:

 * `settokenvalue!(dict, token)`

An `isinsertable` tokenizable dictionary must implement:

 * `gettoken!(dict, i) --> (hadtoken::Bool, token)`
 * `deletetoken!(dict, token) --> dict`
"""
istokenizable(d::AbstractIndices) = false
istokenizable(d::AbstractDictionary) = istokenizable(keys(d))

"""
    tokentype(dict)

Return the type of the tokens retrieved via `gettoken` for dictionary `dict`, for
dictionaries that are `istokenizable`.
"""
tokentype(d::AbstractDictionary) = tokentype(keys(d))

function tokentype(inds::AbstractIndices)
    if istokenizable(inds)
        error("`tokentype` needs to be defined for tokenizable indices: $(typeof(inds))")
    else
        error("Indices are not tokenizable: $(typeof(inds))")
    end
end

"""
    IndicesTokens(indices)

Return a dictionary mapping from `i ∈ indices` to a valid token.
""" 
struct IndicesTokens{I, T, Parent <: AbstractIndices{I}} <: AbstractDictionary{I, T}
    parent::Parent
end

IndicesTokens(indices::AbstractIndices{I}) where {I} = IndicesTokens{I}(indices)
IndicesTokens{I}(indices::AbstractIndices{I}) where {I} = IndicesTokens{I, tokentype(indices)}(indices)

Base.parent(ts::IndicesTokens) = getfield(ts, :parent)

Base.keys(ts::IndicesTokens) = parent(ts)

# These containers are obviously tokenizable (but never settable or insertable)
istokenizable(::IndicesTokens) = true
tokentype(::IndicesTokens{<:Any, T}) where {T} = T
tokens(ts::IndicesTokens) = ts
istokenassigned(ts::IndicesTokens, t) = istokenassigned(parent(ts), t)
@propagate_inbounds iteratetoken(ts::IndicesTokens, s...) = iteratetoken(parent(ts), s...)
@propagate_inbounds gettoken(ts::IndicesTokens, i) = gettoken(parent(ts), i)
gettokenvalue(ts::IndicesTokens, t) = t

Base.IteratorSize(ts::IndicesTokens) = Base.IteratorSize(parent(ts))
Base.length(ts::IndicesTokens) = length(parent(ts))

"""
    tokens(dict::AbstractDictionary)

Return a new dictionary mapping from the `keys` of `dict` to a "token". The token can be
used to fetch a value with `gettokenvalue`. For mutable containers, the token can be used to
overwrite a value with `settokenvalue!`.
"""
@inline tokens(d::AbstractDictionary) = tokens(keys(d))
@inline function tokens(i::AbstractIndices{I}) where {I}
    if istokenizable(i)
        return IndicesTokens{I, tokentype(i), typeof(i)}(i)
    else
        return i
    end
end


"""
    Tokenized(dict)

Return an indexable container mapping from the `token ∈ tokens(dict)` to the values of
`dict`. 
"""
struct Tokenized{Parent <: AbstractDictionary}
    parent::Parent
end

Base.parent(dict::Tokenized) = getfield(dict, :parent)

@propagate_inbounds function Base.getindex(d::Tokenized, t)
    return gettoken(parent(d), t)
end

function Base.isassigned(d::Tokenized, t)
    return istokenassigned(parent(d), t)
end

@propagate_inbounds function Base.setindex!(d::Tokenized, value, t)
    return settokenvalue!(parent(d), t, value)
end


"""
    tokenized(dict::AbstractDictionary)

For `istokenizable` dictionary `dict`, return a container that supports
`getindex(dict, token)` and `isassigned(dict, token)`, where `token ∈ tokens(dict)`.

If `issettable(dict)` then the result should also support `setindex!(dict, value, token)`.

Note: the output is not necessarily an `AbstractDictionary`.
"""
function tokenized(d::AbstractDictionary)
    if istokenizable(d)
        return Tokenized{tokentype(d), eltype(d), typeof(d)}(d)
    else
        return d
    end
end


"""
    gettoken(dict, i)

Return the tuple `(hasindex, token)`, where `hasindex` is `true` if `i` exists in `dict`.
The `token` can be used to retrieve a value using the `gettokenvalue` function. You can
check if a token is assigned to a valid Julia object (i.e. not `#undef`) via
`istokenassigned`.

Settable (i.e. mutable) dictionaries allow you to set a corresponding value via the
`settokenvalue!` function (see the `issettable` trait).

Insertable dictionaries provide the `gettoken!` function (see the `isinsertable` trait).
"""
@propagate_inbounds function gettoken(inds::AbstractIndices, i)
    if istokenizable(inds)
        error("gettoken needs to be defined for tokenizable indices: $(typeof(inds))")
    end

    @boundscheck if i ∉ inds
        return (false, i)
    end
    return (true, i)
end

@propagate_inbounds function gettoken(d::AbstractDictionary, i)
    return gettoken(keys(d), i)
end

@propagate_inbounds function gettokenvalue(d::AbstractDictionary, token)
    if istokenizable(d)
        error("gettokenvalue needs to be defined for tokenizable $(d isa AbstractIndices ? "indices" : "dictionary"): $(typeof(d))")
    end

    return d[token]
end

@propagate_inbounds function istokenassigned(d::AbstractDictionary, token)
    if istokenizable(d)
        error("istokenassigned needs to be defined for tokenizable $(d isa AbstractIndices ? "indices" : "dictionary"): $(typeof(d))")
    end

    return isassigned(d, token)
end

function istokenassigned(::AbstractIndices, token)
    return true  # We are checking that given a valid token a value exists
end

@propagate_inbounds function settokenvalue!(d::AbstractDictionary{<:Any,T}, t, value) where {T}
    return settokenvalue!(d, t, convert(T, value))
end

@propagate_inbounds function settokenvalue!(d::AbstractDictionary{<:Any,T}, i, value::T) where {T}
    if !issettable(d)
        error("Cannot mutate values of dictionary: $(typeof(d))")
    end
    if istokenizable(d)
        error("settokenvalue! needs to be defined for settable, tokenizable dictionary: $(typeof(d))")
    end

    return d[i] = value
end

## Check if we can do fast mutual iteration over multiple containers

# I guess someone could overload this method if they can check this faster than O(N),
# but more precise than ===

"""
    sharetokens(dict1, dict2)

Return `true` if `dict1` and `dict2` obviously share tokens, using a test which can be
performed quickly (e.g. O(1) rather than O(N)). Return `false` otherwise.

Note: the test may not be precise, this defaults to `tokens(dict1) === tokens(dict2)`.
"""
sharetokens(i1::AbstractIndices, i2::AbstractIndices) = istokenizable(i1) && i1 === i2
sharetokens(d1, d2) = sharetokens(keys(d1), keys(d2))
sharetokens(d1, d2, ds...) = sharetokens(d1, d2) && sharetokens(d1, ds...)

@testset "map" begin
    function _mapview(f, d::AbstractDictionary)
        I = keytype(d)
        T = Core.Compiler.return_type(f, Tuple{eltype(d)})
        
        return MappedDictionary{I, T, typeof(f), Tuple{typeof(d)}}(f, (d,))
    end

    i = Indices([1,2,3,4,5])

    @test map(iseven, i)::Dictionary == dictionary([1=>false, 2=>true, 3=>false, 4=>true, 5=>false])
    @test map(isodd, i)::Dictionary == dictionary([1=>true, 2=>false, 3=>true, 4=>false, 5=>true])
 
    @test _mapview(iseven, i)::Dictionaries.MappedDictionary == dictionary([1=>false, 2=>true, 3=>false, 4=>true, 5=>false])
    @test _mapview(isodd, i)::Dictionaries.MappedDictionary == dictionary([1=>true, 2=>false, 3=>true, 4=>false, 5=>true])

    d = Dictionary([1,2,3,4,5], [1,3,2,4,5])

    @test map(iseven, d)::Dictionary == dictionary([1=>false, 2=>false, 3=>true, 4=>true, 5=>false])
    @test map(isodd, d)::Dictionary == dictionary([1=>true, 2=>true, 3=>false, 4=>false, 5=>true])
    @test map(+, d, d)::Dictionary == dictionary([1=>2, 2=>6, 3=>4, 4=>8, 5=>10])
    @test map(+, d, d, d)::Dictionary == dictionary([1=>3, 2=>9, 3=>6, 4=>12, 5=>15])
 
    @test _mapview(iseven, d)::Dictionaries.MappedDictionary == dictionary([1=>false, 2=>false, 3=>true, 4=>true, 5=>false])
    @test _mapview(isodd, d)::Dictionaries.MappedDictionary == dictionary([1=>true, 2=>true, 3=>false, 4=>false, 5=>true])
end

@testset "findall" begin
    i = Indices([1,2,3,4,5])

    @test issetequal(findall(iseven, i)::Indices, [2, 4])
    @test issetequal(findall(map(iseven, i))::Indices, [2, 4])
    @test issetequal(findall(isodd, i)::Indices, [1, 3, 5])

    d = i .+ 1

    @test issetequal(findall(iseven, d)::Indices, [1, 3, 5])
    @test issetequal(findall(map(iseven, d))::Indices, [1, 3, 5])
    @test issetequal(findall(isodd, d)::Indices, [2, 4])
end

@testset "pairs()" begin
    h = Indices{Int64}([3,6,9])
    p = pairs(h)
    @test p isa AbstractDictionary{Int64, Pair{Int64, Int64}}
    @test p[3] == (3 => 3)
    @test p[6] == (6 => 6)
    @test p[9] == (9 => 9)
    @test length(p) == 3
end

@testset "Indices" begin
    @test Indices() isa Indices{Any}
    @test_throws IndexError Indices([1, 1])
    @test @inferred(Indices(2*x for x in 1:10))::Indices == Indices(2:2:20)
    @test @inferred(distinct(mod(x, 5) for x in 0:9))::Indices == Indices(0:4)

    h = Indices{Int64}()

    @test isinsertable(h)
    @test length(h) == 0
    @test keys(h) === h
    @test h == h
    @test h == copy(h)
    @test isempty(h)
    @test isequal(copy(h), h)
    @test_throws IndexError h[10]
    @test length(unset!(h, 10)) == 0
    io = IOBuffer(); print(io, h); @test String(take!(io)) == "{}"
    io = IOBuffer(); show(io, MIME"text/plain"(), h); @test String(take!(io)) == "0-element Indices{Int64}"
    @test_throws IndexError delete!(h, 10)

    insert!(h, 10.0)

    @test length(h) == 1
    @test keys(h) === h
    @test unique(h) === h
    @test h == h
    @test h == copy(h)
    @test !isempty(h)
    @test isequal(copy(h), h)
    @test h[10.0] == 10
    @test_throws IndexError insert!(h, 10)
    @test length(set!(h, 10)) == 1
    @test_throws IndexError insert!(h, 10)
    io = IOBuffer(); print(io, h); @test String(take!(io)) == "{10}"
    io = IOBuffer(); show(io, MIME"text/plain"(), h); @test String(take!(io)) == "1-element Indices{Int64}:\n 10"
    @test !isequal(h, empty(h))
    @test isequal(h, copy(h))
    @test isempty(empty(h))

    delete!(h, 10.0)

    @test isequal(h, Indices{Int64}())

    for i = 2:2:1000
        insert!(h, i)
    end
    @test issetequal(h, Indices(2:2:1000))
    @test all(in(i, h) == iseven(i) for i in 2:1000)
    @test !in("x", h)
    @test isempty(empty!(h))

    # set
    @test length(set!(h, 1)) == 1
    @test length(set!(h, 2, 2)) == 2
    @test length(set!(h, 3.0, 3.0)) == 3
    @test_throws ErrorException set!(h, 4, 5)
    @test_throws ErrorException setwith!(+, h, 3, 2)

    @testset "Comparison" begin
        i1 = Indices([1,2,3])
        i2 = Indices([1,2])
        i3 = Indices([1,2,3,4])
        i4 = Indices([3,2,1])

        @test isequal(i1, i1)
        @test hash(i1) == hash(copy(i1))

        @test isless(i2, i1)
        @test !isless(i1, i2)
        @test !isequal(i1, i2)
        @test hash(i1) != hash(i2)

        @test isless(i2, i1)
        @test !isless(i1, i2)
        @test !isequal(i1, i2)

        @test isless(i1, i3)
        @test !isless(i3, i1)
        @test !isequal(i1, i3)

        @test isless(i1, i4)
        @test !isless(i4, i1)
        @test !isequal(i1, i4)

        @test cmp(i1, i1) == 0
        @test cmp(i2, i1) == -1
        @test cmp(i1, i2) == 1
        @test cmp(i3, i1) == 1
        @test cmp(i1, i3) == -1
        @test cmp(i4, i1) == 1
        @test cmp(i1, i4) == -1

        i5 = Indices([1,2,missing])
        @test isequal(i5, i5)
        @test !isless(i5, i5)
        @test (i5 == i5) === missing
        @test (i5 == Indices([1,2,missing])) === missing
    end

    @testset "Adapted from Dict tests from Base" begin
        h = Indices{Int}()
        N = 10000

        for i in 1:N
            insert!(h, i)
        end
        for i in 1:N
            @test i in h
        end
        for i in 1:2:N
            delete!(h, i)
        end
        for i in 1:N
            @test (i in h) == iseven(i)
        end
        for i in 1:2:N
            insert!(h, i)
        end
        for i in 1:N
            @test i in h
        end
        for i in 1:N
            delete!(h, i)
        end
        @test isempty(h)
        insert!(h, 77)
        @test 77 in h
        for i in 1:N
            set!(h, i)
        end
        for i in 1:N
            @test i in h
        end
        for i in 1:2:N
            delete!(h, i)
        end
        for i in 1:N
            @test (i in h) == iseven(i)
        end
        for i in N+1:2N
            insert!(h, i)
        end
        for i in 1:2N
            @test (i in h) == (i > N || iseven(i))
        end
    end

    @testset "distinct" begin
        res = Indices([1,2,3])
        @test distinct(res) === res
        @test isequal(distinct([1,2,3]), res)
        @test isequal(distinct([1,2,3,1]), res)
        @test isequal(distinct([1,2,3]), res)
    end

    @testset "set logic" begin
        i1 = Indices([1,2])
        i2 = Indices([2,3])
        i3 = Indices([3,4])
        i4 = Indices([2])

        s1 = [4,5]

        @test !issetequal(i1, i2)
        @test !(i1 ⊆ i2)
        @test i4 ⊆ i1

        @test !isdisjoint(i1, i2)
        @test isdisjoint(i1, i3)

        @test isequal(union(i1, i2), Indices([1,2,3]))
        @test isequal(union(i2, i1), Indices([2,3,1]))
        @test isequal(union(i1, i3), Indices([1,2,3,4]))
        @test isequal(union(i1, s1), Indices([1,2,4,5]))

        @test isequal(intersect(i1, i2), Indices([2]))
        @test isequal(intersect(i1, i3), Indices([]))
        @test isequal(intersect(i3, s1), Indices([4]))

        @test isequal(setdiff(i1, i2), Indices([1]))
        @test isequal(setdiff(i1, i3), Indices([1, 2]))
        @test isequal(setdiff(i3, s1), Indices([3]))

        @test isequal(symdiff(i1, i2), Indices([1, 3]))
        @test isequal(symdiff(i1, i3), Indices([1, 2, 3, 4]))
        @test isequal(symdiff(i3, s1), Indices([3, 5]))
    end

    @testset "covert" begin
        i = Indices{Int32}([1,2,3])
        ai = ArrayIndices{Int32}([1,2,3])

        @test convert(AbstractIndices{Int32}, i) === i
        @test convert(AbstractIndices{Int64}, i)::Indices{Int64} == i

        @test convert(Indices{Int32}, i) === i
        @test convert(Indices{Int64}, i)::Indices{Int64} == i

        @test convert(Indices{Int32}, ai)::Indices{Int32} == i
        @test convert(Indices{Int64}, ai)::Indices{Int64} == i
    end

    @testset "rand" begin
        inds = Indices(["a", "b", "c", "d", "e"])
        for i = 1:100
            @test rand(inds) in ["a", "b", "c", "d", "e"]
        end

        delete!(inds, "b") # Test handling of deleted slots
        for i = 1:100
            @test rand(inds) in ["a", "c", "d", "e"]
        end
    end

    @testset "sort" begin
        inds = Indices([1, 5, 2])
        @test sort(inds)::Indices == Indices([1, 2, 5])
        @test sort(inds; rev=true)::Indices == Indices([5, 2, 1])

        @test sortperm(inds)::Indices == Indices([1, 2, 5])
        @test sortperm(inds; rev=true)::Indices == Indices([5, 2, 1])
        @test getindices(inds, sortperm(inds))::Indices == Indices([1, 2, 5])
        @test getindices(inds, sortperm(inds; rev=true))::Indices == Indices([5, 2, 1])

        indscopy = deepcopy(inds)
        sort!(indscopy)
        @test indscopy == Indices([1, 2, 5])

        indscopy = deepcopy(inds)
        sort!(indscopy; rev=true)
        @test indscopy == Indices([5, 2, 1])
    end

    # TODO: token interface
end

"""
    isinsertable(dict::AbstractDictionary)

Return `true` if `dict` supports the insertable interface, or `false` otherwise. The primary
functions `dict` needs to implement for the insertable interface are:

 * `insert!(dict, i, value)` - add a new `value` at index `i` (will error if index exists)
 * `delete!(dict, i)` - remove element at index `i` (will error if index does not exist)

Functions `get!`, `set!` and `unset!` are also provided for common operations where you are
not sure if an index exists or not. New insertable dictionaries are primarily generated via
the `empty` function.

See also `issettable` and `istokenizable`.
"""
isinsertable(::AbstractDictionary) = false

"""
    isinsertable(indices::AbstractIndices)

Return `true` if `indices` supports the insertable interface, or `false` otherwise. The
primary functions a map needs to implement for the insertable interface are:

 * `insert!(indices, i)` - add new index `i` to `indices` (will error if index exists)
 * `delete!(indices, i)` - remove an existing index `i` from `indices` (will error if index does not exist).

Functions `set!` and `unset!` are also provided for common operations where you are not sure
if an index exists or not. New insertable indices are primarily generated via the `empty`
function.
"""
isinsertable(::AbstractIndices) = false

safe_convert(::Type{I}, i::I) where {I} = i
function safe_convert(::Type{I}, i) where {I}
    i2 = convert(I, i)
    if !isequal(i, i2)
        throw(ArgumentError("$i is not a valid key for type $I"))
    end
    return i2
end

### Underlying token interface functions

"""
    gettoken!(dict, i)

Return the tuple `(hadindex, token)`, where `hadindex` is `true` if `i` previously existed
in `dict`, or `false` otherwise (in which case `dict` was mutated to insert a slot for the
new index `i`). The `token` may be used to retrieve a value using the `gettokenvalue` or set
a corresponding value via the `settokenvalue!`.

See also `gettoken` and `deletetoken!`.
"""
@propagate_inbounds function gettoken!(d::AbstractDictionary{I}, i) where {I}
    return gettoken!(d, convert(I, i))
end

function gettoken!(d::AbstractDictionary{I}, i::I) where {I}
    if isinsertable(d)
        error("gettoken! needs to be defined for insertable dictionary: $(typeof(d))")
    else
        error("dictionary not insertable: $(typeof(d))")
    end
end

function gettoken!(d::AbstractIndices{I}, i::I) where {I}
    if isinsertable(d)
        error("gettoken! needs to be defined for insertable indices: $(typeof(d))")
    else
        error("indices not insertable: $(typeof(d))")
    end
end

"""
    deletetoken!(dict, token)

Remove the slot of the dictionary at `token`.

See also `gettoken` and `gettoken!`.
"""
function deletetoken!(d::AbstractDictionary, token)
    if isinsertable(d)
        error("deletetoken! needs to be defined for insertable dictionary: $(typeof(d))")
    else
        error("dictionary not insertable: $(typeof(d))")
    end
end

function deletetoken!(d::AbstractIndices, token)
    if isinsertable(d)
        error("deletetoken! needs to be defined for insertable indices: $(typeof(d))")
    else
        error("indices not insertable: $(typeof(d))")
    end
end

### User-facing scalar insertion/deletion

"""
    insert!(indices::AbstractIndices, i)

Insert the new index `i` into `indices`. An error is thrown if `i` already exists.
"""
@propagate_inbounds function Base.insert!(indices::AbstractIndices{I}, i) where {I}
    i2 = safe_convert(I, i)
    return insert!(indices, i2)
end

function Base.insert!(indices::AbstractIndices{I}, i::I) where {I}
    (hadindex, token) = gettoken!(indices, i)
    if hadindex
        throw(IndexError("Indices already contains index: $i"))
    end
    return indices
end

"""
    insert!(dict::AbstractDictionary, i, value)

Insert the `value` at new index `i` into `dict`. An error is thrown if index `i` already
exists.

Hint: Use `setindex!` to update an existing value, and `set!` to perform an "upsert"
(update-or-insert) operation.
"""
function Base.insert!(d::AbstractDictionary{I}, i, value) where {I}
    i2 = safe_convert(I, i)
    return insert!(d, i2, value)
end

function Base.insert!(d::AbstractDictionary{I, T}, i::I, value) where {I, T}
    return insert!(d, i, convert(T, value))
end

function Base.insert!(d::AbstractDictionary{I, T}, i::I, value::T) where {I, T}
    (hadtoken, token) = gettoken!(d, i)
    if hadtoken
        throw(IndexError("Dictionary already contains index: $i"))
    end
    @inbounds settokenvalue!(d, token, value)
    return d
end

# Since `AbstractIndices <: AbstractDictionary` we should still obey the supertype's interface where possible...
function Base.insert!(indices::AbstractIndices{I}, i1::I, i2::I) where {I}
    if isinsertable(indices)
        if isequal(i1, i2)
            return insert!(indices, i1)
        else
            error("Attempted to set distinct key-value pair ($i1, $i2) to indices: $(typeof(indices))")
        end
    else
        error("indices not insertable: $(typeof(indices))")
    end
end

"""
    set!(dict::AbstractDictionary, i, value)

Update or insert the `value` at index `i` into `dict`. Sometimes referred to as an "upsert"
operation.

Hint: Use `setindex!` to exclusively update an existing value, and `insert!` to exclusively
insert a new value. See also `get!`.
"""
@propagate_inbounds function set!(d::AbstractDictionary{I}, i, value) where {I}
    i2 = safe_convert(I, i)
    return set!(d, i2, value)
end

function set!(d::AbstractDictionary{I, T}, i::I, value) where {I, T}
    return set!(d, i, convert(T, value))
end

function set!(d::AbstractDictionary{I, T}, i::I, value::T) where {I, T}
    (hadtoken, token) = gettoken!(d, i)
    @inbounds settokenvalue!(d, token, value)
    return d
end

# Since `AbstractIndices <: AbstractDictionary` we should still obey the supertype's interface where possible...
function set!(indices::AbstractIndices{I}, i1::I, i2::I) where {I}
    if isinsertable(indices)
        if isequal(i1, i2)
            return set!(indices, i1)
        else
            error("Attempted to set distinct key-value pair ($i1, $i2) to indices: $(typeof(indices))")
        end
    else
        error("indices not insertable: $(typeof(indices))")
    end
end

"""
    setwith!(f, dict::AbstractDictionary, i, value)

Update the value at `i` with the function `f` (`f(dict[i], value)`) or insert `value`.

Hint: Use [`mergewith!`](@ref) to merge `Dictionary`s together.
"""
function setwith!(f, d::AbstractDictionary{I}, i, value) where {I}
    (had_token, token) = gettoken!(d, i)
    new_value = had_token ? f(@inbounds(gettokenvalue(d, token)), value) : value
    @inbounds settokenvalue!(d, token, new_value)
    return d
end

setwith!(f, ::AbstractIndices, i, value) = error("`setwith!` does not work with `AbstractIndices`")

"""
    set!(indices::AbstractIndices, i)

Insert a new value `i` into `indices` if it doesn't exist, or do nothing otherwise.
"""
@propagate_inbounds function set!(indices::AbstractIndices{I}, i) where {I}
    i2 = convert(I, i)
    if !isequal(i, i2)
        throw(ArgumentError("$i is not a valid key for type $I"))
    end
    return set!(indices, i2)
end

function set!(indices::AbstractIndices{I}, i::I) where {I}
    gettoken!(indices, i)
    return indices
end

"""
    get!(dict::AbstractDictionary, i, default)

Return the value `dict[i]` if index `i` exists. Otherwise, a new index `i` is inserted and
set to `default`, which is returned.

See also `get`, `set!`.
"""
@propagate_inbounds function Base.get!(d::AbstractDictionary{I}, i, default) where {I}
    i2 = safe_convert(I, i)
    return get!(d, i2, default)
end

function Base.get!(d::AbstractDictionary{I, T}, i::I, default) where {I, T}
    return get!(d, i, convert(T, default))
end

function Base.get!(d::AbstractDictionary{I, T}, i::I, default::T) where {I, T}
    (hadindex, token) = gettoken!(d, i)
    if hadindex
        return @inbounds gettokenvalue(d, token)
    else
        @inbounds settokenvalue!(d, token, default)
        return default
    end
end

"""
    get!(f::Union{Function, Type}, dict::AbstractDictionary, i)

Return the value `dict[i]` if index `i` exists. Otherwise, a new index `i` is inserted and
set to the value `f()`, which is returned.
"""
function Base.get!(f::Callable, d::AbstractDictionary{I}, i) where {I}
    i2 = safe_convert(I, i)
    get!(f, d, i2)
end


function Base.get!(f::Callable, d::AbstractDictionary{I, T}, i::I) where {I, T}
    (hadindex, token) = gettoken!(d, i)
    if hadindex
        return @inbounds gettokenvalue(d, token)
    else
        default = convert(T, f())
        @inbounds settokenvalue!(d, token, default)
        return default
    end
end


"""
    delete!(indices::AbstractIndices, i)

Delete the index `i` from `indices`. An error is thrown if `i` does not exist.

    delete!(dict::AbstractDictionary, i)

Delete the index `i` from `dict`. An error is thrown if `i` does not exist.

See also `unset!`, `insert!`.
"""
@propagate_inbounds function Base.delete!(d::AbstractDictionary{I}, i) where {I}
    i2 = safe_convert(I, i)
    return delete!(d, i2)
end

function Base.delete!(d::AbstractDictionary{I}, i::I) where {I}
    (hasindex, token) = gettoken(d, i)
    if !hasindex
        throw(IndexError("Index doesn't exist: $i"))
    end
    @inbounds deletetoken!(d, token)
    return d
end


"""
    unset!(indices::AbstractIndices, i)

Delete the index `i` from `indices` if it exists, or do nothing otherwise.

    unset!(dict::AbstractDictionary, i)

Delete the index `i` from `dict` if it exists, or do nothing otherwise.

See also `delete!`, `set!`.
"""
@propagate_inbounds function unset!(indices::AbstractDictionary{I}, i) where {I}
    i2 = safe_convert(I, i)
    return unset!(indices, i2)
end

function unset!(d::AbstractDictionary{I}, i::I) where {I}
    (hasindex, token) = gettoken(d, i)
    if hasindex
        @inbounds deletetoken!(d, token)
    end
    return d
end

### Non-scalar insertion/deletion
function Base.merge!(d::AbstractDictionary, others::AbstractDictionary...)
    for other in others
        for (i, v) in pairs(other)
            set!(d, i, v)
        end
    end
    return d
end

function Base.mergewith!(combiner, d::AbstractDictionary, d2::AbstractDictionary)
    for (i, v) in pairs(d2)
        (hasindex, token) = gettoken!(d, i)
        if hasindex
            @inbounds settokenvalue!(d, token, combiner(gettokenvalue(d, token), v))
        else
            @inbounds settokenvalue!(d, token, v)
        end
    end
    return d
end
Base.mergewith!(combiner, d::AbstractDictionary, others::AbstractDictionary...) =
    foldl(mergewith!(combiner), others, init = d)

# TODO some kind of exclusive merge (throw on key clash like `insert!`)

# TODO: deletemany!, unsetmany! (which is setdiff! on indices)

### Indices ("sets") versions of above

function Base.union!(s1::AbstractIndices, itr)
    # Optimized to handle repeated values in `itr` - e.g. if `itr` is already sorted
    x = iterate(itr)
    if x === nothing
        return s1
    end
    (i, s) = x
    set!(s1, i)
    i_old = i
    while x !== nothing
        (i, s) = x
        !isequal(i, i_old) && set!(s1, i)
        i_old = i
        x = iterate(itr, s)
    end
    return s1
end

function Base.intersect!(s1::AbstractIndices, s2)
    return filter!(in(s2), s1)
end

function Base.setdiff!(s1::AbstractIndices, s2)
    for i in s2
        unset!(s1, i)
    end
    return s1
end

function Base.symdiff!(s1::AbstractIndices, s2)
    for i in s2
        (hastoken, token) = gettoken!(s1, i)
        if hastoken
            @inbounds deletetoken!(s1, token)
        end
    end
    return s1
end

## Filtering

# These generic implementations are gimped.

# # `filter!` is basically a programmatic version of `intersect!`.
# function Base.filter!(pred, indices::AbstractIndices)
#     for i in copy(indices)
#         if !pred(i)
#             delete!(indices, i)
#         end
#     end
#     return indices
# end

# # Dictionary version is similar
# function Base.filter!(pred, dict::AbstractDictionary)
#     for (i, v) in pairs(copy(dict))
#         if !pred(v)
#             delete!(dict, i)
#         end
#     end
#     return dict
# end

# This implementation is faster when deleting indices does not invalidate tokens/iteration,
# and is opt-in only. Works for both dictionaries and indices
function Base.unsafe_filter!(pred, dict::AbstractDictionary)
    for token in tokens(dict)
        @inbounds if !pred(gettokenvalue(dict, token))
            deletetoken!(dict, token)
        end
    end
end

# Factories for insertable Dictionaries/Indices

"""
    empty(inds::AbstractIndices, I::Type)
    empty(dict::AbstractDictionary, I::Type)

Return an empty, insertable `AbstractIndices` of element type `I` (even when the first
argument is a dictionary). The default container is `Indices{I}`, but the output may
depend on the first argument.

    empty(inds::AbstractIndices)

Return an empty, insertable `AbstractIndices` of element type `eltype(inds)`.
"""
Base.empty(inds::AbstractIndices) = empty(inds, eltype(inds))

"""
    empty(inds::AbstractIndices, I::Type, T::Type)
    empty(dict::AbstractDictionary, I::Type, T::Type)

Return an empty, insertable `AbstractDictionary` of with indices of type `I` and elements
of type `T` (even when the first argument is are indices). The default container is
`Dictionary{I}`, but the output may depend on the first argument.

    empty(dict::AbstractDictionary)

Return an empty, insertable `AbstractDictionary` with indices of type `keytype(dict)` and
elements of type `eltype(inds)`.
"""
Base.empty(d::AbstractDictionary) = empty(keys(d), keytype(d), eltype(d))

Base.empty(d::AbstractDictionary, ::Type{I}) where {I} = empty(keys(d), I)

using Test
using Dictionaries
using Indexing
using Serialization

# Simple mutable structure for `deepcopy` testing
mutable struct Foo{T}
    x::T
end

@testset "Dictionaries" begin
    include("Indices.jl")
    include("Dictionary.jl")
    include("ArrayIndices.jl")
    include("ArrayDictionary.jl")
    include("PairDictionary.jl")
    include("FillDictionary.jl")
    include("UnorderedIndices.jl")
    include("UnorderedDictionary.jl")
    include("indexing.jl")
    include("foreach.jl")
    include("map.jl")
    include("broadcast.jl")
    include("filter.jl")
    include("find.jl")
    include("reverse.jl")
    include("show.jl")
end

# Run the following test without julia --check-bounds=yes mode
cmd = deepcopy(Base.julia_cmd())
filter!(a->!startswith(a, "--check-bounds="), cmd.exec)
@test process_exited(run(`$cmd auto_boundscheck.jl`))

@testset "FillDictionary" begin
    inds = Indices([2, 4, 6])
    dict = FillDictionary(inds, 100.0)

    @test keytype(dict) == Int
    @test valtype(dict) == Float64
    @test eltype(dict) == Float64
    @test keys(dict) === inds
    @test dict[2] === 100.0
    @test_throws IndexError dict[3]
    @test dict == Dictionary([2, 4, 6], [100.0, 100.0, 100.0])
    @test dict == FillDictionary([2, 4, 6], 100.0)
    @test istokenizable(dict) == true
end

@testset "UnorderedDictionary" begin
    @test UnorderedDictionary() isa UnorderedDictionary{Any, Any}

    d = UnorderedDictionary{Int64, Int64}()

    @test eltype(d) === Int64
    @test keytype(d) === Int64
    @test valtype(d) === Int64
    @test tokentype(d) === Int
    @test Base.IteratorSize(d) === Base.HasLength()
    @test isinsertable(d)
    @test length(d) == 0
    @test isempty(d)
    @test isempty(keys(d))
    @test d == d
    @test d == copy(d)
    @test d == map(identity, d)
    @test isequal(d, d)
    @test isdictequal(d, d)
    @test isdictequal(copy(d), d)
    @test isdictequal(map(identity, d), d)
    @test_throws IndexError d[10]
    @test get(d, 10, 15) == 15
    @test get(() -> 15, d, 10) == 15
    @test get(d, "10", 15) == 15
    @test get(() -> 15, d, "10") == 15
    @test length(unset!(d, 10)) == 0
    io = IOBuffer(); print(io, d); @test String(take!(io)) == "{}"
    io = IOBuffer(); show(io, MIME"text/plain"(), d); @test String(take!(io)) == "0-element UnorderedDictionary{Int64, Int64}"
    @test_throws IndexError d[10] = 11
    @test_throws IndexError delete!(d, 10)

    insert!(d, 10.0, 11.0)

    @test d[10] == 11
    @test haskey(d, 10)
    @test !haskey(d, 100)
    @test get(d, 10, 15) == 11
    @test get(() -> 15, d, 10) == 11
    @test get(d, "10", 15) == 15
    @test get(() -> 15, d, "10") == 15
    @test get!(d, 10, 15) == 11
    @test length(d) == 1
    @test keys(d) === keys(keys(d))
    @test unique(d)::UnorderedIndices{Int64} == UnorderedIndices([11])
    @test !isempty(d)
    @test d == d
    @test d == copy(d)
    @test d == map(identity, d)
    @test d != empty(d)
    @test empty(d) != d
    @test fill(0, d) != d
    @test d != fill(0, d)
    @test fill(0, copy(keys(d))) != d
    @test d != fill(0, copy(keys(d)))
    @test isequal(d, d)
    @test isdictequal(d, d)
    @test isdictequal(copy(d), d)
    @test isdictequal(map(identity, d), d)
    @test !isdictequal(d, empty(d))
    @test !isdictequal(empty(d), d)
    @test !isdictequal(fill(0, d), d) 
    @test !isdictequal(d, fill(0, d))
    @test !isdictequal(fill(0, copy(keys(d))), d) 
    @test !isdictequal(d, fill(0, copy(keys(d))))
    @test_throws IndexError insert!(d, 10, 12)
    @test d[10.0] == 11
    set!(d, 10.0, 12.0)
    @test length(d) == 1
    @test d[10] == 12
    setwith!(+, d, 10.0, 2.0)
    @test length(d) == 1
    @test d[10] == 14
    setwith!(+, d, 2.0, 2.0)
    @test length(d) == 2
    @test d[2] == 2
    delete!(d, 2)
    @test length(d) == 1
    d[10.0] = 13.0
    @test d[10] == 13
    io = IOBuffer(); print(io, d); @test String(take!(io)) == "{10 = 13}"
    io = IOBuffer(); show(io, MIME"text/plain"(), d); @test String(take!(io)) == "1-element UnorderedDictionary{Int64, Int64}:\n 10 │ 13"
    @test !isdictequal(d, empty(d))
    @test isdictequal(d, copy(d))
    @test isempty(empty(d))

    delete!(d, 10.0)
    @test isequal(d, UnorderedDictionary{Int64, Int64}())
    @test isdictequal(d, UnorderedDictionary{Int64, Int64}())

    @test get!(d, 10, 14.0) == 14
    @test d[10] == 14
    delete!(d, 10)
    
    for i = 2:2:1000
        insert!(d, i, i+1)
        @test d[i] == i + 1 ? true : (@show i; false)
    end
    @test all(in(i, d) == !iseven(i) for i in 2:2:1000)
    @test all(in(i, keys(d)) == iseven(i) for i in 2:2:1000)
    @test collect(Iterators.reverse(d)) == reverse(collect(d))
    @test isempty(empty!(d))
   
    @test get!(() -> 15, d, 10) == 15
    @test get!(() -> 16, d, 10) == 15

    @test isdictequal(d, copy(d))
    @test isdictequal(UnorderedDictionary(['a','b'],[1,2]), UnorderedDictionary(['b','a'],[2,1]))
    @test !isdictequal(UnorderedDictionary(['a','b'],[1,2]), UnorderedDictionary(['b','c'],[2,1]))
    @test !isdictequal(UnorderedDictionary(['a','b'],[1,2]), UnorderedDictionary(['a','b','c'],[1,2,3]))
    @test !isdictequal(UnorderedDictionary(['a','b'],[1,2]), UnorderedDictionary(['b','a'],[2,3]))

    dmut = UnorderedDictionary([Foo(3), Foo(2)], rand(2))
    dmut_copy = deepcopy(dmut)
    @test all(k -> haskey(dmut_copy, k), keys(dmut_copy))
    dmut2_copy = deepcopy((dmut, dmut));
    @test dmut2_copy[1] === dmut2_copy[2];

    mktemp() do path, io
        open(io->serialize(io, dmut), path, "w")
        dmut_ser = deserialize(open(path, "r"))
        @test all(k -> haskey(dmut_ser, k), keys(dmut_ser))
    end
    
    d5 = UnorderedDictionary(['a','b'],[1,missing])
    @test isdictequal(d5, d5) === missing
    @test (d5 == d5) === missing
    d6 = UnorderedDictionary(['a','b'],[1,missing])
    @test isdictequal(d5, d5) === missing
    @test (d5 == d5) === missing
    
    d = UnorderedDictionary([:a, :b, :c], [1, 2, 3])
    @test isdictequal(merge(d, UnorderedDictionary([:c], [3])), UnorderedDictionary([:a, :b, :c], [1, 2, 3]))
    @test isdictequal(merge(d, UnorderedDictionary([:b, :c], [4, 3])), UnorderedDictionary([:a, :b, :c], [1, 4, 3]))

    d7 = UnorderedDictionary(Int32[1, 2], UInt32[1, 2])
    @test convert(UnorderedDictionary{Int64, Int64}, d7)::UnorderedDictionary{Int64, Int64} == UnorderedDictionary(Int64[1, 2], Int64[1, 2])
    d8 = UnorderedDictionary{Int, Int}()
    @test convert(UnorderedDictionary{Int, Int}, d8) === d8

    dict = UnorderedDictionary{Int64, String}([1, 2], undef)

    dictcopy = copy(dict)
    @test dict isa UnorderedDictionary{Int64, String}
    @test !sharetokens(dict, dictcopy)
    io = IOBuffer(); show(io, MIME"text/plain"(), dict); str = String(take!(io)); @test(
        str == "2-element UnorderedDictionary{Int64, String}:\n 1 │ #undef\n 2 │ #undef" ||
        str == "2-element UnorderedDictionary{Int64, String}:\n 2 │ #undef\n 1 │ #undef"
    )
    @test all(!isassigned(dict, i) for i in collect(keys(dict)))
    @test all(!isassigned(dictcopy, i) for i in collect(keys(dictcopy)))
    @test sharetokens(dict, UnorderedDictionary{Int64, String}(dict))
    @test pairs(dict) isa Dictionaries.PairDictionary{Int64, String}

    # TODO token interface

    @testset "filter!" begin
        d = UnorderedDictionary([1,2,3,4,5], [1,3,2,4,5])
        filter!(iseven, d)
        @test isdictequal(d, UnorderedDictionary([3,4], [2,4]))
    end

    @testset "Dict tests from Base" begin
        h = UnorderedDictionary{Int, Int}()

        for i in 1:10000
            insert!(h, i, i+1)
        end
        for i in 1:10000
            @test h[i] == i+1
        end
        for i in 1:2:10000
            delete!(h, i)
        end
        for i in 1:10000
            if iseven(i)
                @test h[i] == i+1
            else
                @test_throws IndexError h[i]
            end
        end
        for i in 1:2:10000
            insert!(h, i, i+1)
        end
        for i in 1:10000
            @test h[i] == i+1
        end
        for i in 1:10000
            delete!(h, i)
        end
        @test isempty(h)
        insert!(h, 77, 100)
        @test h[77] == 100
        for i in 1:10000
            set!(h, i, i+1)
        end
        for i in 1:10000
            @test h[i] == i+1
        end
        for i in 1:2:10000
            delete!(h, i)
        end
        for i in 1:10000
            if iseven(i)
                @test h[i] == i+1
            else
                @test_throws IndexError h[i]
            end
        end
        for i in 10001:20000
            insert!(h, i, i+1)
        end
        for i in 1:10000
            if iseven(i)
                @test h[i] == i+1
            else
                @test_throws IndexError h[i]
            end
        end
        for i in 10000:20000
            @test h[i] == i+1
        end
    end

    @testset "Factories" begin
        d = UnorderedDictionary(['a','b','c'], [1,2,3])
        @test similar(d) isa UnorderedDictionary{Char, Int}
        @test similar(d, Float64) isa UnorderedDictionary{Char, Float64}
        @test sharetokens(d, similar(d))

        @test isempty(empty(d)::UnorderedDictionary{Char, Int})
        @test isempty(empty(d, Float64)::UnorderedIndices{Float64})
        @test isempty(empty(d, String, Float64)::UnorderedDictionary{String, Float64})

        @test isequal(zeros(d)::UnorderedDictionary{Char, Float64}, UnorderedDictionary(['a','b','c'],[0.0,0.0,0.0]))
        @test isequal(zeros(Int64, d)::UnorderedDictionary{Char, Int64}, UnorderedDictionary(['a','b','c'],[0,0,0]))

        @test isequal(ones(d)::UnorderedDictionary{Char, Float64}, UnorderedDictionary(['a','b','c'],[1.0,1.0,1.0]))
        @test isequal(ones(Int64, d)::UnorderedDictionary{Char, Int64}, UnorderedDictionary(['a','b','c'],[1,1,1]))

        @test isequal(keys(rand(1:10, d)::UnorderedDictionary{Char, Int}), UnorderedIndices(['a','b','c']))
        @test isequal(keys(randn(d)::UnorderedDictionary{Char, Float64}), UnorderedIndices(['a','b','c']))
    end

    @testset "rand" begin
        dict = UnorderedDictionary(["a", "b", "c", "d", "e"], 1:5)
        for i = 1:100
            @test rand(dict) in 1:5
        end

        delete!(dict, "b") # Test handling of deleted slots
        for i = 1:100
            @test rand(dict) in [1, 3, 4, 5]
        end
    end
end

@testset "UnorderedIndices" begin
    @test UnorderedIndices() isa UnorderedIndices{Any}
    @test_throws IndexError UnorderedIndices([1, 1])
    @test @inferred(UnorderedIndices(2*x for x in 1:10))::UnorderedIndices == UnorderedIndices(2:2:20)

    h = UnorderedIndices{Int64}()

    @test isinsertable(h)
    @test length(h) == 0
    @test keys(h) === h
    @test h == h
    @test h == copy(h)
    @test isempty(h)
    @test issetequal(copy(h), h)
    h2 = deepcopy((h, h))
    @test h2[1] === h2[2];
    @test_throws IndexError h[10]
    @test length(unset!(h, 10)) == 0
    io = IOBuffer(); print(io, h); @test String(take!(io)) == "{}"
    io = IOBuffer(); show(io, MIME"text/plain"(), h); @test String(take!(io)) == "0-element UnorderedIndices{Int64}"
    @test_throws IndexError delete!(h, 10)

    insert!(h, 10.0)

    @test length(h) == 1
    @test keys(h) === h
    @test unique(h) === h
    @test h == h
    @test h == copy(h)
    @test !isempty(h)
    @test issetequal(copy(h), h)
    @test h[10.0] == 10
    @test_throws IndexError insert!(h, 10)
    @test length(set!(h, 10)) == 1
    @test_throws IndexError insert!(h, 10)
    io = IOBuffer(); print(io, h); @test String(take!(io)) == "{10}"
    io = IOBuffer(); show(io, MIME"text/plain"(), h); @test String(take!(io)) == "1-element UnorderedIndices{Int64}:\n 10"
    @test !isequal(h, empty(h))
    @test issetequal(h, copy(h))
    @test isempty(empty(h))

    delete!(h, 10.0)

    @test issetequal(h, UnorderedIndices{Int64}())

    for i = 2:2:1000
        insert!(h, i)
    end
    @test issetequal(h, UnorderedIndices(2:2:1000))
    @test all(in(i, h) == iseven(i) for i in 2:1000)
    @test collect(Iterators.reverse(h)) == reverse(collect(h))
    @test isempty(empty!(h))

    # set
    @test length(set!(h, 1)) == 1
    @test length(set!(h, 2, 2)) == 2
    @test length(set!(h, 3.0, 3.0)) == 3
    @test_throws ErrorException set!(h, 4, 5)

    @testset "Comparison" begin
        i1 = UnorderedIndices([1,2,3])
        i2 = UnorderedIndices([1,2])

        @test issetequal(i1, i1)
        @test !issetequal(i1, i2)
        @test !issetequal(i2, i1)
        @test issetequal(i2, i2)
    end

    @testset "Adapted from Dict tests from Base" begin
        h = UnorderedIndices{Int}()
        N = 10000

        for i in 1:N
            insert!(h, i)
        end
        for i in 1:N
            @test i in h
        end
        for i in 1:2:N
            delete!(h, i)
        end
        for i in 1:N
            @test (i in h) == iseven(i)
        end
        for i in 1:2:N
            insert!(h, i)
        end
        for i in 1:N
            @test i in h
        end
        for i in 1:N
            delete!(h, i)
        end
        @test isempty(h)
        insert!(h, 77)
        @test 77 in h
        for i in 1:N
            set!(h, i)
        end
        for i in 1:N
            @test i in h
        end
        for i in 1:2:N
            delete!(h, i)
        end
        for i in 1:N
            @test (i in h) == iseven(i)
        end
        for i in N+1:2N
            insert!(h, i)
        end
        for i in 1:2N
            @test (i in h) == (i > N || iseven(i))
        end
    end

    @testset "set logic" begin
        i1 = UnorderedIndices([1,2])
        i2 = UnorderedIndices([2,3])
        i3 = UnorderedIndices([3,4])
        i4 = UnorderedIndices([2])

        s1 = [4,5]

        @test !issetequal(i1, i2)
        @test !(i1 ⊆ i2)
        @test i4 ⊆ i1

        @test !isdisjoint(i1, i2)
        @test isdisjoint(i1, i3)

        @test issetequal(union(i1, i2), UnorderedIndices([1,2,3]))
        @test issetequal(union(i2, i1), UnorderedIndices([2,3,1]))
        @test issetequal(union(i1, i3), UnorderedIndices([1,2,3,4]))
        @test issetequal(union(i1, s1), UnorderedIndices([1,2,4,5]))

        @test issetequal(intersect(i1, i2), UnorderedIndices([2]))
        @test issetequal(intersect(i1, i3), UnorderedIndices([]))
        @test issetequal(intersect(i3, s1), UnorderedIndices([4]))

        @test issetequal(setdiff(i1, i2), UnorderedIndices([1]))
        @test issetequal(setdiff(i1, i3), UnorderedIndices([1, 2]))
        @test issetequal(setdiff(i3, s1), UnorderedIndices([3]))

        @test issetequal(symdiff(i1, i2), UnorderedIndices([1, 3]))
        @test issetequal(symdiff(i1, i3), UnorderedIndices([1, 2, 3, 4]))
        @test issetequal(symdiff(i3, s1), UnorderedIndices([3, 5]))
    end

    @testset "covert" begin
        i = UnorderedIndices{Int32}([1,2,3])
        ai = ArrayIndices{Int32}([1,2,3])

        @test convert(AbstractIndices{Int32}, i) === i
        @test convert(AbstractIndices{Int64}, i)::UnorderedIndices{Int64} == i

        @test convert(UnorderedIndices{Int32}, i) === i
        @test convert(UnorderedIndices{Int64}, i)::UnorderedIndices{Int64} == i

        @test convert(UnorderedIndices{Int32}, ai)::UnorderedIndices{Int32} == i
        @test convert(UnorderedIndices{Int64}, ai)::UnorderedIndices{Int64} == i
    end

    @testset "rand" begin
        inds = UnorderedIndices(["a", "b", "c", "d", "e"])
        for i = 1:100
            @test rand(inds) in ["a", "b", "c", "d", "e"]
        end

        delete!(inds, "b") # Test handling of deleted slots
        for i = 1:100
            @test rand(inds) in ["a", "c", "d", "e"]
        end
    end

    # TODO: token interface
end

module DenseHashDictionaries

import Base: @propagate_inbounds
using Dictionaries
export DenseHashIndices, DenseHashDictionary

perfect_hash(::Any) = false
perfect_hash(::Union{Bool, UInt8, UInt16, UInt32, UInt, Int8, Int16, Int32, Int, Char}) = true

struct DenseHashIndices{I} <: AbstractIndices{I}
    # The hash table
    slots::Vector{Int}

    # Densely ordered hashes and values
    hashes::Vector{UInt}
    values::Vector{I}
end

function DenseHashIndices{I}(; sizehint = 8) where {I}
    @assert sizehint > 0
    DenseHashIndices{I}(fill(0, sizehint), Vector{UInt}(), Vector{I}())
end

function rehash!(indices::DenseHashIndices{I}, newsize::Integer) where {I}
    slots = resize!(indices.slots, newsize)
    fill!(slots, 0)
    bit_mask = newsize - one(typeof(newsize)) # newsize is a power of two
    
    for (index, full_hash) in enumerate(indices.hashes)
        trial_slot = reinterpret(Int, full_hash) & bit_mask
        @inbounds while true
            trial_slot = (trial_slot + 1)
            if slots[trial_slot] == 0
                slots[trial_slot] = index
                break
            else
                trial_slot = trial_slot & bit_mask
            end
            # This is potentially an infinite loop and care must be taken by the callee not
            # to overfill the container
        end
    end
end

Base.length(indices::DenseHashIndices) = length(indices.values)

# Token interface
Dictionaries.istokenizable(::DenseHashIndices) = true

Dictionaries.tokentype(::DenseHashIndices) = Int

# Duration iteration the token cannot be used for deletion - we do not worry about the slots
@propagate_inbounds function Dictionaries.iteratetoken(indices::DenseHashIndices)
    if isempty(indices.values)
        return nothing
    end
    return ((0, 1), 1)
end

@propagate_inbounds function Dictionaries.iteratetoken(indices::DenseHashIndices, index::Int)
    if index == length(indices.values)
        return nothing
    end
    index = index + 1
    return ((0, index), index)
end


function Dictionaries.gettoken(indices::DenseHashIndices{I}, i::I) where {I}
    full_hash = hash(i)
    n_slots = length(indices.slots)
    bit_mask = n_slots - 1 # n_slots is always a power of two

    trial_slot = reinterpret(Int, full_hash) & bit_mask
    @inbounds while true
        trial_slot = (trial_slot + 1)
        trial_index = indices.slots[trial_slot]
        if trial_index == 0
            return (false, (0, 0))
        end

        if full_hash == indices.hashes[trial_index] && (perfect_hash(i) || isequal(i, indices.values[trial_index]))
            return (true, (trial_slot, trial_index))
        end

        trial_slot = trial_slot & bit_mask
        # This is potentially an infinite loop and care must be taken upon insertion not
        # to completely fill the container
    end
end

@propagate_inbounds function Dictionaries.gettokenvalue(indices::DenseHashIndices, (_slot, index))
    return indices.values[index]
end

# Insertion interface
Dictionaries.isinsertable(::DenseHashIndices) = true

function Dictionaries.gettoken!(indices::DenseHashIndices{I}, i::I) where {I}
    full_hash = hash(i)
    n_slots = length(indices.slots)
    bit_mask = n_slots - 1 # n_slots is always a power of two
    n_values = length(indices.values)

    trial_slot = reinterpret(Int, full_hash) & bit_mask
    trial_index = 0
    @inbounds while true
        trial_slot = (trial_slot + 1)
        trial_index = indices.slots[trial_slot]
        if trial_index <= 0
            indices.slots[trial_slot] = n_values + 1
            break
        end

        trial_hash = indices.hashes[trial_index]

        if trial_hash == full_hash && (perfect_hash(i) || isequal(i, indices.values[trial_index]))
            return (true, (trial_slot, trial_index))
        end

        trial_slot = trial_slot & bit_mask
        # This is potentially an infinite loop and care must be taken upon insertion not
        # to completely fill the container
    end

    push!(indices.hashes, full_hash)
    push!(indices.values, i)
    
    # Expand the hash map when it reaches 2/3rd full
    if 3 * (n_values + 1) > 2 * n_slots
        # Grow faster for small hash maps than for large ones
        rehash!(indices, n_slots > 16000 ? 2 * n_slots : 4 * n_slots)
    end

    return (false, (trial_slot, n_values + 1))
end

@propagate_inbounds function Dictionaries.deletetoken!(indices::DenseHashIndices, (slot, index))
    indices.slots[slot] = -1
    splice!(indices.hashes, index)
    splice!(indices.values, index)

    # Shrink the hash map when it is less than 1/4th full
    n_slots = length(indices.slots)
    n_values = length(indices.values)
    if 4 * n_values < n_slots && n_slots > 8
        # Halve each time
        rehash!(indices, n_slots >> 0x01)
    end

    return indices
end

# Factories

Base.empty(::DenseHashIndices, ::Type{I}) where {I} = DenseHashIndices{I}()

########

struct DenseHashDictionary{I, T} <: AbstractDictionary{I, T}
    indices::DenseHashIndices{I}
    values::Vector{T}
end

function DenseHashDictionary{I, T}(; sizehint = 8) where {I, T}
    DenseHashDictionary{I, T}(DenseHashIndices{I}(; sizehint = sizehint), Vector{T}())
end

# indices

Base.keys(dict::DenseHashDictionary) = dict.indices

# tokens

Dictionaries.tokenized(dict::DenseHashDictionary) = dict.values

# values

function Dictionaries.istokenassigned(dict::DenseHashDictionary, (_slot, index))
    return isassigned(dict.values, index)
end

@propagate_inbounds function Dictionaries.gettokenvalue(dict::DenseHashDictionary, (_slot, index))
    return dict.values[index]
end

Dictionaries.issettable(::DenseHashDictionary) = true

@propagate_inbounds function Dictionaries.settokenvalue!(dict::DenseHashDictionary{<:Any, T}, (_slot, index), value::T) where {T}
    dict.values[index] = value
    return dict
end

# insertion

function Dictionaries.gettoken!(dict::DenseHashDictionary{I}, i::I) where {I}
    (hadtoken, (slot, index)) = gettoken!(keys(dict), i)
    if !hadtoken
        resize!(dict.values, length(dict.values) + 1)
    end
    return (hadtoken, (slot, index))
end

function Dictionaries.deletetoken!(dict::DenseHashDictionary, (slot, index))
    deletetoken!(dict.indices, (slot, index))
    splice!(dict.values, index)
    return dict
end


# Factories

Base.empty(::DenseHashIndices, ::Type{I}, ::Type{T}) where {I, T} = DenseHashDictionary{I, T}()

function Base.similar(indices::DenseHashIndices{I}, ::Type{T}) where {I, T}
    return DenseHashDictionary(indices, Vector{T}(undef, length(indices)))
end

end # module

struct Dictionary{I, T} <: AbstractDictionary{I, T}
    indices::Indices{I}
    values::Vector{T}

    function Dictionary{I, T}(inds::Indices{I}, values::Vector{T}, ::Nothing) where {I, T}
       @assert length(values) == length(_values(inds))
       return new{I,T}(inds, values)
    end
end

"""
    Dictionary{I,T}(;sizehint = 8)

Construct an empty hash-based dictionary. `I` and `T` default to `Any` if not specified. A
`sizehint` may be specified to set the initial size of the hash table, which may speed up
subsequent `insert!` operations.

# Example

```julia
julia> d = Dictionary{Int, Int}()
0-element Dictionary{Int64,Int64}
```
"""
Dictionary(; sizehint = 8) = Dictionary{Any, Any}(; sizehint = sizehint)
Dictionary{I}(; sizehint = 8) where {I} = Dictionary{I, Any}(; sizehint = sizehint)

function Dictionary{I, T}(; sizehint = 8) where {I, T}
    values = Vector{T}()
    sizehint!(values, sizehint)
    Dictionary{I, T}(Indices{I}(; sizehint = sizehint), values, nothing)
end

"""
    Dictionary(indexable)
    Dictionary{I}(indexable)
    Dictionary{I,T}(indexable)

Construct a hash-based dictionary from an indexable input `indexable`, equivalent to
`Dictionary(keys(indexable), values(indexable))`. The input might not be copied.

Note: to construct a dictionary from `Pair`s use the `dictionary` function. See also the
`index` function.

# Examples

```julia
julia> Dictionary(Dict(:a=>1, :b=>2))
2-element Dictionary{Symbol,Int64}
 :a │ 1
 :b │ 2

julia> Dictionary(3:-1:1)
3-element Dictionary{Int64,Int64}
 1 │ 3
 2 │ 2
 3 │ 1 
```
"""
Dictionary(indexable) = Dictionary(keys(indexable), values(indexable))
Dictionary{I}(indexable) where {I} = Dictionary{I}(keys(indexable), values(indexable))
Dictionary{I, T}(indexable) where {I, T} = Dictionary{I, T}(keys(indexable), values(indexable))

Dictionary{I, T}(indexable::Dictionary) where {I, T} = Dictionary{I, T}(convert(Indices{I}, keys(indexable)), convert(Vector{T}, indexable.values), nothing)


"""
    Dictionary(inds, values)
    Dictionary{I}(inds, values)
    Dictionary{I, T}(inds, values)

Construct a hash-based dictionary from two iterable inputs `inds` and `values`. The first
value of `inds` will be the index for the first value of `values`. The input might not be
copied.

Note: the values of `inds` must be distinct. Consider using `dictionary(zip(inds, values))`
if they are not. See also the `index` function.

# Example

julia> Dictionary(["a", "b", "c"], [1, 2, 3])
3-element Dictionary{String,Int64}
 "a" │ 1
 "b" │ 2
 "c" │ 3

julia> Dictionary{String, Float64}(["a", "b", "c"], [1, 2, 3])
3-element Dictionary{String,Float6464}
 "a" │ 1.0
 "b" │ 2.0
 "c" │ 3.0
"""
function Dictionary(inds, values)
    return Dictionary(Indices(inds), values)
end

function Dictionary(inds::Indices{I}, values) where {I}
    return Dictionary{I}(inds, values)
end

function Dictionary{I}(inds, values) where {I}
    return Dictionary{I}(Indices{I}(inds), values)
end

function Dictionary{I}(inds::Indices{I}, values) where {I}
    if Base.IteratorEltype(values) === Base.EltypeUnknown()
        values = collect(values)
    end
    
    return Dictionary{I, eltype(values)}(inds, values)
end

function Dictionary{I, T}(inds, values) where {I, T}
    return Dictionary{I, T}(Indices{I}(inds), values)
end

function Dictionary{I, T}(inds::Indices{I}, values) where {I, T}
    if _holes(inds) != 0
        # TODO instead constructor a vector with holes in it...
        inds = copy(inds)
    end

    iter_size = Base.IteratorSize(values)
    if iter_size isa Union{Base.HasLength, Base.HasShape}
        vs = Vector{T}(undef, length(values))
        @inbounds for (i, v) in enumerate(values)
            vs[i] = v
        end
        return Dictionary{I, T}(inds, vs, nothing)
    else
        vs = Vector{T}()
        for v in values
            push!(vs, v)
        end
        return Dictionary{I, T}(inds, vs, nothing)
    end
end

function Dictionary{I, T}(inds::Indices{I}, values::AbstractVector) where {I, T}
    if _holes(inds) != 0
        # TODO instead constructor a vector with holes in it...
        inds = copy(inds)
    end
    return Dictionary{I, T}(inds, convert(Vector{T}, values), nothing)
end

"""
    Dictionary(indices, undef::UndefInitializer)

Construct a `Dictionary` from an iterable of `indices`, where the values are
undefined/uninitialized.

# Example

```julia
julia> Dictionary{Int, Float64}([1,2,3], undef)
3-element Dictionary{Int64,Float64}
 1 │ 6.9220016379355e-310
 2 │ 6.9220016379426e-310
 3 │ 6.92200163794736e-310
```
"""
function Dictionary{I, T}(inds::Indices{I}, ::UndefInitializer) where {I, T}
    vs = Vector{T}(undef, length(_values(inds)))
    return Dictionary{I, T}(inds, vs, nothing)
end

function Base.convert(::Type{Dictionary{I, T}}, dict::Dictionary) where {I, T}
    return Dictionary{I, T}(convert(Indices{I}, dict.indices), convert(Vector{T}, dict.values), nothing)
end
Base.convert(::Type{T}, dict::T) where {T<:Dictionary} = dict

Base.copy(dict::Dictionary) = Dictionary(copy(dict.indices), copy(dict.values))

function Base.deepcopy_internal(dict::Dictionary{I,T}, id::IdDict) where {I,T}
    if haskey(id, dict)
        id[dict]::Dictionary{I,T}
    else
        id[dict] = Dictionary{I,T}(Base.deepcopy_internal(keys(dict), id), Base.deepcopy_internal(collect(dict), id))
    end
end

function Serialization.serialize(s::AbstractSerializer, dict::T) where {T<:Dictionary}
    serialize_type(s, T, false)
    serialize(s, keys(dict))
    serialize(s, collect(dict))
end

"""
    dictionary(iter)

Construct a new `AbstractDictionary` from an iterable `iter` of key-value `Pair`s (or other
iterables of two elements, such as a two-tuples). The default container type is
`Dictionary`. If duplicate keys are detected, the first encountered value is retained.

See also the `index` function.

# Examples

```julia
julia> dictionary(["a"=>1, "b"=>2, "c"=>3])
3-element Dictionary{String,Int64}
 "a" │ 1
 "b" │ 2
 "c" │ 3

julia> dictionary(["a"=>1, "b"=>2, "c"=>3, "a"=>4])
3-element Dictionary{String,Int64}
 "a" │ 1
 "b" │ 2
 "c" │ 3

julia> dictionary(zip(["a","b","c"], [1,2,3]))
3-element Dictionary{String,Int64}
 "a" │ 1
 "b" │ 2
 "c" │ 3
```
"""
function dictionary(iter)
    return _dictionary(first, last, Dictionary, iter)
end

# An auto-widening Dictionary constructor
function _dictionary(key, value, ::Type{Dictionary}, iter)
    tmp = iterate(iter)
    if tmp === nothing
        IT = Base.@default_eltype(iter)
        I = IT == Union{} ? Union{} : Core.Compiler.return_type(first, Tuple{IT})
        T = IT == Union{} ? Union{} : Core.Compiler.return_type(last, Tuple{IT})
        return Dictionary{I, T}()
    end
    (x, s) = tmp
    i = key(x)
    v = value(x)
    dict = Dictionary{typeof(i), typeof(v)}()
    insert!(dict, i, v)
    return __dictionary(key, value, dict, iter, s)
end

# An auto-widening AbstractDictionary constructor
function __dictionary(key, value, dict, iter, s)
    I = keytype(dict)
    T = eltype(dict)
    tmp = iterate(iter, s)
    while tmp !== nothing
        (x, s) = tmp
        i = key(x)
        v = value(x)
        if !(i isa I) && promote_type(typeof(i), I) != I
            new_inds = copy(keys(dict), promote_type(I, typeof(i)))
            new_dict = similar(new_inds, promote_type(T, typeof(v)))
            copyto!(new_dict.values, dict.values)
            (hadtoken, token) = gettoken!(new_dict, i)
            if !hadtoken
                @inbounds settokenvalue!(new_dict, token, v)
            end
            return __dictionary(key, value, new_dict, iter, s)
        elseif !(v isa T) && promote_type(typeof(v), T) != T
            new_dict = copy(dict, promote_type(T, typeof(v)))
            (hadtoken, token) = gettoken!(new_dict, i)
            if !hadtoken
                @inbounds settokenvalue!(new_dict, token, v)
            end
            return __dictionary(key, value, new_dict, iter, s)
        end
        (hadtoken, token) = gettoken!(dict, i)
        if !hadtoken
            @inbounds settokenvalue!(dict, token, v)
        end
        tmp = iterate(iter, s)
    end
    return dict
end

"""
    index(f, iter)

Return a dictionary associating the values `x` of iterable collection `iter` with the key
`f(x)`. If keys are repeated, only the first is kept. Somewhat similar to `unique(f, iter)`

See also the `dictionary` function.

# Examples

```julia
julia> index(first, ["Alice", "Bob", "Charlie"])
3-element Dictionary{Char,String}
 'A' │ "Alice"
 'B' │ "Bob"
 'C' │ "Charlie"

julia> index(iseven, 1:10)
2-element Dictionary{Bool,Int64}
 false │ 1
  true │ 2
```
"""
function index(f, iter)
    _dictionary(f, identity, Dictionary, iter)
end

# indices

Base.keys(dict::Dictionary) = getfield(dict, :indices)
_values(dict::Dictionary) = getfield(dict, :values)

# tokens

tokenized(dict::Dictionary) = _values(dict)

# values

function istokenassigned(dict::Dictionary, (_slot, index))
    return isassigned(_values(dict), index)
end

function istokenassigned(dict::Dictionary, index::Int)
    return isassigned(_values(dict), index)
end

@propagate_inbounds function gettokenvalue(dict::Dictionary, (_slot, index))
    return _values(dict)[index]
end

@propagate_inbounds function gettokenvalue(dict::Dictionary, index::Int)
    return _values(dict)[index]
end

issettable(::Dictionary) = true

@propagate_inbounds function settokenvalue!(dict::Dictionary{<:Any, T}, (_slot, index), value::T) where {T}
    _values(dict)[index] = value
    return dict
end

@propagate_inbounds function settokenvalue!(dict::Dictionary{<:Any, T}, index::Int, value::T) where {T}
    _values(dict)[index] = value
    return dict
end

# insertion

isinsertable(::Dictionary) = true

function gettoken!(dict::Dictionary{I}, i::I) where {I}
    (hadtoken, (slot, index)) = gettoken!(keys(dict), i, (_values(dict),))
    return (hadtoken, (slot, index))
end

function deletetoken!(dict::Dictionary{I, T}, (slot, index)) where {I, T}
    isbitstype(T) || ccall(:jl_arrayunset, Cvoid, (Any, UInt), _values(dict), index-1)
    deletetoken!(keys(dict), (slot, index), (_values(dict),))
    return dict
end


function Base.empty!(dict::Dictionary{I, T}) where {I, T}
    empty!(_values(dict))
    empty!(keys(dict))

    return dict
end

function Base.filter!(pred, dict::Dictionary)
    indices = keys(dict)
    _filter!(token -> pred(@inbounds gettokenvalue(dict, token)), indices, (_values(dict),))
    return dict
end

function Base.filter!(pred, dict::PairDictionary{<:Any, <:Any, <:Dictionary})
    d = dict.d
    indices = keys(d)
    _filter!(token -> pred(@inbounds gettokenvalue(indices, token) => gettokenvalue(d, token)), indices, (_values(d),))
    return dict
end

# Factories

function Base.similar(indices::Indices{I}, ::Type{T}) where {I, T}
    return Dictionary{I, T}(indices, Vector{T}(undef, length(_values(indices))), nothing)
end

"""
    sort!(dict::AbstractDictionary; kwargs...)

Modify `dict` so that it is sorted by its values. The `kwargs` are the usual ordering
options supported by `sort`. Note that this only works on supported types.

See also `sort`, `sortkeys!` and `sortpairs!`.
"""
function Base.sort!(dict::Dictionary; kwargs...)
    inds = keys(dict)
    if inds.holes != 0
        rehash!(inds, length(inds.slots), (dict.values,))
    end
    perm = sortperm(dict.values; kwargs...)
    iperm = invperm(perm)
    inds.values = @inbounds inds.values[perm]
    inds.hashes = @inbounds inds.hashes[perm]
    @inbounds for i in keys(inds.slots)
        s = inds.slots[i]
        if s > 0
            inds.slots[i] = iperm[s]
        end
    end
    permute!(dict.values, perm)
    return dict
end

Base.sortperm(dict::AbstractDictionary; kwargs...) = keys(sort(dict; kwargs...))

"""
    sortkeys!(dict::AbstractDictionary; kwargs...)

Modify `dict` so that it is sorted by `keys(dict)`. The `kwargs` are the usual ordering
options supported by `sort`. Note that this only works on supported types.

See also `sortkeys`, `sort!` and `sortpairs!`.
"""
function sortkeys!(dict::Dictionary; kwargs...)
    inds = keys(dict)
    if inds.holes != 0
        rehash!(inds, length(inds.slots), (dict.values,))
    end
    perm = sortperm(inds.values; kwargs...)
    iperm = invperm(perm)
    inds.values = @inbounds inds.values[perm]
    inds.hashes = @inbounds inds.hashes[perm]
    @inbounds for i in keys(inds.slots)
        s = inds.slots[i]
        if s > 0
            inds.slots[i] = iperm[s]
        end
    end
    permute!(dict.values, perm)
    return dict
end

"""
    sortpairs!(dict::AbstractDictionary; kwargs...)

Modify `dict` so that it is sorted by `pairs(dict)`. The `kwargs` are the usual ordering
options supported by `sort`.

See also `sortpairs`,`sort!` and `sortkeys!`.
"""
function sortpairs!(dict::Dictionary; by = identity, kwargs...)
    inds = keys(dict)
    if inds.holes != 0
        rehash!(inds, length(inds.slots), (dict.values,))
    end
    vals = dict.values
    inds_vals = inds.values
    perm = sortperm(keys(dict.values); by = i -> by(@inbounds(inds_vals[i]) => @inbounds(vals[i])), kwargs...)
    iperm = invperm(perm)
    inds.values = @inbounds inds.values[perm]
    inds.hashes = @inbounds inds.hashes[perm]
    @inbounds for i in keys(inds.slots)
        s = inds.slots[i]
        if s > 0
            inds.slots[i] = iperm[s]
        end
    end
    permute!(dict.values, perm)
    return dict
end

@testset "Dictionary" begin
    @test Dictionary() isa Dictionary{Any, Any}

    d = Dictionary{Int64, Int64}()

    @test eltype(d) === Int64
    @test keytype(d) === Int64
    @test valtype(d) === Int64
    @test tokentype(d) === Int
    @test Base.IteratorSize(d) === Base.HasLength()
    @test isinsertable(d)
    @test length(d) == 0
    @test isempty(d)
    @test isempty(keys(d))
    @test d == d
    @test d == copy(d)
    @test d == map(identity, d)
    @test isequal(d, d)
    @test isequal(copy(d), d)
    @test isequal(map(identity, d), d)
    @test !isless(d, d)
    @test !isless(copy(d), d)
    @test !isless(map(identity, d), d)
    @test cmp(d, d) == 0
    @test cmp(copy(d), d) == 0
    @test cmp(map(identity, d), d) == 0
    @test_throws IndexError d[10]
    @test get(d, 10, 15) == 15
    @test get(() -> 15, d, 10) == 15
    @test get(d, "10", 15) == 15
    @test get(() -> 15, d, "10") == 15
    @test length(unset!(d, 10)) == 0
    io = IOBuffer(); print(io, d); @test String(take!(io)) == "{}"
    io = IOBuffer(); show(io, MIME"text/plain"(), d); @test String(take!(io)) == "0-element Dictionary{Int64, Int64}"
    @test_throws IndexError d[10] = 11
    @test_throws IndexError delete!(d, 10)

    insert!(d, 10.0, 11.0)

    @test d[10] == 11
    @test haskey(d, 10)
    @test !haskey(d, 100)
    @test get(d, 10, 15) == 11
    @test get(() -> 15, d, 10) == 11
    @test get(d, "10", 15) == 15
    @test get(() -> 15, d, "10") == 15
    @test get!(d, 10, 15) == 11
    @test length(d) == 1
    @test keys(d) === keys(keys(d))
    @test unique(d)::Indices{Int64} == Indices([11])
    @test !isempty(d)
    @test d == d
    @test d == copy(d)
    @test d == map(identity, d)
    @test d != empty(d)
    @test empty(d) != d
    @test fill(0, d) != d
    @test d != fill(0, d)
    @test fill(0, copy(keys(d))) != d
    @test d != fill(0, copy(keys(d)))
    @test isequal(d, d)
    @test isequal(copy(d), d)
    @test isequal(map(identity, d), d)
    @test !isequal(d, empty(d))
    @test !isequal(empty(d), d)
    @test !isequal(fill(0, d), d)
    @test !isequal(d, fill(0, d))
    @test !isequal(fill(0, copy(keys(d))), d)
    @test !isequal(d, fill(0, copy(keys(d))))
    @test !isless(d, d)
    @test !isless(copy(d), d)
    @test !isless(map(identity, d), d)
    @test !isless(d, empty(d))
    @test isless(empty(d), d)
    @test isless(fill(0, d), d)
    @test !isless(d, fill(0, d))
    @test isless(fill(0, copy(keys(d))), d)
    @test !isless(d, fill(0, copy(keys(d))))
    @test cmp(d, d) == 0
    @test cmp(copy(d), d) == 0
    @test cmp(map(identity, d), d) == 0
    @test cmp(d, empty(d)) == 1
    @test cmp(empty(d), d) == -1
    @test cmp(fill(0, d), d) == -1
    @test cmp(d, fill(0, d)) == 1
    @test cmp(fill(0, copy(keys(d))), d) == -1
    @test cmp(d, fill(0, copy(keys(d)))) == 1
    @test_throws IndexError insert!(d, 10, 12)
    @test d[10.0] == 11
    set!(d, 10.0, 12.0)
    @test length(d) == 1
    @test d[10] == 12
    setwith!(+, d, 10.0, 2.0)
    @test length(d) == 1
    @test d[10] == 14
    setwith!(+, d, 2.0, 2.0)
    @test length(d) == 2
    @test d[2] == 2
    delete!(d, 2)
    @test length(d) == 1
    d[10.0] = 13.0
    @test d[10] == 13
    io = IOBuffer(); print(io, d); @test String(take!(io)) == "{10 = 13}"
    io = IOBuffer(); show(io, MIME"text/plain"(), d); @test String(take!(io)) == "1-element Dictionary{Int64, Int64}:\n 10 │ 13"
    @test !isequal(d, empty(d))
    @test isequal(d, copy(d))
    @test isempty(empty(d))

    delete!(d, 10.0)
    @test isequal(d, Dictionary{Int64, Int64}())

    @test get!(d, 10, 14.0) == 14
    @test d[10] == 14
    delete!(d, 10)

    for i = 2:2:1000
        insert!(d, i, i+1)
        @test d[i] == i + 1 ? true : (@show i; false)
    end
    @test all(in(i, d) == !iseven(i) for i in 2:2:1000)
    @test all(in(i, keys(d)) == iseven(i) for i in 2:2:1000)
    @test isempty(empty!(d))

    @test get!(() -> 15, d, 10) == 15
    @test get!(() -> 16, d, 10) == 15

    d = Dictionary([:a, :b], [1, 2])
    @test isequal(d, d)
    @test d == d
    @test !isless(d, d)
    d2 = Dictionary((a=1, b=2))
    @test isequal(d, d2)
    @test d == d
    d3 = dictionary([:a=>1, :b=>2])
    @test isequal(d, d3)
    d4 = dictionary(zip([:a, :b], [1, 2]))
    @test isequal(d, d4)
    @test !isless(d, d4)
    @test !isless(d4, d)
    @test hash(d) == hash(d4)

    @test isdictequal(d, copy(d))
    @test isdictequal(Dictionary(['a','b'],[1,2]), Dictionary(['b','a'],[2,1]))
    @test !isdictequal(Dictionary(['a','b'],[1,2]), Dictionary(['b','c'],[2,1]))
    @test !isdictequal(Dictionary(['a','b'],[1,2]), Dictionary(['a','b','c'],[1,2,3]))
    @test !isdictequal(Dictionary(['a','b'],[1,2]), Dictionary(['b','a'],[2,3]))

    foos = Foo.(1:10)
    dmut = Dictionary(foos, rand(10))
    dmut_copy = deepcopy(dmut)
    @test all(k -> haskey(dmut_copy, k), keys(dmut_copy))
    delete!(dmut, foos[3])
    dmut_copy = deepcopy(dmut)
    @test all(k -> haskey(dmut_copy, k), keys(dmut_copy))
    dmut2_copy = deepcopy((dmut, dmut));
    @test dmut2_copy[1] === dmut2_copy[2];

    mktemp() do path, io
        open(io->serialize(io, dmut), path, "w")
        dmut_ser = deserialize(open(path, "r"))
        @test all(k -> haskey(dmut_ser, k), keys(dmut_ser))
    end

    d5 = Dictionary(['a','b'],[1,missing])
    @test isdictequal(d5, d5) === missing
    @test (d5 == d5) === missing
    d6 = Dictionary(['a','b'],[1,missing])
    @test isdictequal(d5, d5) === missing
    @test (d5 == d5) === missing

    @test isequal(merge(d, d), d)
    @test isequal(merge(d, d2), d)

    @test isequal(merge(d, Dictionary([:c], [3])), Dictionary([:a, :b, :c], [1, 2, 3]))
    @test isequal(merge(d, Dictionary([:b, :c], [4, 3])), Dictionary([:a, :b, :c], [1, 4, 3]))

    @test isequal(index(first, ["Alice", "Bob", "Charlie"]), Dictionary(['A', 'B', 'C'], ["Alice", "Bob", "Charlie"]))
    @test isequal(index(first, ["Alice", "Bob", "Charlie", "Conner"]), Dictionary(['A', 'B', 'C'], ["Alice", "Bob", "Charlie"]))

    d7 = Dictionary(Int32[1, 2], UInt32[1, 2])
    @test convert(Dictionary{Int64, Int64}, d7)::Dictionary{Int64, Int64} == Dictionary(Int64[1, 2], Int64[1, 2])
    d8 = Dictionary{Int, Int}()
    @test convert(Dictionary{Int ,Int}, d8) === d8

    rd = Dictionary([:b, :a], [2, 1])
    @test reverse(d)::Dictionary == rd
    @test Iterators.reverse(d)::ReverseDictionary == rd
    @test first(d) == 1
    @test last(d) == 2
    @test firstindex(d) == :a
    @test lastindex(d) == :b
    #@test d[begin] == 1 # Parsing issues on earlier versions of Julia...
    @test d[end] == 2

    dict = Dictionary{Int64, String}([1, 2], undef)

    dictcopy = copy(dict)
    @test dict isa Dictionary{Int64, String}
    @test !sharetokens(dict, dictcopy)
    io = IOBuffer(); show(io, MIME"text/plain"(), dict); @test String(take!(io)) == "2-element Dictionary{Int64, String}:\n 1 │ #undef\n 2 │ #undef"
    @test all(!isassigned(dict, i) for i in collect(keys(dict)))
    @test all(!isassigned(dictcopy, i) for i in collect(keys(dictcopy)))
    @test sharetokens(dict, Dictionary{Int64, String}(dict))
    @test pairs(dict) isa Dictionaries.PairDictionary{Int64, String}

    # TODO token interface

    @testset "filter!" begin
        d = Dictionary([1,2,3,4,5], [1,3,2,4,5])
        filter!(iseven, d)
        @test d == Dictionary([3,4], [2,4])
    end

    @testset "Dict tests from Base" begin
        h = Dictionary{Int, Int}()

        for i in 1:10000
            insert!(h, i, i+1)
        end
        for i in 1:10000
            @test h[i] == i+1
        end
        for i in 1:2:10000
            delete!(h, i)
        end
        for i in 1:10000
            if iseven(i)
                @test h[i] == i+1
            else
                @test_throws IndexError h[i]
            end
        end
        for i in 1:2:10000
            insert!(h, i, i+1)
        end
        for i in 1:10000
            @test h[i] == i+1
        end
        for i in 1:10000
            delete!(h, i)
        end
        @test isempty(h)
        insert!(h, 77, 100)
        @test h[77] == 100
        for i in 1:10000
            set!(h, i, i+1)
        end
        for i in 1:10000
            @test h[i] == i+1
        end
        for i in 1:2:10000
            delete!(h, i)
        end
        for i in 1:10000
            if iseven(i)
                @test h[i] == i+1
            else
                @test_throws IndexError h[i]
            end
        end
        for i in 10001:20000
            insert!(h, i, i+1)
        end
        for i in 1:10000
            if iseven(i)
                @test h[i] == i+1
            else
                @test_throws IndexError h[i]
            end
        end
        for i in 10000:20000
            @test h[i] == i+1
        end
    end

    @testset "copy" begin
        dict = Dictionary([1,2,3,4,5], [1,3,2,4,5])
        dictcopy = copy(dict)
        set!(dict, 6, 7)
        @test length(dict) == 6
        @test length(dictcopy) == 5
    end

    @testset "dictionary" begin
        res = Dictionary(['a','b','c'], [1,2,3])
        @test isequal(dictionary(pairs(res)), res)
        @test isequal(dictionary(['a'=>1, 'b'=>2, 'c'=>3]), res)
        @test isequal(dictionary(['a'=>1, 'b'=>2, 'c'=>3, 'a'=>4]), res)
        @test isequal(dictionary((k,v) for (k,v) in pairs(res)), res)

        res = Dictionary{Any,Any}([2, :x], [2, :b])
        @test isequal(dictionary([2 => 2, :x => :b]), res)
    end

    @testset "index" begin
        res = Dictionary(['A','B','C'], ["Alice","Bob","Charlie"])
        @test isequal(index(first, ["Alice", "Bob", "Charlie"]), res)
        @test isequal(index(first, ["Alice", "Bob", "Charlie", "Conner"]), res)
    end

    @testset "Factories" begin
        d = Dictionary(['a','b','c'], [1,2,3])
        @test similar(d) isa Dictionary{Char, Int}
        @test similar(d, Float64) isa Dictionary{Char, Float64}
        @test sharetokens(d, similar(d))

        @test isempty(empty(d)::Dictionary{Char, Int})
        @test isempty(empty(d, Float64)::Indices{Float64})
        @test isempty(empty(d, String, Float64)::Dictionary{String, Float64})

        @test isequal(zeros(d)::Dictionary{Char, Float64}, Dictionary(['a','b','c'],[0.0,0.0,0.0]))
        @test isequal(zeros(Int64, d)::Dictionary{Char, Int64}, Dictionary(['a','b','c'],[0,0,0]))

        @test isequal(ones(d)::Dictionary{Char, Float64}, Dictionary(['a','b','c'],[1.0,1.0,1.0]))
        @test isequal(ones(Int64, d)::Dictionary{Char, Int64}, Dictionary(['a','b','c'],[1,1,1]))

        @test isequal(keys(rand(1:10, d)::Dictionary{Char, Int}), Indices(['a','b','c']))
        @test isequal(keys(randn(d)::Dictionary{Char, Float64}), Indices(['a','b','c']))
    end

    @testset "rand" begin
        dict = Dictionary(["a", "b", "c", "d", "e"], 1:5)
        for i = 1:100
            @test rand(dict) in 1:5
        end

        delete!(dict, "b") # Test handling of deleted slots
        for i = 1:100
            @test rand(dict) in [1, 3, 4, 5]
        end
    end

    @testset "sort" begin
        dict = Dictionary([1, 3, 2], ['c', 'a', 'b'])
        @test sort(dict)::Dictionary == Dictionary([3, 2, 1], ['a', 'b', 'c'])
        @test sort(dict; rev=true)::Dictionary == Dictionary([1, 2, 3], ['c', 'b', 'a'])

        @test sortperm(dict)::Indices == Indices([3, 2, 1])
        @test sortperm(dict; rev=true)::Indices == Indices([1, 2, 3])
        @test getindices(dict, sortperm(dict))::Dictionary == Dictionary([3, 2, 1], ['a', 'b', 'c'])
        @test getindices(dict, sortperm(dict; rev=true))::Dictionary ==Dictionary([1, 2, 3], ['c', 'b', 'a'])

        @test sortkeys(dict)::Dictionary == Dictionary([1, 2, 3], ['c', 'b', 'a'])
        @test sortkeys(dict; rev=true)::Dictionary == Dictionary([3, 2, 1], ['a', 'b', 'c'])

        @test sortpairs(dict)::Dictionary == Dictionary([1, 2, 3], ['c', 'b', 'a'])
        @test sortpairs(dict; rev=true)::Dictionary == Dictionary([3, 2, 1], ['a', 'b', 'c'])
        @test sortpairs(dict; by=kv->kv.second=>kv.first)::Dictionary == Dictionary([3, 2, 1], ['a', 'b', 'c'])

        dictcopy = deepcopy(dict)
        sort!(dictcopy)
        @test dictcopy == Dictionary([3, 2, 1], ['a', 'b', 'c'])
        @test all(isassigned(dictcopy, i) for i in keys(dictcopy))

        dictcopy = deepcopy(dict)
        sort!(dictcopy; rev = true)
        @test dictcopy == Dictionary([1, 2, 3], ['c', 'b', 'a'])
        @test all(isassigned(dictcopy, i) for i in keys(dictcopy))

        dictcopy = deepcopy(dict)
        sortkeys!(dictcopy)
        @test dictcopy == Dictionary([1, 2, 3], ['c', 'b', 'a'])
        @test all(isassigned(dictcopy, i) for i in keys(dictcopy))

        dictcopy = deepcopy(dict)
        sortkeys!(dictcopy; rev = true)
        @test dictcopy == Dictionary([3, 2, 1], ['a', 'b', 'c'])
        @test all(isassigned(dictcopy, i) for i in keys(dictcopy))

        dictcopy = deepcopy(dict)
        sortpairs!(dictcopy)
        @test dictcopy == Dictionary([1, 2, 3], ['c', 'b', 'a'])
        @test all(isassigned(dictcopy, i) for i in keys(dictcopy))

        dictcopy = deepcopy(dict)
        sortpairs!(dictcopy; rev = true)
        @test dictcopy == Dictionary([3, 2, 1], ['a', 'b', 'c'])
        @test all(isassigned(dictcopy, i) for i in keys(dictcopy))

        dictcopy = deepcopy(dict)
        sortpairs!(dictcopy; by = kv->kv.second=>kv.first)
        @test dictcopy == Dictionary([3, 2, 1], ['a', 'b', 'c'])
        @test all(isassigned(dictcopy, i) for i in keys(dictcopy))
    end

    @testset "merge" begin
        d1 = Dictionary([1, 2, 3], [1, 2, 3])
        d2 = Float32.(d1)
        d3 = Float64.(d1) .+ 0.5
        @test merge(d1, d2) isa Dictionary{Int, Float32}
        @test merge(d1, d2, d3) isa Dictionary{Int, Float64}
        @test merge!(d2, d1) == d1
        @test_throws InexactError merge!(d1, d2, d3)

        @test mergewith(+, d1, d2, d3) isa Dictionary{Int, Float64}
        @test_throws InexactError mergewith!(+, d1, d2, d3)
        @test mergewith(+, d3, d1, d2) isa Dictionary{Int, Float64}
    end

    @testset "deepcopy" begin
        local d = Dictionary(1:4, 1:4)
        delete!(d, 2)
        @test d == deepcopy(d)

        local k = keys(d)
        local d_key_copy = deepcopy((k, d, k));
        @test keys(d_key_copy[2]) == d_key_copy[1]
        @test d_key_copy[1] === d_key_copy[3]
    end
end

@testset "show" begin
    function show_str(d)
        io = IOBuffer()
        io_context = IOContext(io, :limit => true, :displaysize => (10, 20))
        show(io_context, MIME"text/plain"(), d)
        return String(take!(io))
    end

    @test show_str(Indices{Int64}()) == "0-element Indices{Int64}"
    @test show_str(Indices{Int64}(1:3)) == "3-element Indices{Int64}:\n 1\n 2\n 3"
    @test show_str(Indices{Int64}(1:100)) == "100-element Indices{Int64}:\n 1\n 2\n 3\n ⋮\n 99\n 100"
    @test show_str(filterview(iseven, Indices{Int64}(1:100))) == "Greater than 6-element FilteredIndices{Int64, Indices{Int64}, typeof(iseven)}:\n 2\n 4\n 6\n ⋮\n 98\n 100"
    if Int === Int64
        @test show_str(Indices{Vector{Int64}}([collect(1:100)])) == "1-element Indices{Vector{Int64}}:\n [1, 2, 3, 4, 5, 6,…"
        @test show_str(Indices{Vector{Int64}}([collect(1:(100+i)) for i in 1:100])) == "100-element Indices{Vector{Int64}}:\n [1, 2, 3, 4, 5, 6,…\n [1, 2, 3, 4, 5, 6,…\n [1, 2, 3, 4, 5, 6,…\n ⋮\n [1, 2, 3, 4, 5, 6,…\n [1, 2, 3, 4, 5, 6,…"
    else
        @test show_str(Indices{Vector{Int64}}([collect(1:100)])) == "1-element Indices{Vector{Int64}}:\n Int64[1, 2, 3, 4, …"
        @test show_str(Indices{Vector{Int64}}([collect(1:(100+i)) for i in 1:100])) == "100-element Indices{Vector{Int64}}:\n Int64[1, 2, 3, 4, …\n Int64[1, 2, 3, 4, …\n Int64[1, 2, 3, 4, …\n ⋮\n Int64[1, 2, 3, 4, …\n Int64[1, 2, 3, 4, …"
    end

    @test show_str(Dictionary{Int64,Int64}()) == "0-element Dictionary{Int64, Int64}"
    @test show_str(Dictionary{Int64,Int64}(1:3,101:103)) == "3-element Dictionary{Int64, Int64}:\n 1 │ 101\n 2 │ 102\n 3 │ 103"
    @test show_str(Dictionary{Int64,Int64}(1:100,101:200)) == "100-element Dictionary{Int64, Int64}:\n   1 │ 101\n   2 │ 102\n   3 │ 103\n   ⋮ │ ⋮\n  99 │ 199\n 100 │ 200"
    @test show_str(filterview(iseven, Dictionary{Int64,Int64}(1:100,101:200))) == "Greater than 6-element FilteredDictionary{Int64, Int64, Dictionary{Int64, Int64}, typeof(iseven)}:\n   2 │ 102\n   4 │ 104\n   6 │ 106\n   ⋮ │ ⋮\n  98 │ 198\n 100 │ 200"
    @test show_str(Dictionary{Int64,Int64}(collect(1:100), collect(101:200))) == "100-element Dictionary{Int64, Int64}:\n   1 │ 101\n   2 │ 102\n   3 │ 103\n   ⋮ │ ⋮\n  99 │ 199\n 100 │ 200"
    if Int === Int64
        @test show_str(Dictionary{Vector{Int64},Vector{Int64}}([collect(1:100+i) for i in 1:100],[collect(101:200+i) for i in 1:100])) == "100-element Dictionary{Vector{Int64}, Vector{Int64}}:\n [1, 2, … │ [101, 1…\n [1, 2, … │ [101, 1…\n [1, 2, … │ [101, 1…\n        ⋮ │ ⋮\n [1, 2, … │ [101, 1…\n [1, 2, … │ [101, 1…"
    else
        @test show_str(Dictionary{Vector{Int64},Vector{Int64}}([collect(1:100+i) for i in 1:100],[collect(101:200+i) for i in 1:100])) == "100-element Dictionary{Vector{Int64}, Vector{Int64}}:\n Int64[1… │ Int64[1…\n Int64[1… │ Int64[1…\n Int64[1… │ Int64[1…\n        ⋮ │ ⋮\n Int64[1… │ Int64[1…\n Int64[1… │ Int64[1…"
    end
end

@testset "foreach" begin
    i = Indices([1,2,3,4,5])

    tmp = Ref(0)
    foreach(x -> tmp[] += x, i)
    @test tmp[] == 15

    tmp = Ref(0)
    foreach((x,y) -> tmp[] += x + y, i, i)
    @test tmp[] == 30

    tmp = Ref(0)
    foreach((x,y) -> tmp[] += x + y, i, copy(i))
    @test tmp[] == 30

    tmp = Ref(0)
    foreach((x,y,z) -> tmp[] += x + y + z, i, i, i)
    @test tmp[] == 45

    tmp = Ref(0)
    foreach((x,y,z) -> tmp[] += x + y + z, i, i, copy(i))
    @test tmp[] == 45

    d = i .+ 1

    tmp = Ref(0)
    foreach(x -> tmp[] += x, d)
    @test tmp[] == 20

    tmp = Ref(0)
    foreach((x,y) -> tmp[] += x + y, d, d)
    @test tmp[] == 40

    tmp = Ref(0)
    foreach((x,y) -> tmp[] += x + y, d, copy(d))
    @test tmp[] == 40

    tmp = Ref(0)
    foreach((x,y,z) -> tmp[] += x + y + z, d, d, d)
    @test tmp[] == 60

    tmp = Ref(0)
    foreach((x,y,z) -> tmp[] += x + y + z, d, d, copy(d))
    @test tmp[] == 60
end

"""
    AbstractIndices{I} <: AbstractDictionary{I, I}

Abstract type for the unique keys of an `AbstractDictionary`. It is itself an `AbstractDictionary` for
which `getindex` is idempotent, such that `indices[i] = i`. (This is a generalization of
`Base.Slice`).

At minimum, an `AbstractIndices{I}` must implement:

 * The `iterate` protocol, returning unique values of type `I`.
 * `in`, such that `in(i, indices)` implies there is an element of `indices` which `isequal` to `i`.
 * Either `length`, or override `IteratorSize` to `SizeUnknown`.

While an `AbstractIndices` object is a dictionary, the value corresponding to each index is
fixed, so `issettable(::AbstractIndices) = false` and `setindex!` is never defined.

If arbitrary indices can be added or removed from the set, implement:

* `isinsertable(::AbstractIndices)` (returning `true`)
* `insert!(indices::AbstractIndices{I}, ::I}` (returning `indices`)
* `delete!(indices::AbstractIndices{I}, ::I}` (returning `indices`)
"""
abstract type AbstractIndices{I} <: AbstractDictionary{I, I}; end

@inline function Base.getindex(indices::AbstractIndices{I}, i::I) where {I}
    @boundscheck checkindex(indices, i)
    return i
end

function Base.setindex!(i::AbstractIndices{I}, ::I, ::I) where {I}
    error("Indices are not settable: $(typeof(i))")
end

function Base.isassigned(indices::AbstractIndices{I}, i::I) where {I}
    return i in indices
end

Base.keys(i::AbstractIndices) = i

@propagate_inbounds function Base.iterate(inds::AbstractIndices)
    if istokenizable(inds)
        tmp = iteratetoken(keys(inds))
        tmp === nothing && return nothing
        (t, s2) = tmp
        return (@inbounds(gettokenvalue(inds, t)), s2)
    else
        error("All AbstractIndices must define `iterate`: $(typeof(inds))")
    end
end

@propagate_inbounds function Base.iterate(inds::AbstractIndices, s)
    if istokenizable(inds)
        tmp = iteratetoken(keys(inds), s)
        tmp === nothing && return nothing
        (t, s2) = tmp
        return (@inbounds(gettokenvalue(inds, t)), s2)
    else
        error("All AbstractIndices must define `iterate`: $(typeof(inds))")
    end
end

function Base.in(i, indices::AbstractIndices)
    if !istokenizable(indices)
        # A fallback definition based on iteration would be rediculously slow. There
        # shouldn't be many `AbstractIndex` types that rely on iteration for this.
        error("All AbstractIndices must define `in`: $(typeof(indices))")
    end

    return gettoken(indices, i)[1]
end

# Match the default setting from Base - the majority of containers will know their size
Base.IteratorSize(::AbstractIndices) = Base.HasLength() 

function Base.isempty(inds::AbstractIndices)
    return iterate(inds) === nothing
end

function Base.length(indices::AbstractIndices)
    if Base.IteratorSize(indices) isa Base.SizeUnknown
        out = 0
        for _ in tokens(indices)
            out += 1
        end
        return out
    end

    error("All AbstractIndices must define `length` or else have `IteratorSize` of `SizeUnknown`: $(typeof(indices))")
end

Base.unique(i::AbstractIndices) = i

"""
    copy(inds::AbstractIndices)
    copy(inds::AbstractIndices, I::Type)

Construct a shallow copy of `inds`, possibly specifying a new element type `I`. The output
container is not guaranteed to be the same type as the input.
"""
Base.copy(inds::AbstractIndices) = copy(inds, eltype(inds))

function Base.copy(inds::AbstractIndices, ::Type{I}) where I
    out = empty(inds, I)
    for i in inds
        insert!(out, i)
    end
    return out
end

empty_type(::Type{<:AbstractIndices}, ::Type{I}) where {I} = Indices{I}
Base.empty(inds::AbstractIndices, ::Type{I}) where {I} = empty_type(typeof(inds), I)()

"""
    distinct(itr)

Collect the distinct elements of iterator `itr` into a new collection. Similar to
`Base.unique`, except returning a set (`Indices`) instead of an array.

# Example

```julia
julia> distinct([1,2,3,3])
3-element Indices{Int64}
 1
 2
 3
```
"""
distinct(itr) = _distinct(Indices, itr)
distinct(inds::AbstractIndices) = inds

function _distinct(::Type{T}, itr) where T
    out = T()
    union!(out, itr)
    return out
end

struct IndexError <: Exception
	msg::String
end

function Base.checkindex(indices::AbstractIndices{I}, i::I) where {I}
	if i ∉ indices
		short_ind = repr(indices, context=:limit => true)
		throw(IndexError("Index $i not found in indices $short_ind"))
	end
end
Base.checkindex(indices::AbstractIndices{I}, i) where {I} = checkindex(indices, convert(I, i))

function checkindices(indices::AbstractIndices, inds)
    if !(inds ⊆ indices)
        short_ind = repr(indices, context=:limit => true)
        throw(IndexError("Indices $inds are not a subset of $short_ind"))
    end
end

# Indices are isequal if they iterate in the same order
function Base.isequal(i1::AbstractIndices, i2::AbstractIndices)
    if sharetokens(i1, i2)
        return true
    end

    if length(i1) != length(i2)
        return false
    end

    for (j1, j2) in zip(i1, i2)
        if !isequal(j1, j2)
            return false
        end
    end

    return true
end

# The indices must be isequal and the values ==, same ordering
function Base.:(==)(i1::AbstractIndices, i2::AbstractIndices)
    out = true

    if sharetokens(i1, i2)
        # TODO - can we get rid of this loop for reflexive == element types?
        @inbounds for t in tokens(i1)
            # make sure it works for `missing`
            out &= gettokenvalue(i1, t) == gettokenvalue(i2, t)
            if out === false
                return false
            end
        end
        return out
    end

    if length(i1) != length(i2)
        return false
    end

    for (j1, j2) in zip(i1, i2)
        if !isequal(j1, j2)
            return false
        end
        out &= j1 == j2 # make sure it works for `missing`
        if out === false
            return false
        end
    end

    return out
end

# Lexical ordering based on iteration
function Base.isless(inds1::AbstractIndices, inds2::AbstractIndices)
    if sharetokens(inds1, inds2)
        return false # they are isequal
    end

    # We want to iterate... until one is longer than the other (no `zip`)
    tmp1 = iterate(inds1)
    tmp2 = iterate(inds2)
    while tmp1 !== nothing
        if tmp2 === nothing
            return false # shorter collections are isless in lexical ordering
        end
        (i1, s1) = tmp1
        (i2, s2) = tmp2
        !isequal(i1, i2)
        c = cmp(i1, i2)
        
        if c == -1
            return true
        elseif c == 1
            return false
        end

        tmp1 = iterate(inds1, s1)
        tmp2 = iterate(inds2, s2)
    end
    return tmp2 !== nothing # shorter collections are isless in lexical ordering, otherwise isequal
end

function Base.cmp(inds1::AbstractIndices, inds2::AbstractIndices)
    if sharetokens(inds1, inds2)
        return 0 # they are isequal
    end

    # We want to iterate... until one is longer than the other (no `zip`)
    tmp1 = iterate(inds1)
    tmp2 = iterate(inds2)
    while tmp1 !== nothing
        if tmp2 === nothing
            return 1 # shorter collections are isless in lexical ordering
        end
        (i1, s1) = tmp1
        (i2, s2) = tmp2
        !isequal(i1, i2)
        c = cmp(i1, i2)
        
        if c == -1
            return -1
        elseif c == 1
            return 1
        end

        tmp1 = iterate(inds1, s1)
        tmp2 = iterate(inds2, s2)
    end
    if tmp2 === nothing
        return 0
    else
        return -1 # shorter collections are isless in lexical ordering
    end
end

## Hashing - matches the dictionary case (matching keys and matching values)
function Base.hash(inds::AbstractIndices, h::UInt)
    h1 = h
    for i in inds
        h1 = hash(i, h1)
    end
    
    return hash(hash(UInt === UInt64 ? 0x8955a87bc313a509 : 0xa9cff5d1, h1), h1)
end

function Base.union(i::AbstractIndices{T}, itr) where {T}
    if Base.IteratorEltype(itr) === Base.EltypeUnknown()
        itr = collect(itr)
    end
    T2 = eltype(itr)
    Tout = promote_type(T, T2)

    if isinsertable(i)
        out = copy(i, Tout)
        union!(out, itr)
    else
        out = empty(i, Tout)
        union!(out, i)
        union!(out, itr)
    end
    return out
end

function Base.intersect(i::AbstractIndices, itr)
    if isinsertable(i)
        out = copy(i)
        intersect!(out, itr)
    else
        out = empty(i)
        union!(out, i)
        intersect!(out, itr)
    end
    return out
end

function Base.setdiff(i::AbstractIndices, itr)
    if isinsertable(i)
        out = copy(i)
        setdiff!(out, itr)
    else
        out = empty(i)
        union!(out, i)
        setdiff!(out, itr)
    end
    return out
end

function Base.symdiff(i::AbstractIndices{T}, itr) where {T}
    if Base.IteratorEltype(itr) === Base.EltypeUnknown()
        itr = collect(itr)
    end
    T2 = eltype(itr)
    Tout = promote_type(T, T2)

    if isinsertable(i)
        out = copy(i, Tout)
        symdiff!(out, itr)
    else
        out = empty(i, Tout)
        union!(out, i)
        symdiff!(out, itr)
    end
    return out
end

# issetequal and issubset(equal) should work already

function randtoken(i::AbstractIndices)
    return randtoken(Random.GLOBAL_RNG, i)
end

function randtoken(::Random.AbstractRNG, i::AbstractIndices)
    error("randtoken is not implemented for $(typeof(i))")
end

function Base.sort(inds::AbstractIndices{I}; kwargs...) where {I}
    ks = collect(inds)
    sort!(ks; kwargs...)
    return empty_type(typeof(inds), I)(ks)
end

"""
    ArrayIndices(iter)

Construct an `ArrayIndices <: AbstractIndices` from an arbitrary Julia iterable with unique
elements. Lookup uses naive iteration.

ArrayIndices make simple and flexible indices using naive search that may be optimal for
small collections. Larger collections are better handled by containers like `Indices`.
"""
struct ArrayIndices{I, Inds <: AbstractArray{I}} <: AbstractIndices{I}
    inds::Inds
    
    @inline function ArrayIndices{I, Inds}(a::Inds) where {I, Inds <: AbstractArray{I}}
        @boundscheck for i in LinearIndices(a)
            @inbounds x = a[i]
            for j in i+1:last(LinearIndices(a))
                if isequal(x, @inbounds(a[j]))
                    throw(IndexError("Indices are not unique"))
                end
            end
        end
        return new(a)
    end
end

@propagate_inbounds ArrayIndices() = ArrayIndices{Any}([])
@propagate_inbounds ArrayIndices{I}() where {I} = ArrayIndices{I, Vector{I}}(I[])
@propagate_inbounds ArrayIndices{I, Inds}() where {I, Inds} = ArrayIndices{I}(Inds())

@propagate_inbounds ArrayIndices(iter) = ArrayIndices(collect(iter))
@propagate_inbounds ArrayIndices{I}(iter) where {I} = ArrayIndices{I}(collect(I, iter))

@propagate_inbounds ArrayIndices(a::AbstractArray{I}) where {I} = ArrayIndices{I}(a)
@propagate_inbounds ArrayIndices{I}(a::AbstractArray{I}) where {I} = ArrayIndices{I, typeof(a)}(a)

Base.convert(::Type{AbstractIndices{I}}, inds::ArrayIndices) where {I} = convert(ArrayIndices{I}, inds)
Base.convert(::Type{ArrayIndices}, inds::AbstractIndices{I}) where {I} = convert(ArrayIndices{I}, inds)
Base.convert(::Type{ArrayIndices{I}}, inds::AbstractIndices) where {I} = convert(ArrayIndices{I, Vector{I}}, inds)
function Base.convert(::Type{ArrayIndices{I, Inds}}, inds::AbstractIndices) where {I, Inds <: AbstractArray{I}}
    a = convert(Inds, collect(I, inds))
    return @inbounds ArrayIndices{I, typeof(a)}(a)
end

Base.convert(::Type{ArrayIndices{I}}, inds::ArrayIndices{I}) where {I} = inds
Base.convert(::Type{ArrayIndices{I}}, inds::ArrayIndices{<:Any,Inds}) where {I, Inds <: AbstractArray{I}} = convert(ArrayIndices{I, Inds}, inds)
Base.convert(::Type{ArrayIndices{I, Inds}}, inds::ArrayIndices{I, Inds}) where {I, Inds <: AbstractArray{I}} = inds
function Base.convert(::Type{ArrayIndices{I, Inds}}, inds::ArrayIndices) where {I, Inds <: AbstractArray{I}}
    a = convert(Inds, parent(inds))
    return @inbounds ArrayIndices{I, Inds}(a)
end

Base.parent(inds::ArrayIndices) = getfield(inds, :inds)

# Basic interface
@propagate_inbounds function Base.iterate(i::ArrayIndices{I}, state...) where {I}
    iterate(parent(i), state...)
end

Base.in(i::I, inds::ArrayIndices{I}) where {I} = in(i, parent(inds))
Base.IteratorSize(::ArrayIndices) = Base.HasLength()
Base.length(inds::ArrayIndices) = length(parent(inds))

istokenizable(i::ArrayIndices) = true
tokentype(::ArrayIndices) = Int
@inline iteratetoken(inds::ArrayIndices, s...) = iterate(LinearIndices(parent(inds)), s...)
@inline function iteratetoken_reverse(inds::ArrayIndices)
    li = LinearIndices(parent(inds))
    if isempty(li)
        return nothing
    else
        t = last(li)
        return (t, t)
    end
end
@inline function iteratetoken_reverse(inds::ArrayIndices, t)
    li = LinearIndices(parent(inds))
    t -= 1
    if t < first(li)
        return nothing
    else
        return (t, t)
    end
end

@inline function gettoken(inds::ArrayIndices, i)
    a = parent(inds)
    @inbounds for x in LinearIndices(a)
        if isequal(i, a[x])
            return (true, convert(Int, x))
        end
    end
    return (false, 0)
end
@propagate_inbounds gettokenvalue(inds::ArrayIndices, x::Int) = parent(inds)[x]

isinsertable(i::ArrayIndices) = true # Need an array trait here...
@inline function gettoken!(inds::ArrayIndices{I}, i::I, values = ()) where {I}
    a = parent(inds)
    @inbounds for x in LinearIndices(a)
        if isequal(i, a[x])
            return (true, convert(Int, x))
        end
    end
    push!(a, i)
    foreach(v -> resize!(v, length(v) + 1), values)
    return (false, last(LinearIndices(a)))
end

@inline function deletetoken!(inds::ArrayIndices, x::Int, values = ())
    deleteat!(parent(inds), x)
    foreach(v -> deleteat!(v, x), values)
    return inds
end

function Base.empty!(inds::ArrayIndices, values = ())
    empty!(parent(inds))
    foreach(empty!, values)
    return inds
end

empty_type(::Type{<:ArrayIndices}, ::Type{I}) where {I} = ArrayIndices{I, Vector{I}}

function Base.copy(inds::ArrayIndices, ::Type{I}) where {I}
    if I === eltype(inds)
        ArrayIndices{I}(copy(parent(inds)))
    else
        ArrayIndices{I}(convert(AbstractArray{I}, parent(inds)))
    end
end

function Base.filter!(pred, inds::ArrayIndices)
    filter!(pred, parent(inds))
    return inds
end

function randtoken(rng::Random.AbstractRNG, inds::ArrayIndices)
    return rand(rng, keys(parent(inds)))
end

function Base.sort!(inds::ArrayIndices; kwargs...)
    sort!(inds.inds; kwargs...)
    return inds
end

## Indices

function Base.filter(pred, inds::AbstractIndices)
    out = empty(inds)
    for i in inds
        if pred(i)
            insert!(out, i)
        end
    end
    return out
end

# Occasionally it might be faster to copy all and remove just a few indices...
# TODO: export `unsafe_filter`, or hook up to certain datatypes or something
function unsafe_filter(pred, inds::AbstractIndices)
    out = copy(inds)
    Base.unsafe_filter!(pred, out)
    return out
end

struct FilteredIndices{I, Parent <: AbstractIndices{I}, Pred} <: AbstractIndices{I}
    parent::Parent
    pred::Pred
end

Base.parent(inds::FilteredIndices) = getfield(inds, :parent)
_pred(inds::FilteredIndices) = getfield(inds, :pred)
Base.IteratorSize(::FilteredIndices) = Base.SizeUnknown() # You can still call `length`, but it is slower
Base.length(inds::FilteredIndices) = count(_pred(inds), parent(inds))

function Base.in(i::I, inds::FilteredIndices{I}) where {I}
    return i in parent(inds) && _pred(inds)(i)
end

function Base.iterate(inds::FilteredIndices{I}, s...) where {I}
    tmp = iterate(parent(inds), s...)
    tmp === nothing && return nothing
    (i::I, s2) = tmp
    if _pred(inds)(i)
        return (i, s2)
    else
        return iterate(inds, s2)
    end
    return nothing
end

function Base.iterate(inds::ReverseIndices{I,<:FilteredIndices}, s...) where {I}
    tmp = iterate(Iterators.reverse(parent(inds)), s...)
    tmp === nothing && return nothing
    (i::I, s2) = tmp
    if _pred(inds)(i)
        return (i, s2)
    else
        return iterate(inds, s2)
    end
    return nothing
end

istokenizable(inds::FilteredIndices) = istokenizable(parent(inds))
@propagate_inbounds function iteratetoken(inds::FilteredIndices{I}, s...) where {I}
    p = parent(inds)
    tmp = iteratetoken(p, s...)
    while (tmp !== nothing)
        (token, state) = tmp
        i = gettokenvalue(p, token)
        if _pred(inds)(i)
            return tmp
        end
        tmp = iteratetoken(p, state)
    end
    return nothing
end
@propagate_inbounds function iteratetoken_reverse(inds::FilteredIndices{I}, s...) where {I}
    p = parent(inds)
    tmp = iteratetoken_reverse(p, s...)
    while (tmp !== nothing)
        (token, state) = tmp
        i = gettokenvalue(p, token)
        if _pred(inds)(i)
            return tmp
        end
        tmp = iteratetoken_reverse(p, state)
    end
    return nothing
end
@propagate_inbounds function gettoken(inds::FilteredIndices, i)
    (hastoken, token) = gettoken(parent(inds), i)
    @boundscheck if hastoken
        return (_pred(inds)(@inbounds gettokenvalue(parent(inds), token)), token)
    end
    return (hastoken, token)
end
@propagate_inbounds gettokenvalue(inds::FilteredIndices, t) = gettokenvalue(parent(inds), t)

function filterview(pred, inds::AbstractIndices{I}) where {I}
    return FilteredIndices{I, typeof(inds), typeof(pred)}(inds, pred)
end

Iterators.reverse(inds::FilteredIndices) = filterview(_pred(inds), Iterators.reverse(parent(inds)))

empty_type(::Type{<:FilteredIndices{<:Any, Inds}}, ::Type{I}) where {I, Inds} = empty_type(Inds, I)

function Base.isempty(inds::FilteredIndices)
    for _ in inds
        return false
    end
    return true
end

function randtoken(rng::Random.AbstractRNG, inds::FilteredIndices)
    if isempty(inds)
        throw(ArgumentError("range must be non-empty"))
    end
    p = parent(inds)
    while true
        # Rejection sampling
        token = randtoken(rng, p)
        if _pred(inds)(@inbounds gettokenvalue(p, token))
            return token
        end
    end
end

## Dictionaries

function Base.filter(pred, dict::AbstractDictionary)
    out = empty(dict)
    for (i, v) in pairs(dict)
        if pred(v)
            insert!(out, i, v)
        end
    end
    return out
end

# Occasionally it might be faster to copy all and remove just a few indices...
# TODO: export `unsafe_filter`, or hook up to certain datatypes or something
function unsafe_filter(pred, dict::AbstractDictionary)
    out = copy(dict)
    Base.unsafe_filter!(pred, dict)
    return out
end

struct FilteredDictionary{I, V, Parent <: AbstractDictionary{I, V}, Pred} <: AbstractDictionary{I, V}
    parent::Parent
    pred::Pred
end

Base.parent(dict::FilteredDictionary) = getfield(dict, :parent)
_pred(dict::FilteredDictionary) = getfield(dict, :pred)
Base.IteratorSize(::FilteredDictionary) = Base.SizeUnknown() # You can still call `length`, but it is slower

@inline function Base.keys(dict::FilteredDictionary)
    return filterview(i -> _pred(dict)(parent(dict)[i]), keys(parent(dict)))
end

function Base.isassigned(dict::FilteredDictionary{I}, i::I) where {I}
    p = parent(dict)
    if !isassigned(p, i)
        return false
    end
    @inbounds v = p[i]
    return _pred(dict)(v)
end

@propagate_inbounds function Base.getindex(dict::FilteredDictionary{I}, i::I) where {I}
    p = parent(dict)
    (hastoken, token) = gettoken(p, i)
    @boundscheck if !hastoken
        throw(IndexError("Dictionary does not contain index: $i"))
    end
    out = gettokenvalue(p, token)
    @boundscheck if !_pred(dict)(out)
        throw(IndexError("Dictionary does not contain index: $i"))
    end
    return out
end

# These dictionaries are not settable - changing the values can change the keys

istokenizable(dict::FilteredDictionary) = istokenizable(parent(dict))
@propagate_inbounds function gettoken(dict::FilteredDictionary, i)
    (hastoken, token) = gettoken(parent(dict), i)
    @boundscheck if hastoken
        return (_pred(dict)(@inbounds gettokenvalue(parent, token)), token)
    end
    return (hastoken, token)
end
@propagate_inbounds gettokenvalue(dict::FilteredDictionary, t) = gettokenvalue(parent(dict), t)
@propagate_inbounds istokenassigned(dict::FilteredDictionary, t) = istokenassigned(parent(dict), t)

function filterview(pred, inds::AbstractDictionary{I, T}) where {I, T}
    return FilteredDictionary{I, T, typeof(inds), typeof(pred)}(inds, pred)
end

Base.similar(dict::FilteredDictionary, ::Type{T}) where {T} = similar(keys(dict), T)
empty_type(::Type{<:FilteredDictionary{<:Any, <:Any, D}}, ::Type{I}, ::Type{T}) where {I, T, D} = empty_type(D, I, T)

# Lazy broadcasted dictionary

struct BroadcastedDictionary{I, T, F, Data <: Tuple} <: AbstractDictionary{I, T}
    f::F
    data::Data
    sharetokens::Bool
end

# We prevent @inbounds annotations from propagating into the call to the user
# defined function `d.f` using an extra layer of indirection with `_call_f`.
_call_f(d::BroadcastedDictionary, args...) = getfield(d, :f)(args...)

_f(d::BroadcastedDictionary) = getfield(d, :f)
_data(d::BroadcastedDictionary) = getfield(d, :data)

@propagate_inbounds function BroadcastedDictionary(f, data)
    dicts = _dicts(data...)
    sharetokens = _sharetokens(dicts...)
    I = keytype(dicts[1])
    Ts = Base.Broadcast.eltypes(data)
    T = Core.Compiler.return_type(f, Ts)

    return BroadcastedDictionary{I, T, typeof(f), typeof(data)}(f, data, sharetokens)
end

@inline Base.keys(d::BroadcastedDictionary) = _keys(_data(d)...)

@propagate_inbounds function Base.getindex(d::BroadcastedDictionary{I}, i::I) where {I}
    if istokenizable(d)
        t = gettoken(d, i)
        return _call_f(d, _gettokenvalue(t, _data(d)...)...)
    else
        return _call_f(d, _getindex(i, _data(d)...)...)
    end
end

function Base.isassigned(d::BroadcastedDictionary{I}, i::I) where {I}
    return _isassigned(i, _data(d)...)
end

istokenizable(d::BroadcastedDictionary) = getfield(d, :sharetokens)
function tokens(d::BroadcastedDictionary)
    _tokens(_data(d)...)
end

@propagate_inbounds function gettoken(d::BroadcastedDictionary, i)
    return gettoken(_tokens(_data(d)...), i)
end

function istokenassigned(d::BroadcastedDictionary, t)
    return _istokenassigned(t, _data(d)...)
end

@propagate_inbounds function gettokenvalue(d::BroadcastedDictionary, t)
    return _call_f(d, _gettokenvalue(t, _data(d)...)...)
end

@inline function Base.similar(d::BroadcastedDictionary, ::Type{T}) where {T}
    return similar(_dicts(d.data...)[1], T)
end

@inline _dicts(d::AbstractDictionary, ds...) = (d, _dicts(ds...)...)
@inline _dicts(d, ds...) = (_dicts(ds...)...,)
_dicts() = ()

@inline _tokens(d::AbstractDictionary, ds...) = tokens(d)
@inline _tokens(d, ds...) = _tokens(ds...)

@inline _keys(d::AbstractDictionary, ds...) = keys(d)
@inline _keys(d, ds...) = _keys(ds...)

_sharetokens(d) = true
@propagate_inbounds function _sharetokens(d, d2, ds...)
    if sharetokens(d, d2)
        return _sharetokens(d, ds...)
    else
        @boundscheck if !isequal(keys(d), keys(d2))
            throw(IndexError("Indices do not match"))
        end
        return false
    end
end

_getindex(i) = ()
@propagate_inbounds _getindex(i, d::AbstractDictionary, ds...) = (d[i], _getindex(i, ds...)...)
@propagate_inbounds _getindex(i, d::Ref, ds...) = (d[], _getindex(i, ds...)...)
@propagate_inbounds _getindex(i, d, ds...) = (d[CartesianIndex()], _getindex(i, ds...)...)

_gettokenvalue(t) = ()
@propagate_inbounds _gettokenvalue(t, d::AbstractDictionary, ds...) = (gettokenvalue(d, t), _gettokenvalue(t, ds...)...)
@propagate_inbounds _gettokenvalue(t, d::Ref, ds...) = (d[], _gettokenvalue(t, ds...)...)
@propagate_inbounds _gettokenvalue(t, d, ds...) = (d[CartesianIndex()], _gettokenvalue(t, ds...)...)

_isassigned(i) = true
_isassigned(i, d, ds...) = _isassigned(i, ds...)
function _isassigned(i, d::AbstractDictionary, ds...)
    if isassigned(d, i)
        return _isassigned(i, ds...)
    else
        return false
    end
end

_istokenassigned(t) = true
_istokenassigned(t, d, ds...) = _istokenassigned(t, ds...)
function _istokenassigned(t, d::AbstractDictionary, ds...)
    if istokenassigned(d, t)
        return _istokenassigned(t, ds...)
    else
        return false
    end
end

## Hook into `Base.Broadcast` machinery

Base.Broadcast.broadcastable(d::AbstractDictionary) = d

struct DictionaryStyle <: Base.Broadcast.BroadcastStyle
end

Base.Broadcast.BroadcastStyle(::Type{<:AbstractDictionary}) = DictionaryStyle()
Base.Broadcast.BroadcastStyle(::DictionaryStyle, ::Base.Broadcast.AbstractArrayStyle{0}) = DictionaryStyle()

# Now we overload `broadcasted` directly
function Base.Broadcast.broadcasted(::DictionaryStyle, f, args...)
    return BroadcastedDictionary(f, args)
end

Base.Broadcast.materialize(d::BroadcastedDictionary) = copyto!(similar(d, eltype(d)), d)
Base.Broadcast.materialize!(out::AbstractDictionary, d::BroadcastedDictionary) = copyto!(out, d)

Base.Broadcast.materialize!(out::AbstractDictionary, bc::Base.Broadcast.Broadcasted{Base.Broadcast.DefaultArrayStyle{0}, Nothing, typeof(identity)}) = fill!(out, bc.args[1][])

# These can be changed, to trade off better performance for space
const global maxallowedprobe = 16
const global maxprobeshift   = 6

mutable struct UnorderedIndices{T} <: AbstractIndices{T}
    slots::Array{UInt8,1}
    inds::Array{T,1}
    ndel::Int
    count::Int
    idxfloor::Int  # an index <= the indices of all used slots
    maxprobe::Int
end

UnorderedIndices() = UnorderedIndices{Any}()

"""
    UnorderedIndices{I}()

Construct an empty `UnorderedIndices` with indices of type `I`. This container uses hashes for
fast lookup, and is insertable. (See `isinsertable`). Unlike `Indices`, the order of elements
is undefined (depending on the implementation of `hash` and the history of the collection).
"""
function UnorderedIndices{T}(; sizehint::Int = 16) where {T}
    sz = Base._tablesz(sizehint)
    UnorderedIndices{T}(zeros(UInt8, sz), Vector{T}(undef, sz), 0, 0, 1, 0)
end


## Constructors

"""
    UnorderedIndices(iter)
    UnorderedIndices{I}(iter)

Construct a `UnorderedIndices` with indices from iterable container `iter`.
"""
function UnorderedIndices(iter)
    if Base.IteratorEltype(iter) === Base.EltypeUnknown()
        # TODO: implement automatic widening from iterators of Base.EltypeUnknown
        iter = collect(iter)
    end

    return UnorderedIndices{eltype(iter)}(iter)
end

function UnorderedIndices{T}(iter) where {T}
    iter_size = Base.IteratorSize(iter)
    if iter_size isa Union{Base.HasLength, Base.HasShape}
        h = UnorderedIndices{T}(; sizehint = (length(iter)*5) >>> 0x02)
    else
        h = UnorderedIndices{T}()
    end

    for i in iter
        insert!(h, i) # should this be `set!` or `insert!`?
    end

    return h
end

Base.convert(::Type{AbstractIndices{I}}, inds::UnorderedIndices) where {I} = convert(UnorderedIndices{I}, inds)
Base.convert(::Type{UnorderedIndices}, inds::AbstractIndices{I}) where {I} = convert(UnorderedIndices{I}, inds)
function Base.convert(::Type{UnorderedIndices{I}}, inds::AbstractIndices) where {I}
    return  UnorderedIndices{I}(inds)
end

Base.convert(::Type{UnorderedIndices{I}}, inds::UnorderedIndices{I}) where {I} = inds
function Base.convert(::Type{UnorderedIndices{I}}, inds::UnorderedIndices) where {I}
    return copy(inds, I)
end

function Base.copy(h::UnorderedIndices{T}, ::Type{T}) where {T}
    return UnorderedIndices{T}(copy(h.slots), copy(h.inds), h.ndel, h.count, h.idxfloor, h.maxprobe)
end

function Base.deepcopy_internal(uinds::UnorderedIndices{T}, id::IdDict) where {T}
    if haskey(id, uinds)
        id[uinds]::UnorderedIndices{T}
    else
        id[uinds] = UnorderedIndices{T}(Base.deepcopy_internal(collect(keys(uinds)), id))
    end
end

function Serialization.serialize(s::AbstractSerializer, uinds::T) where {T<:UnorderedIndices}
    serialize_type(s, T, false)
    serialize(s, collect(keys(uinds)))
end

function Serialization.deserialize(s::AbstractSerializer, T::Type{<:UnorderedIndices})
    tag = Int32(read(s.io, UInt8)::UInt8)
    if tag != UNDEFREF_TAG
        vals = handle_deserialize(s, tag)
    else
        error("could not deserialize $T")
    end
    return T(vals)
end

## Length
Base.length(h::UnorderedIndices) = h.count

## Token interface

istokenizable(::UnorderedIndices) = true
tokentype(::UnorderedIndices) = Int

@propagate_inbounds isslotempty(h::UnorderedIndices, i::Int) = h.slots[i] == 0x00
@propagate_inbounds isslotfilled(h::UnorderedIndices, i::Int) = h.slots[i] == 0x01
@propagate_inbounds isslotdeleted(h::UnorderedIndices, i::Int) = h.slots[i] == 0x02 # deletion marker/tombstone

istokenassigned(h::UnorderedIndices, i::Int) = h.slots[i] == 0x01 # isslotfilled(h, i)

# iteratetoken

@propagate_inbounds function iteratetoken(h::UnorderedIndices{T}) where {T}
    idx = h.idxfloor
    slots = h.slots
    L = length(slots)

    @inbounds while idx <= L
        if slots[idx] == 0x01
            h.idxfloor = idx # An optimization to skip unnecessary elements when iterating multiple times
            return (idx, idx + 1)
        end

        idx += 1
    end

    return nothing
end

@propagate_inbounds function iteratetoken(h::UnorderedIndices{T}, idx::Int) where {T}
    slots = h.slots
    L = length(slots)

    @inbounds while idx <= L
        if slots[idx] == 0x01
            return (idx, idx + 1)
        end

        idx += 1
    end

    return nothing
end

@propagate_inbounds function iteratetoken_reverse(h::UnorderedIndices{T}) where {T}
    slots = h.slots
    L = length(slots)
    idx = L

    @inbounds while idx > 0
        if slots[idx] == 0x01
            return (idx, idx - 1)
        end

        idx -= 1
    end

    return nothing
end

@propagate_inbounds function iteratetoken_reverse(h::UnorderedIndices{T}, idx::Int) where {T}
    slots = h.slots

    @inbounds while idx > 0
        if slots[idx] == 0x01
            return (idx, idx - 1)
        end

        idx -= 1
    end

    return nothing
end

# gettoken
function hashtoken(key, sz::Int)
    # Given key what is the hash slot? sz is a power of two
    (((hash(key)%Int) & (sz-1)) + 1)::Int
end

@inline function gettoken(h::UnorderedIndices{T}, key) where {T}
    inds = h.inds
    slots = h.slots
    sz = length(inds)
    iter = 0
    maxprobe = h.maxprobe
    token = hashtoken(key, sz)

    @inbounds while true
        slot = slots[token]
        if slot == 0x00 # isslotempty(h, token)
            break
        elseif slot == 0x01 #= !isslotdeleted(h, token) =#
            k = inds[token]
            if key === k || isequal(key, k)
                return (true, token)
            end
        end

        token = (token & (sz-1)) + 1
        iter += 1
        iter > maxprobe && break
    end
    return (false, 0)
end

# gettokenvalue
@propagate_inbounds function gettokenvalue(h::UnorderedIndices, token::Int)
    return h.inds[token]
end


# insertable interface
isinsertable(::UnorderedIndices) = true

function Base.empty!(h::UnorderedIndices{T}) where {T}
    fill!(h.slots, 0x0) # It should be OK to reduce this back to some smaller size.
    sz = length(h.slots)
    empty!(h.inds)
    resize!(h.inds, sz)
    h.ndel = 0
    h.count = 0
    h.idxfloor = 1
    return h
end

function rehash!(h::UnorderedIndices, newsz::Int = length(h.inds))
    _rehash!(h, nothing, newsz)
    return h
end

function _rehash!(h::UnorderedIndices{T}, oldv::Union{Nothing, Vector}, newsz::Int) where {T}
    olds = h.slots
    oldk = h.inds
    sz = length(olds)
    newsz = Base._tablesz(newsz)
    h.idxfloor = 1
    if h.count == 0
        resize!(slots, newsz)
        fill!(slots, 0)
        resize!(inds, newsz)
        error()
        oldv === nothing || resize!(oldv, newsz)
        h.ndel = 0
        return oldv
    end

    slots = zeros(UInt8, newsz)
    keys = Vector{T}(undef, newsz)
    vals = oldv === nothing ? nothing : Vector{eltype(oldv)}(undef, newsz)
    count = 0
    maxprobe = h.maxprobe

    for i ∈ 1:sz
        @inbounds if olds[i] == 0x1
            k = oldk[i]
            v = vals === nothing ? nothing : oldv[i]
            index0 = index = hashtoken(k, newsz)
            while slots[index] != 0
                index = (index & (newsz-1)) + 1
            end
            probe = (index - index0) & (newsz-1)
            probe > maxprobe && (maxprobe = probe)
            slots[index] = 0x1
            keys[index] = k
            vals === nothing || (vals[index] = v)
            count += 1
        end
    end

    h.slots = slots
    h.inds = keys
    h.count = count
    h.ndel = 0
    h.maxprobe = maxprobe

    return vals
end

Base.sizehint!(h::UnorderedIndices, newsz::Int) = _sizehint!(h, nothing, newsz)

function _sizehint!(h::UnorderedIndices{T}, values::Union{Nothing, Vector}, newsz::Int) where {T}
    oldsz = length(h.slots)
    if newsz <= oldsz
        # TODO: shrink
        # be careful: rehash!() assumes everything fits. it was only designed
        # for growing.
        return hash
    end
    # grow at least 25%
    newsz = min(max(newsz, (oldsz*5)>>2),
                Base.max_values(T))
    return _rehash!(h, values, newsz)
end



function gettoken!(h::UnorderedIndices{T}, key::T) where {T}
    (token, _) = _gettoken!(h, nothing, key) # This will make sure a slot is available at `token` (or `-token` if it is new)

    if token < 0
        @inbounds (token, _) = _insert!(h, nothing, key, -token) # This will fill the slot with `key`
        return (false, token)
    else
        return (true, token)
    end
end

# get the index where a key is stored, or -pos if not present 
# and the key would be inserted at pos
# This version is for use by insert!, set! and get!
function _gettoken!(h::UnorderedIndices{T}, values::Union{Nothing, Vector}, key::T) where {T}
    inds = h.inds
    slots = h.slots
    sz = length(inds)
    iter = 0
    maxprobe = h.maxprobe
    token = hashtoken(key, sz)
    avail = 0

    # Search of the key is present or if there is a deleted slot `key` could fill.
    @inbounds while true
        slot = slots[token]
        if slot == 0x00 # isslotempty(h, token)
            if avail < 0
                return (avail, values)
            end
            return (-token, values)
        elseif slot == 0x02 # isslotdeleted(h, token)
            if avail == 0
                # found an available deleted slot, but we need to keep scanning
                # in case `key` already exists in a later collided slot.
                avail = -token
            end
        else
            k = inds[token]
            if key === k || isequal(key, k)
                return (token, values)
            end
        end

        token = (token & (sz-1)) + 1
        iter += 1
        iter > maxprobe && break
    end

    avail < 0 && return (avail, values)

    # The key definitely isn't present, but a slot may become available if we increase
    # `maxprobe` (up to some reasonable global limits).
    maxallowed = max(maxallowedprobe, sz>>maxprobeshift)
    
    @inbounds while iter < maxallowed
        if slots[token] != 0x01 # !isslotfilled(h,token)
            h.maxprobe = iter
            return (-token, values)
        end
        token = (token & (sz-1)) + 1
        iter += 1
    end

    # If we get here, then all the probable slots are filled, and the only recourse is to
    # increase the size of the hash map and try again
    values = _rehash!(h, values, h.count > 64000 ? sz*2 : sz*4)
    return _gettoken!(h, values, key)
end

@propagate_inbounds function _insert!(h::UnorderedIndices{T}, values::Union{Nothing, Vector}, key::T, token::Int) where {T}
    h.slots[token] = 0x1
    h.inds[token] = key
    h.count += 1
    if token < h.idxfloor
        h.idxfloor = token
    end
    
    # TODO revisit this...
    #=
    sz = length(h.inds)
    # Rehash now if necessary
    if h.ndel >= ((3*sz)>>2) || h.count*3 > sz*2
        # > 3/4 deleted or > 2/3 full
        values = _rehash!(h, values, h.count > 64000 ? h.count*2 : h.count*4)
        (_, token) = gettoken(h, key)
    end
    =#

    return (token, values)
end


@inline function deletetoken!(h::UnorderedIndices{T}, token::Int) where {T}
    h.slots[token] = 0x2
    isbitstype(T) || ccall(:jl_arrayunset, Cvoid, (Any, UInt), h.inds, token-1)
    
    h.ndel += 1
    h.count -= 1
    return h
end

# Since deleting elements doesn't mess with iteration, we can use `unsafe_filter!``
Base.filter!(pred, h::UnorderedIndices) = Base.unsafe_filter!(pred, h)

empty_type(::Type{<:UnorderedIndices}, ::Type{I}) where {I} = UnorderedIndices{I}

function randtoken(rng::Random.AbstractRNG, inds::UnorderedIndices)
    if inds.count == 0
        throw(ArgumentError("collection must be non-empty"))
    end

    # Rejection sampling to handle holes
    range = Base.OneTo(length(inds.slots))
    @inbounds while true
        i = rand(rng, range)
        if inds.slots[i] === 0x01
            return i
        end
    end
end

# Reversed indices
struct ReverseIndices{I, Inds <: AbstractIndices{I}} <: AbstractIndices{I}
    inds::Inds
end

Base.parent(inds::ReverseIndices) = getfield(inds, :inds)
@propagate_inbounds Base.in(item, inds::ReverseIndices) = in(item, parent(inds))
Base.length(inds::ReverseIndices) = length(parent(inds))
Base.IteratorSize(inds::ReverseIndices) = Base.IteratorSize(parent(inds))

istokenizable(inds::ReverseIndices) = istokenizable(parent(inds))
tokentype(inds::ReverseIndices) = tokentype(parent(inds))
@propagate_inbounds gettoken(inds::ReverseIndices, i) = gettoken(parent(inds), i)
@propagate_inbounds gettokenvalue(inds::ReverseIndices, t) = gettokenvalue(parent(inds), t)

@propagate_inbounds iteratetoken(inds::ReverseIndices, s...) = iteratetoken_reverse(parent(inds), s...)
@propagate_inbounds iteratetoken_reverse(inds::ReverseIndices, s...) = iteratetoken(parent(inds), s...)

Iterators.reverse(inds::AbstractIndices) = ReverseIndices{eltype(inds), typeof(inds)}(inds)
Iterators.reverse(inds::ReverseIndices) = parent(inds)

Base.reverse(inds::AbstractIndices) = copy(Iterators.reverse(inds))

empty_type(::Type{<:ReverseIndices{<:Any, Inds}}, ::Type{I}) where {I, Inds} = empty_type(Inds, I)
empty_type(::Type{<:ReverseIndices{<:Any, Inds}}, ::Type{I}, ::Type{T}) where {I, T, Inds} = empty_type(Inds, I, T)

Base.similar(inds::ReverseIndices, ::Type{T}) where {T} = Iterators.reverse(similar(parent(inds), T))

# Reversed dictionary
struct ReverseDictionary{I, T, Dict <: AbstractDictionary{I, T}} <: AbstractDictionary{I, T}
    dict::Dict
end

Base.parent(dict::ReverseDictionary) = getfield(dict, :dict)

@inline function Base.keys(dict::ReverseDictionary)
    Iterators.reverse(keys(parent(dict)))
end

issetable(dict::ReverseDictionary) = issetable(parent(dict))

Base.isassigned(dict::ReverseDictionary{I}, i::I) where {I} = isassigned(parent(dict), i)
@propagate_inbounds Base.getindex(dict::ReverseDictionary{I}, i::I) where {I} = getindex(parent(dict), i)
@propagate_inbounds Base.setindex!(dict::ReverseDictionary{I, T}, i::I, v::T) where {I, T} = setindex!(parent(dict), v, i)

istokenassigned(dict::ReverseDictionary, t) = istokenassigned(parent(dict), t)
@propagate_inbounds gettokenvalue(dict::ReverseDictionary, t) = gettokenvalue(parent(dict), t)
@propagate_inbounds settokenvalue!(dict::ReverseDictionary{<:Any, T}, t, v::T) where {T} = settokenvalue!(parent(dict), t, v)

Iterators.reverse(dict::AbstractDictionary) = ReverseDictionary{keytype(dict), eltype(dict), typeof(dict)}(dict)
Iterators.reverse(dict::ReverseDictionary) = parent(dict)

function Base.reverse(dict::AbstractDictionary)
    out = similar(reverse(keys(dict)), eltype(dict))
    @inbounds copyto!(out, Iterators.reverse(dict))
    return out
end

empty_type(::Type{<:ReverseDictionary{<:Any, <:Any, D}}, ::Type{I}) where {I, D} = empty_type(D, I)
empty_type(::Type{<:ReverseDictionary{<:Any, <:Any, D}}, ::Type{I}, ::Type{T}) where {I, T, D} = empty_type(D, I, T)

@testset "indexing" begin
    i = Indices([1,2,3,4,5])

    @test issetequal(getindices(i, i)::Indices, i)
    @test view(i, i) === i

    i2 = Indices([1,2,3])
    
    @test issetequal(getindices(i, i2)::Indices, i2)
    @test view(i, i2) === i2
    
    d = zeros(Int64, i)::Dictionary

    @test isequal(getindices(d, i)::Dictionary, d)
    @test issetequal(pairs(getindices(d, i2)::Dictionary), [1=>0, 2=>0, 3=>0])
    @test issetequal(pairs(view(d, i2)::DictionaryView), [1=>0, 2=>0, 3=>0])

    setindices!(d, 1, i2)

    @test issetequal(pairs(d), [1=>1, 2=>1, 3=>1, 4=>0, 5=>0])

    d2 = Dictionary([3,4,2], [2,3,4])

    @test issetequal(pairs(getindices(i, d2)::Dictionary), [4=>3, 2=>4, 3=>2])
    @test issetequal(pairs(view(i, d2)::DictionaryView), [4=>3, 2=>4, 3=>2])

    @test issetequal(pairs(getindices(d, d2)::Dictionary), [2=>0, 3=>1, 4=>1])
    @test issetequal(pairs(view(d, d2)::DictionaryView), [2=>0, 3=>1, 4=>1])

    setindices!(d, 2, d2)
    
    @test issetequal(pairs(d), [1=>1, 2=>2, 3=>2, 4=>2, 5=>0])
end

const hash_mask = typemax(UInt) >>> 0x01
const deletion_mask = hash_mask + 0x01

mutable struct Indices{I} <: AbstractIndices{I}
    # The hash table
    slots::Vector{Int}

    # Hashes and values
    hashes::Vector{UInt} # Deletion marker stored in high bit
    values::Vector{I}

    holes::Int # Number of "vacant" slots in hashes and values
end

_slots(inds::Indices) = getfield(inds, :slots)
_hashes(inds::Indices) = getfield(inds, :hashes)
_values(inds::Indices) = getfield(inds, :values)
_holes(inds::Indices) = getfield(inds, :holes)

Indices(; sizehint = 8) = Indices{Any}(; sizehint = sizehint)

function Indices{I}(; sizehint = 8) where {I}
    newsize = Base._tablesz((3 * sizehint) >> 0x01);
    hashes = Vector{UInt}()
    values = Vector{I}()
    sizehint!(hashes, sizehint)
    sizehint!(values, sizehint)
    Indices{I}(fill(0, newsize), hashes, values, 0)
end

"""
    Indices(iter)
    Indices{I}(iter)

Construct a `Indices` with indices from iterable container `iter`.

Note that the elements of `iter` must be distinct/unique. Instead, the `distinct` function
can be used for finding the unique elements.

# Examples

```julia
julia> Indices([1,2,3])
3-element Indices{Int64}
 1
 2
 3

julia> Indices([1,2,3,3])
ERROR: IndexError("Indices are not unique (inputs at positions 3 and 4) - consider using the distinct function")
Stacktrace:
 [1] Indices{Int64}(::Array{Int64,1}) at /home/ferris/.julia/dev/Dictionaries/src/Indices.jl:92
 [2] Indices(::Array{Int64,1}) at /home/ferris/.julia/dev/Dictionaries/src/Indices.jl:53
 [3] top-level scope at REPL[12]:1

julia> distinct([1,2,3,3])
3-element Indices{Int64}
 1
 2
 3
```
"""
function Indices(iter)
    if Base.IteratorEltype(iter) === Base.EltypeUnknown()
        iter = collect(iter)
    end

    return Indices{eltype(iter)}(iter)
end

function Indices{I}(iter) where {I}
    iter_size = Base.IteratorSize(iter)
    if iter_size isa Union{Base.HasLength, Base.HasShape}
        values = Vector{I}(undef, length(iter))
        @inbounds for (i, value) in enumerate(iter)
            values[i] = value
        end
    else
        values = Vector{I}()
        @inbounds for value in iter
            push!(values, value)
        end
    end
    return Indices{I}(values)
end

function Indices{I}(values::Vector{I}) where {I}
    # The input must have unique elements (the constructor is not to be used in place of `distinct`)
    hashes = map(v -> hash(v) & hash_mask, values)
    
    # Incrementally build the hashmap and throw if duplicates detected
    newsize = Base._tablesz(3*length(values) >> 0x01)
    bit_mask = newsize - 1 # newsize is a power of two
    slots = zeros(Int, newsize)
    @inbounds for index in keys(hashes)
        full_hash = hashes[index]
        trial_slot = reinterpret(Int, full_hash) & bit_mask
        @inbounds while true
            trial_slot = (trial_slot + 1)
            if slots[trial_slot] == 0
                slots[trial_slot] = index
                break
            else
                # TODO make this check optional
                if isequal(values[index], values[slots[trial_slot]])
                    throw(IndexError("Indices are not unique (inputs at positions $(slots[trial_slot]) and $index) - consider using the distinct function"))
                end
            end
            trial_slot = trial_slot & bit_mask
            # This is potentially an infinite loop and care must be taken not to overfill the container
        end
    end
    return Indices{I}(slots, hashes, values, 0)
end

Base.convert(::Type{AbstractIndices{I}}, inds::AbstractIndices) where {I} = convert(Indices{I}, inds) # the default AbstractIndices type
Base.convert(::Type{AbstractIndices{I}}, inds::AbstractIndices{I}) where {I} = inds

Base.convert(::Type{AbstractIndices{I}}, inds::Indices) where {I} = convert(Indices{I}, inds)
Base.convert(::Type{Indices}, inds::AbstractIndices{I}) where {I} = convert(Indices{I}, inds)

Base.convert(::Type{Indices{I}}, inds::Indices{I}) where {I} = inds
function Base.convert(::Type{Indices{I}}, inds::AbstractIndices) where {I}
    # Fast path
    if inds isa Indices
        # Note: `convert` doesn't have copy semantics
        return Indices{I}(_slots(inds), _hashes(inds), convert(Vector{I}, _values(inds)), _holes(inds))
    end

    # The input is already unique
    values = collect(I, inds)
    hashes = map(v -> hash(v) & hash_mask, values)

    # Incrementally build the hashmap
    newsize = Base._tablesz(3*length(values) >> 0x01)
    bit_mask = newsize - 1 # newsize is a power of two
    slots = zeros(Int, newsize)
    @inbounds for index in keys(hashes)
        full_hash = hashes[index]
        trial_slot = reinterpret(Int, full_hash) & bit_mask
        @inbounds while true
            trial_slot = (trial_slot + 1)
            if slots[trial_slot] == 0
                slots[trial_slot] = index
                break
            else
                # TODO make this check optional
                if isequal(values[index], values[slots[trial_slot]])
                    throw(IndexError("Indices are not unique (inputs at positions $(slots[trial_slot]) and $index)"))
                end
            end
            trial_slot = trial_slot & bit_mask
            # This is potentially an infinite loop and care must be taken not to overfill the container
        end
    end
    return Indices{I}(slots, hashes, values, 0)
end

"""
    copy(inds::AbstractIndices)
    copy(inds::AbstractIndices, ::Type{I})

Create a shallow copy of the indices, optionally changing the element type.

(Note that `copy` on a dictionary does not copy its indices).
"""
function Base.copy(indices::Indices{I}, ::Type{I2}) where {I, I2}
    return Indices{I2}(copy(_slots(indices)), copy(_hashes(indices)), collect(I2, _values(indices)), _holes(indices))
end

function Base.copy(indices::ReverseIndices{I,Indices{I}}, ::Type{I2}) where {I, I2}
    p = parent(indices)
    l = length(_values(p)) + 1
    old_slots = _slots(p)
    new_slots = similar(old_slots)
    @inbounds for i in keys(_slots(p))
        index = old_slots[i]
        if index > 0
            new_slots[i] = l - index
        else
            new_slots[i] = index
        end
    end
    return Indices{I2}(new_slots, reverse(_hashes(p)), collect(I2, Iterators.reverse(_values(p))), _holes(p))
end

function Base.deepcopy_internal(ind::Indices{T}, id::IdDict) where {T}
    if haskey(id, ind)
        id[ind]::Indices{T}
    else
        id[ind] = Indices{T}(Base.deepcopy_internal(collect(ind), id))
    end
end

function Serialization.serialize(s::AbstractSerializer, ind::T) where {T<:Indices}
    serialize_type(s, T, false)
    serialize(s, collect(ind))
end

function Serialization.deserialize(s::AbstractSerializer, T::Type{<:Indices})
    tag = Int32(read(s.io, UInt8)::UInt8)
    if tag != UNDEFREF_TAG
        vals = handle_deserialize(s, tag)
    else
        error("could not deserialize $T")
    end
    return T(vals)
end

# private (note that newsize must be power of two)
function rehash!(indices::Indices{I}, newsize::Int, values = (), include_last_values::Bool = true) where {I}
    slots = resize!(_slots(indices), newsize)
    fill!(slots, 0)
    bit_mask = newsize - 1 # newsize is a power of two
    
    if _holes(indices) == 0
        for (index, full_hash) in enumerate(_hashes(indices))
            trial_slot = reinterpret(Int, full_hash) & bit_mask
            @inbounds while true
                trial_slot = (trial_slot + 1)
                if slots[trial_slot] == 0
                    slots[trial_slot] = index
                    break
                else
                    trial_slot = trial_slot & bit_mask
                end
                # This is potentially an infinite loop and care must be taken not to overfill the container
            end
        end
    else
        # Compactify _values(indices), _hashes(indices) and the values while we are at it
        to_index = Ref(1) # Reassigning to to_index/from_index gives the closure capture boxing issue, so mutate a reference instead
        from_index = Ref(1)
        n_values = length(_values(indices))
        @inbounds while from_index[] <= n_values
            full_hash = _hashes(indices)[from_index[]]
            if full_hash & deletion_mask === zero(UInt)
                trial_slot = reinterpret(Int, full_hash) & bit_mask
                @inbounds while true
                    trial_slot = trial_slot + 1
                    if slots[trial_slot] == 0
                        slots[trial_slot] = to_index[]
                        _hashes(indices)[to_index[]] = _hashes(indices)[from_index[]]
                        _values(indices)[to_index[]] = _values(indices)[from_index[]]
                        if include_last_values || from_index[] < n_values
                            # Note - the last slot might end up with a random value (or
                            # GC'd reference). It's the callers responsibility to ensure the
                            # last slot is written to after this operation.
                            map(values) do (vals)
                                @inbounds vals[to_index[]] = vals[from_index[]]
                            end
                        end
                        to_index[] += 1
                        break
                    else
                        trial_slot = trial_slot & bit_mask
                    end
                end
            end
            
            from_index[] += 1
        end
    
        new_size = n_values - _holes(indices)
        resize!(_values(indices), new_size)
        resize!(_hashes(indices), new_size)
        map(values) do (vals)
            resize!(vals, new_size)
        end
        setfield!(indices, :holes, 0)
    end
    return indices
end

Base.length(indices::Indices) = length(_values(indices)) - _holes(indices)

# Token interface
istokenizable(::Indices) = true

tokentype(::Indices) = Int

# Duration iteration the token cannot be used for deletion - we do not worry about the slots
@propagate_inbounds function iteratetoken(indices::Indices)
    if _holes(indices) == 0
        return length(indices) > 0 ? ((0, 1), 1) : nothing
    end
    index = 1
    @inbounds while index <= length(_hashes(indices))
        if _hashes(indices)[index] & deletion_mask === zero(UInt)
            return ((0, index), index)
        end
        index += 1
    end
    return nothing
end

@propagate_inbounds function iteratetoken(indices::Indices, index::Int)
    index += 1
    if _holes(indices) == 0 # apparently this is enough to make it iterate as fast as `Vector`
        return index <= length(_values(indices)) ? ((0, index), index) : nothing
    end
    @inbounds while index <= length(_hashes(indices))
        if _hashes(indices)[index] & deletion_mask === zero(UInt)
            return ((0, index), index)
        end
        index += 1
    end
    return nothing
end

@propagate_inbounds function iteratetoken_reverse(indices::Indices)
    index = length(indices)
    if _holes(indices) == 0
        return index > 0 ? ((0, index), index) : nothing
    end
    @inbounds while index > 0
        if _hashes(indices)[index] & deletion_mask === zero(UInt)
            return ((0, index), index)
        end
        index -= 1
    end
    return nothing
end

@propagate_inbounds function iteratetoken_reverse(indices::Indices, index::Int)
    index -= 1
    if _holes(indices) == 0 # apparently this is enough to make it iterate as fast as `Vector`
        return index > 0 ? ((0, index), index) : nothing
    end
    @inbounds while index > 0
        if _hashes(indices)[index] & deletion_mask === zero(UInt)
            return ((0, index), index)
        end
        index -= 1
    end
    return nothing
end

function gettoken(indices::Indices{I}, i) where {I}
    full_hash = hash(i) & hash_mask
    n_slots = length(_slots(indices))
    bit_mask = n_slots - 1 # n_slots is always a power of two
    hashes = indices.hashes

    trial_slot = reinterpret(Int, full_hash) & bit_mask
    @inbounds while true
        trial_slot = (trial_slot + 1)
        trial_index = _slots(indices)[trial_slot]
        if trial_index > 0
            if isbitstype(I) || Base.isbitsunion(I) || I === Symbol || full_hash === @inbounds hashes[trial_index]
                value = _values(indices)[trial_index]
                if i === value || isequal(i, value)
                    return (true, (trial_slot, trial_index))
                end
            end
        elseif trial_index === 0
            return (false, (0, 0))
        end

        trial_slot = trial_slot & bit_mask
        # This is potentially an infinite loop and care must be taken upon insertion not
        # to completely fill the container
    end
end

@propagate_inbounds function gettokenvalue(indices::Indices, (_slot, index))
    return _values(indices)[index]
end

@propagate_inbounds function gettokenvalue(indices::Indices, index::Int)
    return _values(indices)[index]
end

# Insertion interface
isinsertable(::Indices) = true

function gettoken!(indices::Indices{I}, i::I, values = ()) where {I}
    full_hash = hash(i) & hash_mask
    n_slots = length(_slots(indices))
    bit_mask = n_slots - 1 # n_slots is always a power of two
    n_values = length(_values(indices))
    hashes = indices.hashes

    trial_slot = reinterpret(Int, full_hash) & bit_mask
    trial_index = 0
    deleted_slot = 0
    @inbounds while true
        trial_slot = (trial_slot + 1)
        trial_index = _slots(indices)[trial_slot]
        if trial_index == 0
            break
        elseif trial_index < 0
            if deleted_slot == 0
                deleted_slot = trial_slot
            end
        else
            if isbitstype(I) || Base.isbitsunion(I) || I === Symbol || full_hash === @inbounds hashes[trial_index]
                value = _values(indices)[trial_index]
                if i === value || isequal(i, value)
                    return (true, (trial_slot, trial_index))
                end
            end
        end

        trial_slot = trial_slot & bit_mask
        # This is potentially an infinite loop and care must be taken upon insertion not
        # to completely fill the container
    end

    new_index = n_values + 1
    if deleted_slot == 0
        # Use the trail slot
        _slots(indices)[trial_slot] = new_index
    else
        # Use the deleted slot
        _slots(indices)[deleted_slot] = new_index
    end
    push!(_hashes(indices), full_hash)
    push!(_values(indices), i)
    map(values) do (vals)
        resize!(vals, length(vals) + 1)
    end

    # Expand the hash map when it reaches 2/3rd full
    if 3 * new_index > 2 * n_slots
        # Grow faster for small hash maps than for large ones
        newsize = n_slots > 16000 ? 2 * n_slots : 4 * n_slots
        rehash!(indices, newsize, values, false)

        # The index has changed
        new_index = length(_values(indices))

        # The slot also has changed
        bit_mask = newsize - 1
        trial_slot = reinterpret(Int, full_hash) & bit_mask
        @inbounds while true
            trial_slot = (trial_slot + 1)
            if _slots(indices)[trial_slot] == new_index
                break
            end
            trial_slot = trial_slot & bit_mask
        end
    end

    return (false, (trial_slot, new_index))
end

@propagate_inbounds function deletetoken!(indices::Indices{I}, (slot, index), values = ()) where {I}
    @boundscheck if slot == 0
        error("Cannot use iteration token for deletion")
    end
    _slots(indices)[slot] = -index
    _hashes(indices)[index] = deletion_mask
    isbitstype(I) || ccall(:jl_arrayunset, Cvoid, (Any, UInt), _values(indices), index-1)
    setfield!(indices, :holes, _holes(indices) + 1)

    # Recreate the hash map when 1/3rd of the values are deletions
    n_values = length(_values(indices)) - _holes(indices)
    if 3 * _holes(indices) > n_values
        # Halve if necessary
        n_slots = length(_slots(indices))
        halve = 4 * n_values < n_slots && n_slots > 8
        rehash!(indices, halve ? n_slots >> 0x01 : n_slots, values)
    end

    return indices
end

function Base.empty!(indices::Indices{I}, values = ()) where {I} 
    setfield!(indices, :hashes, Vector{UInt}())
    setfield!(indices, :values, Vector{I}())
    setfield!(indices, :slots, fill(0, 8))
    setfield!(indices, :holes, 0)

    foreach(empty!, values)
    
    return indices
end

# Accelerated filtering

function Base.filter!(pred, indices::Indices)
    _filter!(token -> pred(@inbounds gettokenvalue(indices, token)), indices, ())
end

@inline function _filter!(pred, indices::Indices, values = ())
    indices_values = _values(indices)
    hashes = _hashes(indices)
    n = length(indices_values)
    i = Ref(0)
    j = Ref(0)
    @inbounds while i[] < n
        i[] += 1
        if hashes[i[]] & deletion_mask === zero(UInt) && pred(i[])
            j[] += 1
            indices_values[j[]] = indices_values[i[]]
            hashes[j[]] = hashes[i[]]
            map(vec -> @inbounds(vec[j[]] = vec[i[]]), values)
        end
    end
    newsize = j[]
    resize!(indices_values, newsize)
    resize!(hashes, newsize)
    map(vec -> resize!(vec, newsize), values)
    setfield!(indices, :holes, 0)
    newsize = Base._tablesz(3*length(_values(indices)) >> 0x01)
    rehash!(indices, newsize, values)
end

# Factories

# TODO make this generic... maybe a type-based `empty`?
function _distinct(::Type{Indices}, itr)
    if Base.IteratorEltype(itr) === Base.HasEltype()
        return _distinct(Indices{eltype(itr)}, itr)
    end

    tmp = iterate(itr)
    if tmp === nothing
        return Indices{Base.@default_eltype(itr)}()
    end
    (x, s) = tmp
    indices = Indices{typeof(x)}()
    insert!(indices, x)
    return __distinct!(indices, itr, s, x)
end

# An auto-widening constructor for insertable AbstractIndices
function __distinct!(indices::AbstractIndices, itr, s, x_old)
    T = eltype(indices)
    tmp = iterate(itr, s)
    while tmp !== nothing
        (x, s) = tmp
        if !isequal(x, x_old) # Optimized for repeating elements of `itr`, e.g. if `itr` is sorted
            if !(x isa T) && promote_type(typeof(x), T) != T
                new_indices = copy(indices, promote_type(T, typeof(x)))
                set!(new_indices, x)
                return __distinct!(new_indices, itr, s, x)
            end
            set!(indices, x)
            x_old = x
        end
        tmp = iterate(itr, s)
    end
    return indices
end

function randtoken(rng::Random.AbstractRNG, inds::Indices)
    if length(inds) == 0
        throw(ArgumentError("collection must be non-empty"))
    end

    if inds.holes === 0
        return (0, rand(rng, Base.OneTo(length(inds))))
    end

    # Rejection sampling to handle deleted tokens (which are sparse)
    range = Base.OneTo(length(_hashes(inds)))
    @inbounds while true
        i = rand(rng, range)
        if inds.hashes[i] !== deletion_mask
            return (0, i)
        end
    end
end

function Base.sort!(inds::Indices; kwargs...)
    if inds.holes != 0
        rehash!(inds, length(inds.slots))
    end
    perm = sortperm(inds.values; kwargs...)
    inds.values = @inbounds inds.values[perm]
    inds.hashes = @inbounds inds.hashes[perm]
    @inbounds for i in keys(inds.slots)
        s = inds.slots[i]
        if s > 0
            inds.slots[i] = perm[s]
        end
    end
    return inds
end

Base.sortperm(inds::AbstractIndices; kwargs...) = sort(inds; kwargs...)

## Scalar indexing (and related) conversion helpers

# getting
@propagate_inbounds function Base.getindex(d::AbstractDictionary{I}, i) where {I}
	return d[convert(I, i)]
end

@propagate_inbounds function Base.setindex!(d::AbstractDictionary{I}, v, i) where {I}
    # Should we do a `isequal` check here?
    return setindex!(d, v, convert(I, i))
end

# setting
@propagate_inbounds function Base.setindex!(d::AbstractDictionary{I, T}, v, i::I) where {I, T}
    return setindex!(d, convert(T, v), i)
end

## `get` helper function
@propagate_inbounds function Base.get(d::AbstractDictionary, i, default)
    (hasindex, t) = gettoken(d, i)
    if hasindex
        return gettokenvalue(d, t)
    else
        return default
    end
end

@propagate_inbounds function Base.get(f::Base.Callable, d::AbstractDictionary, i)
    (hasindex, t) = gettoken(d, i)
    if hasindex
        return gettokenvalue(d, t)
    else
        return f()
    end
end

## getproperty is equivalent to indexing with a `Symbol`

# @propagate_inbounds Base.getproperty(d::AbstractDictionary, s::Symbol) = d[s]
# @propagate_inbounds function Base.setproperty!(d::AbstractDictionary, s::Symbol, x)
#     d[s] = x
#     return x
# end

## Non-scalar indexing

# Basically, getindices maps the indices over the indexee
@inline function Indexing.getindices(d, inds::AbstractDictionary)
    @boundscheck checkindices(keys(d), inds)
    return map(i -> @inbounds(d[i]), inds)
end

@inline function Indexing.setindices!(d, value, inds::AbstractDictionary)
    @boundscheck checkindices(keys(d), inds)
    foreach(i -> @inbounds(d[i] = value), inds)
    return d
end

@inline function Indexing.getindices(inds1::AbstractIndices, inds2::AbstractIndices)
    @boundscheck checkindices(inds1, inds2)
    return inds2 # TODO should this be a `copy`, perhaps? The output shouldn't alias inds1, but what about inds2?
end

## Views

struct DictionaryView{I, V, Inds <: AbstractDictionary{I}, Vals <: AbstractDictionary{<:Any, V}} <: AbstractDictionary{I, V}
    inds::Inds
    vals::Vals
end

Base.parent(d::DictionaryView) = getfield(d, :vals)
_inds(d::DictionaryView) = getfield(d, :inds)

Base.keys(d::DictionaryView) = keys(_inds(d))

function Base.isassigned(d::DictionaryView{I}, i::I) where {I}
    i2 = @inbounds _inds(d)[i]
    return isassigned(parent(d), i2)
end

@propagate_inbounds function Base.getindex(d::DictionaryView{I}, i::I) where {I}
    i2 = _inds(d)[i]
    return @inbounds parent(d)[i2]
end

@propagate_inbounds function Base.setindex!(d::DictionaryView{I, T}, value::T, i::I) where {I, T}
    i2 = _inds(d)[i]
    return @inbounds parent(d)[i2] = value
end

# `DictionaryView` shares tokens with it's `keys` (and can co-iterate quickly with other dictionaries with those keys)
@propagate_inbounds function gettoken(d::DictionaryView, i)
    return gettoken(_inds(d), i)
end

@propagate_inbounds function istokenassigned(d::DictionaryView, t)
    i2 = gettokenvalue(_inds(d), t)
    return isassigned(parent(d), i2)
end

@propagate_inbounds function gettokenvalue(d::DictionaryView, t)
    i2 = gettokenvalue(_inds(d), t)
    return @inbounds parent(d)[i2]
end

@propagate_inbounds function settokenvalue!(d::DictionaryView{<:Any, T}, t, value::T) where {T}
    i2 = gettokenvalue(_inds(d), t)
    return @inbounds parent(d)[i2] = value
end

@inline function Base.view(vals::AbstractDictionary, inds::AbstractDictionary)
    @boundscheck checkindices(keys(vals), inds)

    return DictionaryView{keytype(inds), eltype(vals), typeof(inds), typeof(vals)}(inds, vals)
end

@inline function Base.view(inds1::AbstractIndices, inds2::AbstractIndices)
    @boundscheck checkindices(inds1, inds2)
    return inds2
end

# TODO accelerate view(::Union{Dictionary, Indices}, ::Indices) to fetch not compute the intermediate `hash`
# (similarly a sort-based index could take advantage of sort-merge algorithms on iteration?)

module Dictionaries

using Random
using Indexing
using Base: @propagate_inbounds, Callable
using Serialization: Serialization, deserialize, serialize, serialize_type, AbstractSerializer, handle_deserialize, UNDEFREF_TAG

export getindices, setindices!

export AbstractDictionary, AbstractIndices, IndexError, ArrayIndices, Indices, Dictionary, ArrayDictionary, MappedDictionary, ReverseIndices, ReverseDictionary, DictionaryView, FilteredDictionary, FilteredIndices, BroadcastedDictionary, FillDictionary, UnorderedIndices, UnorderedDictionary

export dictionary, index, distinct, disjoint, isdictequal, filterview, sortkeys, sortpairs, sortkeys!, sortpairs!
export issettable, isinsertable, set!, setwith!, unset!
export istokenizable, tokentype, tokens, tokenized, gettoken, gettokenvalue, istokenassigned, settokenvalue!, gettoken!, deletetoken!, sharetokens

include("AbstractDictionary.jl")
include("AbstractIndices.jl")

include("tokens.jl")
include("indexing.jl")
include("insertion.jl")
include("reverse.jl")
include("filter.jl")
include("foreach.jl")
include("map.jl")
include("broadcast.jl")
include("find.jl")
include("show.jl")
include("pairs.jl")

include("ArrayIndices.jl")
include("ArrayDictionary.jl")
include("Indices.jl")
include("Dictionary.jl")
include("UnorderedIndices.jl")
include("UnorderedDictionary.jl")
include("FillDictionary.jl")

Base.@deprecate_binding HashIndices Indices true
Base.@deprecate_binding HashDictionary Dictionary true

end # module

# # TODO
#
# * Improved printing - don't calculate length (beyond some cutoff) if it is `SizeUnknown` and limit=true, fix indentiation problems for wider values
# * TODO: have `delete!` return next key, `deletetoken!` return next token.
#   For these kinds of algorithms, probably need: firstindex, firsttoken, nextind, prevind,
#   nexttoken, prevtoken, lastindex, lasttoken.
# * More operations for "ordered" indices/sets (sort-based dictionaries and
#   B-trees). We can probably formalize an interface around a trait here. Certain operations
#   like slicing out an interval or performing a sort-merge co-iteration for `merge` become
#   feasible.

@testset "reverse" begin
    @testset "indices" begin
        inds = Indices([1,2,3])

        @test first(inds) == 1
        @test firstindex(inds) == 1
        @test last(inds) == 3
        @test lastindex(inds) == 3

        @test reverse(inds)::Indices == Indices([3, 2, 1])
        @test Iterators.reverse(inds)::ReverseIndices == Indices([3, 2, 1])

        @test reverse(convert(ArrayIndices, inds))::ArrayIndices == Indices([3, 2, 1])
        @test Iterators.reverse(convert(ArrayIndices, inds))::ReverseIndices == Indices([3, 2, 1])
    end

    @testset "dictionaries" begin
        d = Dictionary([:a, :b], [1, 2])
        rd = Dictionary([:b, :a], [2, 1])

        @test reverse(d)::Dictionary == rd
        @test Iterators.reverse(d)::ReverseDictionary == rd

        @test reverse(ArrayDictionary(d))::ArrayDictionary == rd
        @test Iterators.reverse(ArrayDictionary(d))::ReverseDictionary == rd

        @test first(d) == 1
        @test last(d) == 2
        @test firstindex(d) == :a
        @test lastindex(d) == :b
        #@test d[begin] == 1 # Parsing issues on earlier versions of Julia...
        @test d[end] == 2
    end
end

"""
    ArrayDictionary(indices, values)

Construct an `ArrayDictionary <: AbstractDictionary` from two arbitrary Julia iterables, one
specifying the `indices` and one specifying the `values`. Lookup uses naive iteration.

If `indices` and `values` are `Vector`s, then the result is `isinsertable` and
`istokenizable`, making simple and flexible dictionaries using naive search that may be
optimal for small collections.
"""
struct ArrayDictionary{I, T, Inds <: ArrayIndices{I}, Vals <: AbstractArray{T}} <: AbstractDictionary{I, T}
    indices::Inds
    values::Vals
    
    @inline function ArrayDictionary{I, T, Indices, Values}(indices::Indices, values::Values) where {I, T, Indices <: ArrayIndices{I}, Values <: AbstractArray{T}}
        @boundscheck if LinearIndices(parent(indices)) != LinearIndices(values)
            error("Dictionary indices and values inputs do not match")
        end
        return new(indices, values)
    end
end

"""
    ArrayDictionary{I,T}()

Construct an `ArrayDictionary` from empty `Vector`s, with `I` and `T` default to `Any`.
"""
@propagate_inbounds ArrayDictionary() = ArrayDictionary{Any, Any}([], [])
@propagate_inbounds ArrayDictionary{I}() where {I} = ArrayDictionary{I, Any}(I[], [])
@propagate_inbounds ArrayDictionary{I, T}() where {I, T} = ArrayDictionary{I, T}(I[], T[])
@propagate_inbounds ArrayDictionary{I, T, Inds, Vals}() where {I, T, Inds, Vals} = ArrayDictionary{I, T, Inds, Vals}(Inds(), Vals())

@propagate_inbounds ArrayDictionary(inds, vals) = ArrayDictionary(ArrayIndices(inds), vals)
@propagate_inbounds ArrayDictionary{I}(inds, vals) where {I} = ArrayDictionary{I}(ArrayIndices{I}(inds), vals)
@propagate_inbounds ArrayDictionary{I, T}(inds, vals) where {I, T} = ArrayDictionary{I, T}(ArrayIndices{I}(inds), vals)

@propagate_inbounds ArrayDictionary(inds::ArrayIndices, vals) = ArrayDictionary(inds, collect(vals))
@propagate_inbounds ArrayDictionary{I}(inds::ArrayIndices{I}, vals) where {I} = ArrayDictionary{I}(inds, collect(vals))
@propagate_inbounds ArrayDictionary{I, T}(inds::ArrayIndices{I}, vals) where {I, T} = ArrayDictionary{I, T}(inds, collect(T, vals))

@propagate_inbounds ArrayDictionary(inds::ArrayIndices, vals::AbstractArray) = ArrayDictionary{eltype(inds), eltype(vals)}(inds, vals)
@propagate_inbounds ArrayDictionary{I}(inds::ArrayIndices{I}, vals::AbstractArray) where {I} = ArrayDictionary{I, eltype(vals)}(inds, vals)

@propagate_inbounds ArrayDictionary{I,T}(inds::ArrayIndices{I}, vals::AbstractArray) where {I,T} = ArrayDictionary{I,T}(inds, convert(AbstractArray{T}, vals))
@propagate_inbounds ArrayDictionary{I,T}(inds::ArrayIndices{I}, vals::AbstractArray{T}) where {I,T} = ArrayDictionary{I,T,typeof(inds),typeof(vals)}(inds, vals)

@propagate_inbounds ArrayDictionary{I,T,Inds,Vals}(inds::AbstractArray, vals::AbstractArray{T}) where {I,T,Inds,Vals} = ArrayDictionary{I,T,Inds,Vals}(Inds(inds), vals)

"""
    ArrayDictionary(indices, undef::UndefInitializer)

Construct a `ArrayDictionary` from an iterable of `indices`, where the values are
undefined/uninitialized.
"""
@propagate_inbounds ArrayDictionary{I, T}(inds, ::UndefInitializer) where {I, T} = ArrayDictionary{I, T}(ArrayIndices{I}(inds), undef)
@propagate_inbounds ArrayDictionary{I, T}(inds::ArrayIndices{I}, ::UndefInitializer) where {I, T} = ArrayDictionary{I, T}(inds, similar(parent(inds), T))

"""
    ArrayDictionary(indexable)

Construct a `ArrayDictionary` from an indexable container `indexable` with the same `keys` and
`values`, equivalent to `ArrayDictionary(keys(indexable), values(indexable))`. Note that
`indexable` may not be copied.
"""
ArrayDictionary(indexable) = ArrayDictionary(keys(indexable), values(indexable))
ArrayDictionary{I}(indexable) where {I} = ArrayDictionary{I}(keys(indexable), values(indexable))
ArrayDictionary{I, T}(indexable) where {I, T} = ArrayDictionary{I, T}(keys(indexable), values(indexable))

ArrayDictionary{I, T}(indexable::ArrayDictionary) where {I, T} = ArrayDictionary{I, T, ArrayIndices{I}, Vector{T}}(convert(ArrayIndices{I}, keys(indexable)), convert(Vector{T}, indexable.values))

Base.parent(d::ArrayDictionary) = getfield(d, :values)

function Base.keys(d::ArrayDictionary{I}) where {I}
    return getfield(d, :indices)
end

# token interface
istokenizable(::ArrayDictionary) = true
istokenassigned(d::ArrayDictionary, t::Int) = isassigned(parent(d), t)
@propagate_inbounds gettokenvalue(d::ArrayDictionary, t::Int) = parent(d)[t]

tokenized(dict::ArrayDictionary) = parent(dict)

# settable interface
issettable(::ArrayDictionary) = true # Need an array trait for this...

@propagate_inbounds function settokenvalue!(d::ArrayDictionary{<:Any, T}, t::Int, value::T) where {T}
    parent(d)[t] = value
    return d
end

function Base.similar(inds::ArrayIndices, ::Type{T}) where {T}
    return ArrayDictionary(inds, similar(parent(inds), T))
end

Base.copy(dict::ArrayDictionary) = ArrayDictionary(copy(dict.indices), copy(dict.values))

# insertable interface
isinsertable(::ArrayDictionary) = true # Need an array trait for this...

@propagate_inbounds function gettoken!(d::ArrayDictionary{I}, i::I) where {I}
    gettoken!(keys(d), i, (parent(d),))
end

@propagate_inbounds function deletetoken!(d::ArrayDictionary, t::Int)
    deletetoken!(keys(d), t)
    deleteat!(parent(d), t)
    return d
end

function Base.empty!(d::ArrayDictionary)
    empty!(keys(d), (parent(d),))
    return d
end

empty_type(::Type{<:ArrayDictionary}, ::Type{I}, ::Type{T}) where {I, T} = ArrayDictionary{I, T, ArrayIndices{I, Vector{I}}, Vector{T}}
empty_type(::Type{<:ArrayIndices}, ::Type{I}, ::Type{T}) where {I, T} = ArrayDictionary{I, T, ArrayIndices{I, Vector{I}}, Vector{T}}

function Base.sort!(dict::ArrayDictionary; kwargs...)
    perm = sortperm(dict.values; kwargs...)
    permute!(dict.values, perm)
    permute!(keys(dict).inds, perm)
    return dict
end

function sortkeys!(dict::ArrayDictionary; kwargs...)
    perm = sortperm(keys(dict).inds; kwargs...)
    permute!(dict.values, perm)
    permute!(keys(dict).inds, perm)
    return dict
end

function sortpairs!(dict::ArrayDictionary; by = identity, kwargs...)
    inds = keys(dict).inds
    vals = dict.values
    perm = sortperm(keys(dict.values); by = i -> by(@inbounds(inds[i]) => @inbounds(vals[i])), kwargs...)
    permute!(dict.values, perm)
    permute!(inds, perm)
    return dict
end

# TODO docstring
struct PairDictionary{I, T, D <: AbstractDictionary{I, T}} <: AbstractDictionary{I, Pair{I, T}}
    d::D
end

"""
    pairs(dict::AbstractDictionary)

Return a new dictionary, wrapping `dict`, that shares the same `keys` but containing
key-value pairs.

# Example

```julia
julia> dict = Dictionary(["a", "b", "c"], [1, 2, 3])
3-element Dictionary{String,Int64}
 "c" │ 3
 "b" │ 2
 "a" │ 1

julia> pairs(dict)
3-element Dictionaries.PairDictionary{String,Int64,Dictionary{String,Int64}}
 "c" │ "c" => 3
 "b" │ "b" => 2
 "a" │ "a" => 1
```
"""
Base.pairs(d::AbstractDictionary) = PairDictionary{keytype(d), eltype(d), typeof(d)}(d)

Base.parent(d::PairDictionary) = getfield(d, :d)
Base.keys(d::PairDictionary) = keys(parent(d))

# Length
Base.IteratorSize(d::PairDictionary) = Base.IteratorSize(parent(d))
Base.length(d::PairDictionary) = Base.length(parent(d))

# Standard interface
@propagate_inbounds Base.getindex(d::PairDictionary{I}, i::I) where {I} = i => parent(d)[i]
Base.isassigned(d::PairDictionary{I}, i::I) where {I} = isassigned(parent(d), i)


# Token interface
@propagate_inbounds gettoken(d::PairDictionary, i) = gettoken(parent(d), i)

@propagate_inbounds function gettokenvalue(pd::PairDictionary, t)
    d = parent(pd)
    gettokenvalue(keys(d), t) => gettokenvalue(d, t)
end

istokenassigned(pd::PairDictionary, t) = istokenassigned(parent(pd), t)

iteratetoken(pd::PairDictionary, s...) = iteratetoken(parent(pd), s...)

# Factories
Base.similar(dict::PairDictionary, ::Type{T}, indices) where {T} = similar(parent(dict), T, indices)
empty_type(::PairDictionary{<:Any, <:Any, D}, ::Type{I}, ::Type{T}) where {I, T, D} = similar(D, I, T)

# findall

function Base.findall(pred::Function, d::AbstractDictionary)
    out = empty(keys(d))
    @inbounds for (i, v) in pairs(d)
        if pred(v)
            insert!(out, i)
        end
    end
    return out
end

# Note this implements Boolean indexing. Compare:
#     array[array_of_bools]
#     getindices(dict, findall(dict_of_bools))
@inline Base.findall(d::AbstractDictionary) = findall(identity, d)

# findfirst

# TODO what do do about findlast, findnext, findprev?
#  * findnext would require us to be able to restart iteration from an index or token
#    (this might be useful even for a hashmap, e.g. if `findall` allocates too much)
#  * findlast and findprev would require thinking about Iterators.reverse

"""
    AbstractDictionary{I, T}

Abstract type for a dictionary between unique indices of type `I` to elements of type `T`.

At minimum, an `AbstractDictionary` must implement:

 * `getindex(::AbstractDictionary{I, T}, ::I) --> T`
 * `isassigned(::AbstractDictionary{I}, ::I) --> Bool`
 * `keys(::AbstractDictionary{I, T}) --> AbstractIndices{I}`

If values can be set/mutated, then an `AbstractDictionary` should implement:

 * `issettable(::AbstractDictionary)` (returning `true`)
 * `setindex!(dict::AbstractDictionary{I, T}, ::T, ::I}` (returning `dict`)

If arbitrary indices can be added to or removed from the dictionary, implement:

 * `isinsertable(::AbstractDictionary)` (returning `true`)
 * `insert!(dict::AbstractDictionary{I, T}, ::I, ::T}` (returning `dict`)
 * `delete!(dict::AbstractDictionary{I, T}, ::I}` (returning `dict`)
"""
abstract type AbstractDictionary{I, T}; end
abstract type AbstractIndices{I} <: AbstractDictionary{I, I}; end

Base.eltype(d::AbstractDictionary) = eltype(typeof(d))
Base.eltype(::Type{<:AbstractDictionary{I, T}}) where {I, T} = T
Base.keytype(d::AbstractDictionary) = keytype(typeof(d))
Base.keytype(::Type{<:AbstractDictionary{I, T}}) where {I, T} = I
Base.valtype(d::AbstractDictionary) = valtype(typeof(d))
Base.valtype(::Type{<:AbstractDictionary{I, T}}) where {I, T} = T

function Base.keys(dict::AbstractDictionary)
    error("Every AbstractDictionary type must define a method for `keys`: $(typeof(dict))")
end

Base.haskey(dict::AbstractDictionary, i) = i in keys(dict)

@propagate_inbounds function Base.getindex(dict::AbstractDictionary{I}, i::I) where {I}
    if !(istokenizable(dict))
        error("Every AbstractDictionary type must define a method for `getindex`: $(typeof(dict))")
    end

    (hastoken, token) = gettoken(dict, i)
    @boundscheck if !hastoken
        throw(IndexError("Dictionary does not contain index: $i"))
    end
    return @inbounds gettokenvalue(dict, token)
end

@inline function Base.iterate(dict::AbstractDictionary{I, T}, s...) where {I, T}
    if istokenizable(dict)
        tmp = iteratetoken(keys(dict), s...)
        tmp === nothing && return nothing
        (t, s2) = tmp
        return (gettokenvalue(dict, t), s2)
    else
        tmp = iterate(keys(dict), s...)
        tmp === nothing && return nothing
        (i, s2) = tmp
        return (@inbounds dict[i], s2)
    end
end

Base.length(d::AbstractDictionary) = length(keys(d))
Base.IteratorSize(d::AbstractDictionary) = Base.IteratorSize(keys(d))
Base.isempty(d::AbstractDictionary) = isempty(keys(d))

Base.checkindex(d::AbstractDictionary{I}, i) where {I} = checkindex(d, convert(I, i))
Base.checkindex(d::AbstractDictionary{I}, i::I) where {I} = checkindex(keys(d), i)

## Comparisons

# dictionaries are isequal if they iterate in the same order
function Base.isequal(d1::AbstractDictionary, d2::AbstractDictionary)
    if d1 === d2
        return true
    end

    if sharetokens(d1, d2)
        @inbounds for t in tokens(d1)
            if !isequal(gettokenvalue(d1, t), gettokenvalue(d2, t))
                return false
            end
        end
        return true
    end

    if length(d1) != length(d2)
        return false
    end

    for (p1, p2) in zip(pairs(d1), pairs(d2))
        if !isequal(p1, p2)
            return false
        end
    end

    return true
end

# The indices must be isequal and the values ==, same ordering
function Base.:(==)(d1::AbstractDictionary, d2::AbstractDictionary)
    out = true

    if sharetokens(d1, d2)
        @inbounds for t in tokens(d1)
            out &= gettokenvalue(d1, t) == gettokenvalue(d2, t)
            if out === false
                return false
            end
        end
        return out
    end

    if length(d1) != length(d2)
        return false
    end

    for ((i1,x1), (i2,x2)) in zip(pairs(d1), pairs(d2))
        if !isequal(i1, i2)
            return false
        end
        out &= x1 == x2 # make sure it works for `missing`
        if out === false
            return false
        end
    end

    return out
end

"""
    isdictequal(d1, d2)

Determine if two dictionaries are equivalent. Dictionaries `d1` and `d2` are equivalent if
`issetequal(keys(d1), keys(d2))` and for each key `i`, `d1[i] == d2[i]`.

Example

```julia
julia> isdictequal(Dictionary(['a','b'],[1,2]), Dictionary(['b','a'],[2,1]))
true

julia> isdictequal(Dictionary(['a','b'],[1,2]), Dictionary(['b','a'],[2,3]))
false

julia> isdictequal(Dictionary(['a','b'],[1,2]), Dictionary(['b','a'],[2,missing]))
missing
```
"""
function isdictequal(d1::AbstractDictionary, d2::AbstractDictionary)
    out = true

    if sharetokens(d1, d2)
        @inbounds for t in tokens(d1)
            out &= gettokenvalue(d1, t) == gettokenvalue(d2, t)
            if out === false
                return false
            end
        end
        return out
    end

    if length(d1) != length(d2)
        return false
    end

    for (i,x1) in pairs(d1)
        (hastoken, t) = gettoken(d2, i)
        if !hastoken
            return false
        end
        out &= x1 == gettokenvalue(d2, t) # make sure it works for `missing`
        if out === false
            return false
        end
    end

    return out
end

# Lexical ordering based on iteration (of pairs - lesser key takes priority over lesser value, as implemented in `cmp(::Pair)`)
function Base.isless(dict1::AbstractDictionary, dict2::AbstractDictionary)
    if sharetokens(dict1, dict2)
        @inbounds for t in tokens(dict1)
            c = cmp(gettokenvalue(dict1, t), gettokenvalue(dict2, t))
            if c == -1
                return true
            elseif c == 1
                return false
            end
        end
        return false # they are isequal
    end

    # We want to iterate... until one is longer than the other (no `zip`)
    pairdict1 = pairs(dict1)
    pairdict2 = pairs(dict2)
    tmp1 = iterate(pairdict1)
    tmp2 = iterate(pairdict2)
    while tmp1 !== nothing
        if tmp2 === nothing
            return false # shorter collections are isless in lexical ordering
        end
        (p1, s1) = tmp1
        (p2, s2) = tmp2
        c = cmp(p1, p2)

        if c == -1
            return true
        elseif c == 1
            return false
        end

        tmp1 = iterate(pairdict1, s1)
        tmp2 = iterate(pairdict2, s2)
    end
    return tmp2 !== nothing # shorter collections are isless in lexical ordering
end

function Base.cmp(dict1::AbstractDictionary, dict2::AbstractDictionary)
    if sharetokens(dict1, dict2)
        @inbounds for t in tokens(dict1)
            c = cmp(gettokenvalue(dict1, t), gettokenvalue(dict2, t))
            if c == -1
                return -1
            elseif c == 1
                return 1
            end
        end
        return 0
    end

    # We want to iterate... until one is longer than the other (no `zip`)
    pairdict1 = pairs(dict1)
    pairdict2 = pairs(dict2)
    tmp1 = iterate(pairdict1)
    tmp2 = iterate(pairdict2)
    while tmp1 !== nothing
        if tmp2 === nothing
            return 1 # shorter collections are isless in lexical ordering
        end
        (p1, s1) = tmp1
        (p2, s2) = tmp2
        c = cmp(p1, p2)

        if c == -1
            return -1
        elseif c == 1
            return 1
        end

        tmp1 = iterate(pairdict1, s1)
        tmp2 = iterate(pairdict2, s2)
    end
    if tmp2 === nothing # shorter collections are isless in lexical ordering
        return 0
    else
        return -1
    end
end

## Hashing

function Base.hash(dict::AbstractDictionary, h::UInt)
    h1 = h
    h2 = h
    for (i, v) in pairs(dict)
        h1 = hash(i, h1)
        h2 = hash(v, h2)
    end

    return hash(hash(UInt === UInt64 ? 0x8955a87bc313a509 : 0xa9cff5d1, h1), h2)
end

## unique returns an Indices

function Base.unique(d::AbstractDictionary)
    out = empty(d, eltype(d)) # an AbstractIndices
    for x in d
        set!(out, x)
    end
    return out
end

function _distinct(f, ::Type{T}, itr) where T
    out = T()
    for x in itr
        i = f(x)
        (hadtoken, token) = gettoken!(out, x)
        if !hadtoken
            @inbounds settokenvalue!(out, token, i)
        end
    end
    return out
end


### Settable interface

"""
    issettable(dict::AbstractDictionary)

Return `true` if the dictionary `dict` obeys the settable interface, or `false` otherwise.

A mutable dictionary is one where the *values* can be modified (but not necessarily the
indices). The mutable interface requires the dictionary to implement:

 * `setindex!(dict::AbstractDictionary{I, T}, value::I, index::T)`

New settable dictionaries are primarily created through the `similar` function (for
uninitialized values), as well as `fill`, `zeros`, `ones`, `trues` and `falses` (for
initialized values).

See also `isinsertable`.
"""
issettable(::AbstractDictionary) = false

function Base.isassigned(dict::AbstractDictionary{I}, i::I) where {I}
    if !(istokenizable(dict))
        error("Every settable AbstractDictionary type must define a method for `isassigned`: $(typeof(dict))")
    end

    (hasindex, token) = gettoken(dict, i)
    if hasindex
        return istokenassigned(dict, token)
    else
        return false
    end
end

@propagate_inbounds function Base.setindex!(dict::AbstractDictionary{I, T}, value::T, i::I) where {I, T}
    if !(istokenizable(dict))
        error("Every settable AbstractDictionary type must define a method for `setindex!`: $(typeof(dict))")
    end

    (hastoken, token) = gettoken(dict, i)
    @boundscheck if !hastoken
        throw(IndexError("Dictionary does not contain index: $i"))
    end
    settokenvalue!(dict, token, value)
    return dict
end

# similar is the primary way to construct an `issettable` dictionary, and allows us to write
# generic "factories" like `fill`, `copy`, `zeros`...

"""
    similar(d::AbstractDictionary, [T=eltype(d)])

Construct a new `issettable` dictionary with identical `keys` as `d` and an element type of
`T`. The initial values are uninitialized/undefined.
"""
Base.similar(d::AbstractDictionary) = similar(keys(d), eltype(d))
Base.similar(d::AbstractDictionary, ::Type{T}) where {T} = similar(keys(d), T)

function Base.similar(indices::AbstractIndices{I}, ::Type{T}) where {I, T}
    return similar(convert(Indices{I}, indices), T)
end

# empty
empty_type(::Type{<:AbstractDictionary}, ::Type{I}, ::Type{T}) where {I, T} = Dictionary{I, T}
Base.empty(dict::AbstractDictionary, ::Type{I}, ::Type{T}) where {I, T} = empty_type(typeof(dict), I, T)()

function Base.merge(d1::AbstractDictionary, others::AbstractDictionary...)
    # Note: need to copy the keys
    K = promote_type(keytype(d1), keytype.(others)...)
    T = promote_type(valtype(d1), valtype.(others)...)
    out = similar(copy(keys(d1), K), T)
    copyto!(out, d1)
    merge!(out, others...)
    return out
end

function Base.mergewith(combiner, d1::AbstractDictionary, others::AbstractDictionary...)
    # Note: need to copy the keys
    K = promote_type(keytype(d1), keytype.(others)...)
    T = promote_op_valtype(combiner, d1, others...)
    out = similar(copy(keys(d1), K), T)
    copyto!(out, d1)
    mergewith!(combiner, out, others...)
    return out
end
promote_op_valtype(combiner, d1::AbstractDictionary{<:Any,T}, others::AbstractDictionary...) where {T} =
    promote_op_valtype(T, combiner, d1, others...)
promote_op_valtype(T::Type, combiner, d1::AbstractDictionary, others::AbstractDictionary...) =
    promote_op_valtype(promote_op_valtype(T, combiner, d1), combiner, others...)
promote_op_valtype(T::Type, combiner, ::AbstractDictionary{<:Any,T´}) where {T´} =
    promote_type(T, T´, Base.promote_op(combiner, T, T´))

# fill! and fill

Base.fill!(d::AbstractDictionary{<:Any, T}, value) where {T} = fill!(d, convert(T, value))
function Base.fill!(d::AbstractDictionary{<:Any, T}, value::T) where {T}
    for t in tokens(d)
        settokenvalue!(d, t, value)
    end
    return d
end

"""
    fill(value, d::AbstractDictionary, [T = typeof(value)])

Construct a new `issettable` dictionary with identical `keys` as `d` and all elements
initialized to `value`.

An element type can optionally be provided, which can be useful for constructing containers
that accept different types of values, for example `fill(d, missing, Union{Missing, Bool})`.
"""
Base.fill(value, d::AbstractDictionary) = fill(value, d, typeof(value))
function Base.fill(value, indices::AbstractDictionary, ::Type{T}) where {T}
    out = similar(keys(indices), T)
    fill!(out, value)
    return out
end

# zeros, ones, falses, trues
Base.zeros(d::AbstractDictionary) = zeros(Float64, d)
Base.zeros(::Type{T}, d::AbstractDictionary) where {T} = fill(zero(T), d, T)

Base.ones(d::AbstractDictionary) = ones(Float64, d)
Base.ones(::Type{T}, d::AbstractDictionary) where {T} = fill(one(T), d, T)

Base.falses(d::AbstractDictionary) = falses(Bool, d)
Base.falses(::Type{T}, d::AbstractDictionary) where {T} = fill(false, d, T) # T could be `Union{Missing, Bool}`, for example

Base.trues(d::AbstractDictionary) = trues(Bool, d)
Base.trues(::Type{T}, d::AbstractDictionary) where {T} = fill(true, d, T) # T could be `Union{Missing, Bool}`, for example

# rand

# Drawing FROM a dictionary requires is to create a `Sampler(rng, dict, Val(1/Inf))` and overload `rand(rng, S)`
function Random.rand(rng::AbstractRNG, dict::AbstractDictionary)
    Random.rand(rng::AbstractRNG, Random.Sampler(rng, dict, Val(Inf)))
end

function Random.rand(rng::AbstractRNG, s::Random.SamplerTrivial{<:AbstractDictionary})
    dict = s[]
    inds = keys(dict)
    t = randtoken(rng, inds)
    return @inbounds gettokenvalue(dict, t)
end

# Creating a random dictionary

function Random.rand!(dict::AbstractDictionary; S = Random.Sampler(Random.GLOBAL_RNG, eltype(dict), Val(1)))
    map!(() -> rand(Random.GLOBAL_RNG, S), dict)
    return dict
end

function Random.rand!(rng::AbstractRNG, dict::AbstractDictionary; S = Random.Sampler(rng, eltype(dict), Val(1)))
    map!(() -> rand(rng, S), dict)
    return dict
end

sampletype(::Random.Sampler{T}) where {T} = T

Random.rand(S, dict::AbstractDictionary) = rand(Random.GLOBAL_RNG, S, dict)

function Random.rand(rng::AbstractRNG, S, dict::AbstractDictionary)
    sampler = Random.Sampler(rng, S, Val(Inf))
    out = similar(dict, sampletype(sampler))
    rand!(rng, out, S=sampler)
    return out
end

# randn
Random.randn!(dict::AbstractDictionary) = randn!(Random.GLOBAL_RNG, dict)

function Random.randn!(rng::AbstractRNG, dict::AbstractDictionary)
    map!(() -> randn(rng, eltype(dict)), dict)
    return dict
end

Random.randn(dict::AbstractDictionary) = randn(Random.GLOBAL_RNG, Float64, dict)
Random.randn(::Type{T}, dict::AbstractDictionary) where {T} = randn(Random.GLOBAL_RNG, T, dict)
Random.randn(rng::AbstractRNG, dict::AbstractDictionary) = randn(rng, Float64, dict)

function Random.randn(rng::AbstractRNG, ::Type{T}, dict::AbstractDictionary) where {T}
    out = similar(dict, T)
    randn!(rng, out)
    return out
end


"""
    copy(dict::AbstractDictionary)
    copy(dict::AbstractDictionary, ::Type{T})

Create a shallow copy of the values and keys of `dict`. A new element type `T` can
optionally be specified.
"""
Base.copy(dict::AbstractDictionary) = copy(dict, eltype(dict))
function Base.copy(d::AbstractDictionary, ::Type{T}) where {T}
    out = similar(copy(keys(d)), T)
    copyto!(out, d)
    return out
end

function Base.copyto!(out::AbstractDictionary, d::AbstractDictionary)
    map!(identity, out, d)
end

Base.last(d::AbstractDictionary) = first(Iterators.reverse(d))
Base.firstindex(d::AbstractDictionary) = first(keys(d))
Base.lastindex(d::AbstractDictionary) = first(Iterators.reverse(keys(d)))

"""
    sort(dict::AbstractDictionary; kwargs...)

Return a copy of `dict` sorted by its values. The `kwargs` are the usual ordering options
supported by `sort`.

See also `sort!`, `sortkeys` and `sortpairs`.
"""
function Base.sort(dict::AbstractDictionary{I, T}; kwargs...) where {I, T}
    ks = collect(keys(dict))
    vs = collect(dict)
    perm = sortperm(vs; kwargs...)
    permute!(ks, perm)
    permute!(vs, perm)
    return empty_type(typeof(dict), I, T)(ks, vs)
end

"""
    sortkeys(dict::AbstractDictionary; kwargs...)

Return a copy of `dict` sorted by `keys(dict)`. The `kwargs` are the usual ordering options
supported by `sort`.

See also `sortkeys!`, `sort` and `sortpairs`.
"""
function sortkeys(dict::AbstractDictionary{I, T}; kwargs...) where {I, T}
    ks = collect(keys(dict))
    vs = collect(dict)
    perm = sortperm(ks; kwargs...)
    permute!(ks, perm)
    permute!(vs, perm)
    return empty_type(typeof(dict), I, T)(ks, vs)
end

"""
    sortpairs(dict::AbstractDictionary; kwargs...)

Return a copy of `dict` sorted by `pairs(dict)`. The `kwargs` are the usual ordering options
supported by `sort`.

See also `sortpairs!`,`sort` and `sortkeys`.
"""
function sortpairs(dict::AbstractDictionary{I, T}; kwargs...) where {I, T}
    ks = collect(keys(dict))
    vs = collect(dict)
    ps = collect(pairs(dict))
    perm = sortperm(ps; kwargs...)
    permute!(ks, perm)
    permute!(vs, perm)
    return empty_type(typeof(dict), I, T)(ks, vs)
end

module TupleDictionaries

using Dictionaries
using Base: @propagate_inbounds

export TupleIndices, TupleDictionary

"""
    TupleIndices(iter)

Construct a `TupleIndices <: AbstractIndices` from an arbitrary Julia iterable. Lookup of
elements uses naive iteration.

If `iter` is a `Vector` then the result is `isinsertable` and `istokenizable`, making simple
and flexible indices using naive search that may be optimal for small collections.
"""
struct TupleIndices{I, Inds<:Tuple{Vararg{I}}} <: AbstractIndices{I}
	inds::Inds
end

TupleIndices() = TupleIndices{Union{},Tuple{}}(())
TupleIndices{I}() where {I} = TupleIndices{I,Tuple{}}({})

TupleIndices(t::Tuple{Vararg{I}}) = TupleIndices{eltype(t), typeof(t)}(t) # EltypeUnknown...
TupleIndices{I}(t::Tuple{Vararg{I}}) where {I} = TupleIndices{I, typeof(t)}(t) # There is a corner case where the elements of `iter` might not be of type `I`



# Basic interface
@propagate_inbounds function Base.iterate(i::TupleIndices{I}, state...) where {I}
    # We haven't enforced uniqueness anywhere...
    iterate(i.inds, state...)::Union{Nothing, Tuple{I, Any}}
end

Base.in(i::I, inds::TupleIndices{I}) where {I} = in(i, inds.inds)
function Base.IteratorSize(i::TupleIndices)
    out = Base.IteratorSize(i.inds)
    if out isa Base.HasShape
        return Base.HasLength()
    end
    return out
end
Base.length(i::TupleIndices) = length(i.inds)

end # module

@testset "ArrayIndices" begin
    @test ArrayIndices() isa ArrayIndices{Any}

    inds = ArrayIndices{Int64}()
    @test ArrayIndices{Int64, Vector{Int64}}() == inds

    @test isinsertable(inds)
    @test length(inds) == 0
    @test keys(inds) === inds
    @test isempty(inds)
    @test isequal(copy(inds), inds)
    @test_throws IndexError inds[10]
    @test length(unset!(inds, 10)) == 0
    io = IOBuffer(); print(io, inds); @test String(take!(io)) == "{}"
    io = IOBuffer(); show(io, MIME"text/plain"(), inds); @test String(take!(io)) == "0-element ArrayIndices{Int64, Vector{Int64}}"
    @test_throws IndexError delete!(inds, 10)

    insert!(inds, 10)

    @test length(inds) == 1
    @test keys(inds) === inds
    @test !isempty(inds)
    @test isequal(copy(inds), inds)
    @test inds[10] == 10
    @test_throws IndexError insert!(inds, 10)
    @test length(set!(inds, 10)) == 1
    @test_throws IndexError insert!(inds, 10)
    io = IOBuffer(); print(io, inds); @test String(take!(io)) == "{10}"
    io = IOBuffer(); show(io, MIME"text/plain"(), inds); @test String(take!(io)) == "1-element ArrayIndices{Int64, Vector{Int64}}:\n 10"
    @test !isequal(inds, empty(inds))
    @test isequal(inds, copy(inds))
    @test isempty(empty(inds))

    delete!(inds, 10)

    @test isequal(inds, ArrayIndices{Int64}())
    @test union!(inds, Indices([1,2,3,4])) == Indices([1, 2, 3, 4])
    @test filter!(iseven, inds) == Indices([2, 4])

    empty!(inds)
    for i = 2:2:100
        insert!(inds, i)
    end
    @test issetequal(inds, Indices(2:2:100))
    @test all(in(i, inds) == iseven(i) for i in 2:100)
    @test isempty(empty!(inds))

    @testset "covert" begin
        i = Indices{Int32}([1,2,3])
        ai = ArrayIndices{Int32}([1,2,3])

        @test convert(AbstractIndices{Int32}, ai) === ai
        @test convert(AbstractIndices{Int64}, ai)::ArrayIndices{Int64} == i

        @test convert(ArrayIndices{Int32}, ai) === ai
        @test convert(ArrayIndices{Int64}, ai)::ArrayIndices{Int64} == i
        
        @test convert(ArrayIndices{Int32}, i)::ArrayIndices{Int32} == i
        @test convert(ArrayIndices{Int64}, i)::ArrayIndices{Int64} == i
    end

    @testset "rand" begin
        inds = ArrayIndices(["a", "b", "c", "d", "e"])
        for i = 1:100
            @test rand(inds) in ["a", "b", "c", "d", "e"]
        end
    end

    @testset "sort" begin
        inds = ArrayIndices([1, 5, 2])
        @test sort(inds)::ArrayIndices == ArrayIndices([1, 2, 5])
        @test sort(inds; rev=true)::ArrayIndices == ArrayIndices([5, 2, 1])

        @test sortperm(inds)::ArrayIndices == ArrayIndices([1, 2, 5])
        @test sortperm(inds; rev=true)::ArrayIndices == ArrayIndices([5, 2, 1])
        @test getindices(inds, sortperm(inds))::ArrayIndices == ArrayIndices([1, 2, 5])
        @test getindices(inds, sortperm(inds; rev=true))::ArrayIndices == ArrayIndices([5, 2, 1])

        indscopy = deepcopy(inds)
        sort!(indscopy)
        @test indscopy == ArrayIndices([1, 2, 5])

        indscopy = deepcopy(inds)
        sort!(indscopy; rev=true)
        @test indscopy == ArrayIndices([5, 2, 1])
    end
end

@testset "broadcast" begin
    i = Indices([1,2,3,4,5])

    @test isequal((i .+ 1)::Dictionary, dictionary([1=>2, 2=>3, 3=>4, 4=>5, 5=>6]))
    @test isequal(Base.Broadcast.broadcasted(+, i, 1)::BroadcastedDictionary, dictionary([1=>2, 2=>3, 3=>4, 4=>5, 5=>6]))

    @test isequal((i .+ i)::Dictionary, dictionary([1=>2, 2=>4, 3=>6, 4=>8, 5=>10]))
    @test isequal(Base.Broadcast.broadcasted(+, i, i)::BroadcastedDictionary, dictionary([1=>2, 2=>4, 3=>6, 4=>8, 5=>10]))

    @test isequal((i .+ copy(i))::Dictionary, dictionary([1=>2, 2=>4, 3=>6, 4=>8, 5=>10]))
    @test isequal(Base.Broadcast.broadcasted(+, i, copy(i))::BroadcastedDictionary, dictionary([1=>2, 2=>4, 3=>6, 4=>8, 5=>10]))

    @test_throws IndexError Indices([1,2]) .+ Indices([2,3])

    d = i .+ 1
    
    @test isequal((d .+ 1)::Dictionary, dictionary([1=>3, 2=>4, 3=>5, 4=>6, 5=>7]))
    @test isequal(Base.Broadcast.broadcasted(+, d, 1)::BroadcastedDictionary, dictionary([1=>3, 2=>4, 3=>5, 4=>6, 5=>7]))

    @test isequal((d .+ d)::Dictionary, dictionary([1=>4, 2=>6, 3=>8, 4=>10, 5=>12]))
    @test isequal(Base.Broadcast.broadcasted(+, d, d)::BroadcastedDictionary, dictionary([1=>4, 2=>6, 3=>8, 4=>10, 5=>12]))

    @test isequal((d .+ copy(d))::Dictionary, dictionary([1=>4, 2=>6, 3=>8, 4=>10, 5=>12]))
    @test isequal(Base.Broadcast.broadcasted(+, d, copy(d))::BroadcastedDictionary, dictionary([1=>4, 2=>6, 3=>8, 4=>10, 5=>12]))

    d2 = similar(d)
    d2 .= d .+ d
    @test isequal(d2, dictionary([1=>4, 2=>6, 3=>8, 4=>10, 5=>12]))

    d2 .= 0
    @test isequal(d2, dictionary([1=>0, 2=>0, 3=>0, 4=>0, 5=>0]))

    @test_throws IndexError Dictionary([1,2],[1,2]) .+ Dictionary([2,3],[2,3])
end

# Make `map!` fast if the inputs and output share tokens

function Base.map!(f, out::AbstractDictionary, d::AbstractDictionary, d2::AbstractDictionary, ds::AbstractDictionary...)
    if sharetokens(out, d, d2, ds...)
        for t in tokens(out)
            y = f(@inbounds(gettokenvalue(d, t)), @inbounds(gettokenvalue(d2, t)), map(x -> @inbounds(gettokenvalue(x, t)), ds)...)
            @inbounds settokenvalue!(out, t, y)
        end
    elseif istokenizable(out)
       @boundscheck if !isequal(keys(out), keys(d)) || !isequal(keys(out), keys(d2)) || any(dict -> !isequal(keys(out), keys(dict)), ds)
            throw(IndexError("Indices do not match"))
       end
       for txs in zip(tokens(out), d, d2, ds...)
            t = @inbounds txs[1]
            xs = @inbounds Base.tail(txs)
            y = f(xs...)
            @inbounds settokenvalue!(out, t, y)
       end
    else
        @boundscheck if !isequal(keys(out), keys(d)) || !isequal(keys(out), keys(d2)) || any(dict -> !isequal(keys(out), keys(dict)), ds)
            throw(IndexError("Indices do not match"))
        end 
        for ixs in zip(keys(out), d, d2, ds...)
            i = @inbounds ixs[1]
            xs = @inbounds Base.tail(ixs)
            y = f(xs...)
            @inbounds out[i] = y
        end
    end
    return out
end

# (avoid an _apply for the two-input case)
function Base.map!(f, out::AbstractDictionary, d::AbstractDictionary, d2::AbstractDictionary)
    if sharetokens(out, d, d2)
        for t in tokens(out)
            x = @inbounds gettokenvalue(d, t)
            x2 = @inbounds gettokenvalue(d2, t)
            y = f(x, x2)
            @inbounds settokenvalue!(out, t, y)
        end
    elseif istokenizable(out)
        @boundscheck if !isequal(keys(out), keys(d)) || !isequal(keys(out), keys(d2))
            throw(IndexError("Indices do not match"))
       end
       for (t, x, x2) in zip(tokens(out), d, d2)
            y = f(x, x2)
            @inbounds settokenvalue!(out, t, y)
       end
    else
        @boundscheck if !isequal(keys(out), keys(d)) || !isequal(keys(out), keys(d2))
            throw(IndexError("Indices do not match"))
        end 
        for i in keys(out)
            y = f(@inbounds(d[i]), @inbounds(d2[i]))
            @inbounds out[i] = y
        end
    end
    return out
end

function Base.map!(f, out::AbstractDictionary, d::AbstractDictionary)
    if sharetokens(out, d)
        for t in tokens(out)
            x = @inbounds gettokenvalue(d, t)
            y = f(x)
            @inbounds settokenvalue!(out, t, y)
        end
    elseif istokenizable(out)
       @boundscheck if !isequal(keys(out), keys(d))
            throw(IndexError("Indices do not match"))
       end
       for (t, x) in zip(tokens(out), d)
            y = f(x)
            @inbounds settokenvalue!(out, t, y)
       end
    else
        @boundscheck if !isequal(keys(out), keys(d))
             throw(IndexError("Indices do not match"))
        end
        for (i, x) in zip(keys(out), d)
            y = f(x)
            @inbounds out[i] = y
        end
    end
    return out
end

function Base.map!(f, out::AbstractDictionary)
    if istokenizable(out)
        for t in tokens(out)
            y = f()
            @inbounds settokenvalue!(out, t, y)
        end
    else
        for i in keys(out)
            y = f()
            @inbounds out[i] = y
        end
    end
    return out
end

function Base.map(f, d::AbstractDictionary)
    out = similar(d, Core.Compiler.return_type(f, Tuple{eltype(d)}))
    @inbounds map!(f, out, d)
    return out
end

function Base.map(f, d::AbstractDictionary, ds::AbstractDictionary...)
    out = similar(d, Core.Compiler.return_type(f, Tuple{eltype(d), map(eltype, ds)...}))
    @inbounds map!(f, out, d, ds...)
    return out
end

# Lazy map container

struct MappedDictionary{I, T, F, Maps <: Tuple{AbstractDictionary{<:I}, Vararg{AbstractDictionary{<:I}}}} <: AbstractDictionary{I, T}
    f::F
    dicts::Maps
end

Base.keys(d::MappedDictionary{I}) where {I} = keys(_dicts(d)[1])::AbstractIndices{I}
_dicts(d::MappedDictionary{I}) where {I} = getfield(d, :dicts)
_f(d::MappedDictionary{I}) where {I} = getfield(d, :f)

function Base.isassigned(d::MappedDictionary{I}, i::I) where {I}
    return all(Base.Fix2(isassigned, i), _dicts(d))
end

function Base.isassigned(d::MappedDictionary{I, T, <:Any, <:Tuple{AbstractDictionary{<:I}}}, i::I) where {I, T}
    return isassigned(_dicts(d)[1], i)
end

@propagate_inbounds function Base.getindex(d::MappedDictionary{I, T, <:Any, <:Tuple{AbstractDictionary{<:I}}}, i::I) where {I, T}
    return _f(d)(_dicts(d)[1][i])::T
end

@inline function Base.getindex(d::MappedDictionary{I, T}, i::I) where {I, T}
    @boundscheck checkindex(_dicts(d)[1], i)
    return _f(d)(map(x -> @inbounds(x[i]), _dicts(d))...)::T
end

# TODO FIXME what do about tokens when there is more than one mapped dictionary? For now, we disable them...
istokenizable(d::MappedDictionary) = false
function istokenizable(d::MappedDictionary{I, T, <:Any, <:Tuple{AbstractDictionary{<:I}}}) where {I, T}
    return istokenizable(_dicts(d)[1])
end

@propagate_inbounds function gettokenvalue(d::MappedDictionary{I, T, <:Any, <:Tuple{AbstractDictionary{<:I}}}, t) where {I, T}
    return _f(d)(gettokenvalue(_dicts(d)[1], t))::T
end

function istokenassigned(d::MappedDictionary{I, T, <:Any, <:Tuple{AbstractDictionary{<:I}}}, t) where {I, T}
    return istokenassigned(_dicts(d)[1], t)
end

empty_type(::Type{<:MappedDictionary{<:Any, <:Any, <:Any, <:Tuple{D, Vararg{AbstractDictionary}}}}, ::Type{I}, ::Type{T}) where {I, T, D} = empty_type(D, I, T)

function Iterators.map(f, d::AbstractDictionary)
    I = keytype(d)
    T = Core.Compiler.return_type(f, Tuple{eltype(d)}) # Base normally wouldn't invoke inference for something like this...
    return MappedDictionary{I, T, typeof(f), Tuple{typeof(d)}}(f, (d,))
end

# Each file of the form "bench_$(name).jl" in this directory is `include`d and
# its last statement is assumed to be a `BenchmarkGroup`.  This group is added
# to the top-level group `SUITE` with the `$name` extracted from the file name.

using BenchmarkTools
using DataFrames
using Statistics

const SUITE = BenchmarkGroup()
for file in sort(readdir(@__DIR__))
    if startswith(file, "bench_") && endswith(file, ".jl")
        SUITE[chop(file, head = length("bench_"), tail = length(".jl"))] =
            include(file)
    end
end

tune!(SUITE)
results = run(SUITE; verbose=true, seconds=1)

result_df = DataFrame()
for (group, group_results) in pairs(results)
    for (n, n_results) in pairs(group_results)
        for (benchmark, benchmark_results) in pairs(n_results)
            for (datastructure, datastructure_result) in pairs(benchmark_results)
                push!(result_df, (; group, benchmark, n=parse(Int, n), datastructure, time_mean=mean(datastructure_result.times), time_std = std(datastructure_result.times)))
            end
        end
    end
end

result_df

@testset "ArrayDictionary" begin
    @test ArrayDictionary() isa ArrayDictionary{Any, Any}

    d = ArrayDictionary{Int64, Int64}()

    @test issettable(d)
    @test isinsertable(d)
    @test istokenizable(d)
    @test length(d) == 0
    @test isempty(d)
    @test isempty(keys(d))
    @test isequal(copy(d), d)
    @test_throws IndexError d[10]
    @test get(d, 10, 15) == 15
    @test get(() -> 15, d, 10) == 15
    @test get(d, "10", 15) == 15
    @test get(() -> 15, d, "10") == 15
    @test length(unset!(d, 10)) == 0
    io = IOBuffer(); print(io, d); @test String(take!(io)) == "{}"
    io = IOBuffer(); show(io, MIME"text/plain"(), d); @test String(take!(io)) == "0-element ArrayDictionary{Int64, Int64, ArrayIndices{Int64, Vector{Int64}}, Vector{Int64}}"
    @test_throws IndexError d[10] = 11
    @test_throws IndexError delete!(d, 10)

    insert!(d, 10, 11)

    @test d[10] == 11
    @test haskey(d, 10)
    @test !haskey(d, 100)
    @test get(d, 10, 15) == 11
    @test get(() -> 15, d, 10) == 11
    @test get(d, "10", 15) == 15
    @test get(() -> 15, d, "10") == 15
    @test get!(d, 10, 15) == 11
    @test length(d) == 1
    @test keys(d) === keys(keys(d))
    @test !isempty(d)
    @test isequal(copy(d), d)
    @test_throws IndexError insert!(d, 10, 12)
    @test d[10.0] == 11
    set!(d, 10.0, 12.0)
    @test length(d) == 1
    @test d[10] == 12
    setwith!(+, d, 10.0, 2.0)
    @test length(d) == 1
    @test d[10] == 14
    setwith!(+, d, 2.0, 2.0)
    @test length(d) == 2
    @test d[2] == 2
    delete!(d, 2)
    @test length(d) == 1
    d[10.0] = 13.0
    @test d[10] == 13
    io = IOBuffer(); print(io, d); @test String(take!(io)) == "{10 = 13}"
    io = IOBuffer(); show(io, MIME"text/plain"(), d); @test String(take!(io)) == "1-element ArrayDictionary{Int64, Int64, ArrayIndices{Int64, Vector{Int64}}, Vector{Int64}}:\n 10 │ 13"
    @test !isequal(d, empty(d))
    @test isequal(d, copy(d))
    @test isempty(empty(d))

    delete!(d, 10)
    @test isequal(d, ArrayDictionary{Int64, Int64}())

    @test get!(d, 10, 14) == 14
    @test d[10] == 14
    delete!(d, 10)
    
    for i = 2:2:100
        insert!(d, i, i+1)
        @test d[i] == i + 1 ? true : (@show i; false)
    end
    @test all(in(i, d) == !iseven(i) for i in 2:2:100)
    @test all(in(i, keys(d)) == iseven(i) for i in 2:2:100)
    @test isempty(empty!(d))

    @testset "rand" begin
        dict = ArrayDictionary(["a", "b", "c", "d", "e"], 1:5)
        for i = 1:100
            @test rand(dict) in 1:5
        end
    end

    @testset "copy" begin
        dict = ArrayDictionary{Int64, String}([1, 2], undef)

        dictcopy = copy(dict)
        @test dict isa ArrayDictionary{Int64, String}
        @test !sharetokens(dict, dictcopy)
        io = IOBuffer(); show(io, MIME"text/plain"(), dict); @test String(take!(io)) == "2-element ArrayDictionary{Int64, String, ArrayIndices{Int64, Vector{Int64}}, Vector{String}}:\n 1 │ #undef\n 2 │ #undef"
        @test all(!isassigned(dict, i) for i in collect(keys(dict)))
        @test all(!isassigned(dictcopy, i) for i in collect(keys(dictcopy)))
        @test sharetokens(dict, ArrayDictionary{Int64, String}(dict))
        @test pairs(dict) isa Dictionaries.PairDictionary{Int64, String}

        dict = ArrayDictionary([1,2,3,4,5], [1,3,2,4,5])
        dictcopy = copy(dict)
        set!(dict, 6, 7)
        @test length(dict) == 6
        @test length(dictcopy) == 5
    end

    @testset "sort" begin
        dict = ArrayDictionary([1, 3, 2], ['c', 'a', 'b'])
        @test sort(dict)::ArrayDictionary == ArrayDictionary([3, 2, 1], ['a', 'b', 'c'])
        @test sort(dict; rev=true)::ArrayDictionary == ArrayDictionary([1, 2, 3], ['c', 'b', 'a'])

        @test sortperm(dict)::ArrayIndices == ArrayIndices([3, 2, 1])
        @test sortperm(dict; rev=true)::ArrayIndices == ArrayIndices([1, 2, 3])
        @test getindices(dict, sortperm(dict))::ArrayDictionary == ArrayDictionary([3, 2, 1], ['a', 'b', 'c'])
        @test getindices(dict, sortperm(dict; rev=true))::ArrayDictionary ==ArrayDictionary([1, 2, 3], ['c', 'b', 'a'])

        @test sortkeys(dict)::ArrayDictionary == ArrayDictionary([1, 2, 3], ['c', 'b', 'a'])
        @test sortkeys(dict; rev=true)::ArrayDictionary == ArrayDictionary([3, 2, 1], ['a', 'b', 'c'])

        @test sortpairs(dict)::ArrayDictionary == ArrayDictionary([1, 2, 3], ['c', 'b', 'a'])
        @test sortpairs(dict; rev=true)::ArrayDictionary == ArrayDictionary([3, 2, 1], ['a', 'b', 'c'])
        @test sortpairs(dict; by=kv->kv.second=>kv.first)::ArrayDictionary == ArrayDictionary([3, 2, 1], ['a', 'b', 'c'])

        dictcopy = deepcopy(dict)
        sort!(dictcopy)
        @test dictcopy == ArrayDictionary([3, 2, 1], ['a', 'b', 'c'])
        
        dictcopy = deepcopy(dict)
        sort!(dictcopy; rev = true)
        @test dictcopy == ArrayDictionary([1, 2, 3], ['c', 'b', 'a'])

        dictcopy = deepcopy(dict)
        sortkeys!(dictcopy)
        @test dictcopy == ArrayDictionary([1, 2, 3], ['c', 'b', 'a'])

        dictcopy = deepcopy(dict)
        sortkeys!(dictcopy; rev = true)
        @test dictcopy == ArrayDictionary([3, 2, 1], ['a', 'b', 'c'])

        dictcopy = deepcopy(dict)
        sortpairs!(dictcopy)
        @test dictcopy == ArrayDictionary([1, 2, 3], ['c', 'b', 'a'])

        dictcopy = deepcopy(dict)
        sortpairs!(dictcopy; rev = true)
        @test dictcopy == ArrayDictionary([3, 2, 1], ['a', 'b', 'c'])

        dictcopy = deepcopy(dict)
        sortpairs!(dictcopy; by = kv->kv.second=>kv.first)
        @test dictcopy == ArrayDictionary([3, 2, 1], ['a', 'b', 'c'])
    end
end

# Simple "print"-like rendering, use "{ ... }" brackets for compactness
function Base.show(io::IO, inds::AbstractIndices)
    limit = get(io, :limit, false) ? Int(10) : typemax(Int)
    comma = false
    print(io, "{")
    for i in inds
        if comma
            print(io, ", ")
        end
        if limit == 0
            print(io, "…")
            break
        end
        show(io, i)
        comma = true
        limit -= 1
    end
    print(io, "}")
end

function Base.show(io::IO, d::AbstractDictionary)
    limit = get(io, :limit, false) ? Int(10) : typemax(Int)
    comma = false
    print(io, "{")
    for i in keys(d)
        if comma
            print(io, ", ")
        end
        if limit == 0
            print(io, "…")
            break
        end
        show(io, i)
        print(io, " = ")
        if isassigned(d, i)
            show(io, d[i])
        else
            print(io, "#undef")
        end
        comma = true
        limit -= 1
    end
    print(io, "}")
end

# The "display"-like rendering
function Base.show(io::IO, ::MIME"text/plain", d::AbstractIndices)
    if isempty(d)
        print(io, "0-element $(typeof(d))")
        return
    end

    # Designed to be efficient for very large sets of unknown lengths

    n_lines = max(Int(3), get(io, :limit, false) ? Int(displaysize(io)[1] - 4) : typemax(Int))
    n_cols = max(Int(2), get(io, :limit, false) ? Int(displaysize(io)[2] - 1) : typemax(Int))
    n_lines_top = n_lines ÷ Int(2)
    n_lines_bottom = n_lines - n_lines_top

    # First we collect strings of all the relevant elements
    top_ind_strs = Vector{String}()
    bottom_ind_strs = Vector{String}()

    top_lines = Int(1)
    top_full = false
    top_last_index = Base.RefValue{keytype(d)}()
    for i in keys(d)
        push!(top_ind_strs, sprint(show, i, context = io, sizehint = 0))
        top_lines += 1
        if top_lines > n_lines_top
            top_full = true
            top_last_index[] = i
            break
        end
    end

    bottom_lines = Int(1)
    bottom_full = false
    if top_full
        for i in Iterators.reverse(keys(d))
            if bottom_full
                if isequal(i, top_last_index[])
                    bottom_full = false # override this, we don't need the ⋮
                else
                    bottom_ind_strs[end] = "⋮"
                end
                break
            end

            if isequal(i, top_last_index[])
                # Already rendered, we are finished
                break
            end

            push!(bottom_ind_strs, sprint(show, i, context = io, sizehint = 0))
            bottom_lines += 1
            if bottom_lines > n_lines_bottom
                bottom_full = true
                # We check the next element to see if this one should be a ⋮
            end
        end
        ind_strs = vcat(top_ind_strs, reverse(bottom_ind_strs))
    else
        ind_strs = top_ind_strs
    end

    if Base.IteratorSize(d) === Base.SizeUnknown()
        if bottom_full
            print(io, "Greater than $(length(ind_strs))-element $(typeof(d)):")
        else
            print(io, "$(length(ind_strs))-element $(typeof(d)):")
        end
    else
        summary(io, d)
        print(io, ":")
    end

    # Now find padding sizes
    max_ind_width = maximum(textwidth, ind_strs)
    if max_ind_width + 1 > n_cols
        shrink_to!(ind_strs, n_cols)
    end

    for ind_str in ind_strs
        print(io, "\n ")
        print(io, ind_str)
    end
end

# The "display"-like rendering
function Base.show(io::IO, ::MIME"text/plain", d::AbstractDictionary)
    if isempty(d)
        print(io, "0-element $(typeof(d))")
        return
    end

    # Designed to be efficient for very large sets of unknown lengths

    n_lines = max(Int(3), get(io, :limit, false) ? Int(displaysize(io)[1] - 4) : typemax(Int))
    n_cols = max(Int(8), get(io, :limit, false) ? Int(displaysize(io)[2] - 4) : typemax(Int))
    n_lines_top = n_lines ÷ Int(2)
    n_lines_bottom = n_lines - n_lines_top

    # First we collect strings of all the relevant elements
    top_ind_strs = Vector{String}()
    top_val_strs = Vector{String}()
    bottom_val_strs = Vector{String}()
    bottom_ind_strs = Vector{String}()

    top_lines = Int(1)
    top_full = false
    top_last_index = Base.RefValue{keytype(d)}()
    for i in keys(d)
        push!(top_ind_strs, sprint(show, i, context = io, sizehint = 0))
        if isassigned(d, i)
            push!(top_val_strs, sprint(show, d[i], context = io, sizehint = 0))
        else
            push!(top_val_strs, "#undef")
        end
        top_lines += 1
        if top_lines > n_lines_top
            top_full = true
            top_last_index[] = i
            break
        end
    end

    bottom_lines = Int(1)
    bottom_full = false
    if top_full
        for i in Iterators.reverse(keys(d))
            if bottom_full
                if isequal(i, top_last_index[])
                    bottom_full = false # override this, we don't need the ⋮
                else
                    bottom_ind_strs[end] = "⋮"
                    bottom_val_strs[end] = "⋮"
                end
                break
            end

            if isequal(i, top_last_index[])
                # Already rendered, we are finished
                break
            end

            push!(bottom_ind_strs, sprint(show, i, context = io, sizehint = 0))
            if isassigned(d, i)
                push!(bottom_val_strs, sprint(show, d[i], context = io, sizehint = 0))
            else
                push!(bottom_val_strs, "#undef")
            end

            bottom_lines += 1
            if bottom_lines > n_lines_bottom
                bottom_full = true
                # We check the next element to see if this one should be a ⋮
            end
        end
        ind_strs = vcat(top_ind_strs, reverse(bottom_ind_strs))
        val_strs = vcat(top_val_strs, reverse(bottom_val_strs))
    else
        ind_strs = top_ind_strs
        val_strs = top_val_strs
    end

    if Base.IteratorSize(d) === Base.SizeUnknown()
        if bottom_full
            print(io, "Greater than $(length(ind_strs))-element $(typeof(d)):")
        else
            print(io, "$(length(ind_strs))-element $(typeof(d)):")
        end
    else
        summary(io, d)
        print(io, ":")
    end

    # Now find padding sizes
    max_ind_width = maximum(textwidth, ind_strs)
    max_val_width = maximum(textwidth, val_strs)
    if max_ind_width + max_val_width > n_cols
        val_width = max_val_width
        ind_width = max_ind_width
        while ind_width + val_width > n_cols
            if ind_width > val_width 
                ind_width -= 1
            else 
                val_width -= 1
            end
        end
        if ind_width != max_ind_width
            shrink_to!(ind_strs, ind_width)
        end
        if val_width != max_val_width
            shrink_to!(val_strs, val_width)
        end
    else
        ind_width = max_ind_width
    end

    for (ind_str, val_str) in zip(ind_strs, val_strs)
        print(io, "\n ")
        print(io, " " ^ max(0, ind_width - textwidth(ind_str)))
        print(io, ind_str)
        print(io, " │ ")
        print(io, val_str)
    end
end

function shrink_to!(strs, width)
    @static if VERSION >= v"1.9"
      strs .= Base._truncate_at_width_or_chars.(true, strs, width)
    else
      strs .= Base._truncate_at_width_or_chars.(strs, width)
    end
end

Base.summary(io::IO, dict::AbstractDictionary) = dict_summary(io, dict)

function dict_summary(io::IO, dict)
    if Base.IteratorSize(dict) === Base.SizeUnknown()
        print(io, typeof(dict))
    else
        print(io, length(dict), "-element ", typeof(dict))
    end
end

# TODO fix `repr`
